ChangeLog for 2.53.1

//Beta 55
Updated allegro to v4.4.4
Added a special colour (teal) to water combos when drowning is off
	when viewing combo solidity. 
	( ZoriaRPG, 16th October, 2020 )

//Beta 54
Fix Linux Console
	( ZoriaRPG, 19th September, 2020 )

//Beta 53

<Classic.zh 1.13> Fixed an identifier error that prevented compiling.
	( ZoriaRPG, 6th September, 2020 )
	
Add forced NULL terminator to pointers passed to TraceS(),
	to prevent crashes in the event that the user passes
	an ZScript client array w/o a NULL terminator.
	( ZoriaRPG, 6th September, 2020 )

Added 'Snap to Grid' to FFC Right Click contextual menu.
	( ZoriaRPG, 5th September, 2020 )
	
Raised max deaths count from 999 to 65535. 
	Requested by zcfan27330 on AGN as he hit 999 deaths in Gleeok's 6th.
	( ZoriaRPG, 4th September, 2020 )

//Beta 52
	
Added Quest->Rules->Pick Ruleset to ZQ menus.
	( ZoriaRPG, 2nd September, 2020 )
	
Updated classic.zh to v 1.12. The 'ChangeRoomGuy' script now
	ignores NPC_FIRE.
	( ZoriaRPG, 14th August, 2020 )
	
<std 1.5013> 
	Added sanity guard on SetLayerCombo/GetLayerCombo functions.
	These now check to ensure that the layer is configured.
	( ZoriaRPG, 7th August, 2020 )
	
Rewrote the MIDI Patch Fix to work properly on modern (Post-XP) Windows.
	( ZoriaRPG, 2nd August, 2020 )
	
Added Fullsceen confirmation warning, backported from 2.55.
	( ZoriaRPG, 25th July, 2020 )
	
Fixed error messages for invald GOTO type instructions.
	( ZoriaRPG, 9th July, 2020 )
	
Fixed possible crash on invalid gotos from logging args order.
	( ZoriaRPG, 7th July, 2020 )
	
Epilepsy Protection is now set when you launch a NEW INSTALL of ZC,
immediately prior to loaing the player interface.
	If the zc.cfg value 'checked_epilepsy' is not present, or is set 
	to '0', then ZC will ask the user if they want this enabled
	and set this config value so that it is not re-checked:
		1. If there is no valid .sav file, then this will appear prior
		   to the .sa file creation dialogue. 
		2. If a .sav file exists, this will occur prior to the title
		   screen, if the config int 'checked_epilepsy' is not present
		   or is set to 0 in zc.cfg.
		3. If 'checked_epilepsy' is in zc.cfg and is set to '1', then
		   this dilogue will not open, and the user's epilepsy protection
		   settings are used as normal.
		4. The dialogue defaults to NO. 
Reduced the amplitude of screen wave effects when epilepsy protection is enabled.
	( ZoriaRPG, 17th June, 2020 )

Added a ZQE hotkey for '?' that opens the version info display.
	( ZoriaRPG, 13th June, 2020 )

Added an emulation flag '2.10 Hammer Upward Reach' that extends
	the vertical reach of the Hamer weapon by four pixels 
	when the player is facing up. 
	This is automatically enabled for 2.10 and earlier quests. 
	( ZoriaRPG, 12th June, 2020 )

Implemented a request from ShadowTiger, whereby when you edit a
	DMap, and select a map tile, when you go to edit further
	DMap map tiles within the same session, the DMap editor will
	remember the last tile that you used. 
	This will clear on loading any quest, but it remains static
	while working on a quest in memory, updating each time that
	the user selects a different tile in this editor. 
	( ZoriaRPG, 11th June, 2020 )

Header Guard for the ZScript compiler is now defaulted to off. 
Added the following configs to ZQuest:
	PreFillTileEditorPage = (0|1)
	If set to 1, the page field of the Goto Page dialogue in 
		the Tile Editor will be populated with the current page.
	If set to 0, the page field of the Goto Page dialogue in 
		the Tile Editor will be populated '0', as was always
		the case in the past.
	If unset, the default value for this config is '0'.
	
	PreFillComboEditorPage = (0|1)
	If set to 1, the page field of the Goto Page dialogue in 
		the Combo Page Editor will be populated with the current page,
		as was always the case in the past..
	If set to 0, the page field of the Goto Page dialogue in 
		the Combo Page Editor will be populated '0', like the prior 
		behaviour of the Tile Editor's Goto Page function.
	If unset, the default value for this config is '0'.
	
	PreFillMapTilePage = (0|1)
	Reserved for a feature request regarding the DMap Editor, when setting
		Map Tile values for DMaps.
		The desired outcome is that, if set to '1', that the DMap editor will
		memorise the last used tile page when selecting Map Tiles.
		The internal ZQE global variable 'DMapEditorLastMaptileUsed' is 
		reserved for this purpose.
	
	( ZoriaRPG, 10th June, 2020 )

Don't allow taking ZC GUI snapshot, with menu open, with wonky colours.
	Use only the tre screen colour with shaded effect.
ZC GUI snapshot (Shift+F12) uses correct ame colours, as long as the
	menu isn't active.
Added a way to detect if the system menu is open (bool MenuOpen).
	This is enabled and disabled exclusively in System() and
	writing to it elsewhere is **unefined**. 
	In theory, alt+tab could call System() to force-pause ZC Player,
	but win32.cpp cannot access System() during its callbacks.
Allow taking a screenshot in ZC that shows the subscreen area
	when the NOSUBSCREEN flag is enabled, by holding the
	ALT key when taking the snapshot.
Preserve the quest colours when taking a GUI snapshot in ZC Player
	unless the user holds the CONTROL key when taking the snapshot.
Fixed a crash reported by ywkls,that when trying to use the
	tile grabber on .qst and .qsu files, where the tile 
	grabber would allow the user to scroll outside the 
	bounds of the .qst tile buffer. 
	It is now clamped to MAXTILEROWS.
	( ZoriaRPG, 6th June, 2020 )
	
//Beta 51
Te old water emulation flag is now enabled whenever loading a quest 
	oolder than 2.50. 
	( ZoriaRPG, 4th June, 2020 )
	
Added 'Old 2.10 Water' emulation to ZC Player.
	This is intended as a patch for old 2.10 quests that have
	very-specific water combo placement where you are expected
	to use the ladder (while you have the flippers), but the flippers
	engage.
	( ZoriaRPG, 26th May, 2020 )

//Beta 50
Try to properly initialise directItem and directItemA.
	( ZoriaRPG, 23rd May, 2020 )
	
//Beta 49
Slight changes to the directItem init when loading quests, that
	now checks if the prior quest was a B+A subscreen type. 
	( ZoriaRPG, 23rd May, 2020 )

//Beta 48
Fixed a memory leak when compiling scripts and exiting out of
	the assign scripts dialogue with Cancel.
	( ZoriaRPG, 16th May, 2020 )

//Beta 47 
Added sanity guard to inline bool get_item(int id).
	( ZoriaRPG, 12th May, 2020 )

//Beta 46
Fixed possible crash and bad error message for Screen->Combo[] errors.

//Beta 45
Slight timing fix to directItemA, for B-only quests. 
	( ZoriaRPG, 30th April, 2020 )

//Beta 44
You can now press C in the Tile Editor to copy a tile, then
	select a range of tiles and press F to FLOODFILL paste the copied
	tile to every position.
In the Tile Editor, electing multiple tiles, pressing C, 
	then selecting multiple tiles and pressing O will now overlay
	the copied selection tot he dest selection, triming overflow.
Mass Overlay now works properly, overlaying to each tile space, rather
	than overlaying to the first tile and copying the result of that
	overlay to the remaining spaces.
	
//Beta 43
Make default cheat modkeys SHIFT, not CTL+SHIFT.
	( ZoriaRPG, 26th April, 2020 )
	
//Beta 42: The Meaning of Life, the Universe, and Everything.
Added a new Quest Report type: Bugged Next-> Combos.
	This will scan a quest for any Next-> combo type that also has a secret
	flag on it, and report that this may be erroneous. (It is legal to
	place these flags, but they must be EXTERNALLY triggered. They no
	longer trigger when the Next-> combo is activated.)
Added extra sanity guards and reports to Link->Warp, PitWarp, and WarpEx.
	( ZoriaRPG, 22nd April, 2020 )
	
//Beta 41
Intermediate changes included in the 40 and 42 sections to do with Quest Reports.
	
//Beta 40
Fixed a bug where finishing a custom quest advanted to 1st.qst.
Added Game->IncrementQuest().
Backported Rob's fixes for abc list size from 2.55.
	( ZoriaRPG, 19th April, 2020 )

//Beta 39
Backported the Linux console from 2.55 to 2.53.1. 
	( ZoriaRPG, 19th April, 2020 )

//Beta 38
Fixed the initialisation of forced_awpn and forced_bwpn on firstplay.
Fixed a bug where exiting a quest with an A+B subscreen, and starting
	to play a B-only subscreen quest preventing using the A-item.
	( ZoriaRPG, 19th April, 2020 )

//Beta 37
Clear forced_wpn if setting an item slot from the real subscreen.
If the user config for ZC Player speifies a custom SAVEFILE
	filename, and that file is absent, create it. (Don't try creating
	a .sav with a different filename!)
Values set when writing Link->Equipment now write to
	gamedata->forced_awpn and gamedata->forced_bwpn.
	These values are saved with the quest, and restored on load, so
	that the items set to the A/B slots remain corret.
	Witing -1 to an item with Link-Equipment sets gamedata->fored_
		to -1, and if the gamedata strut value is -1, then nothing
		special happens.
	If the values of these gamedata (signed short) variables != -1,
		then calls to update A/B weapon (speific to the non -1 value)
		return early.
	If a forced item is removed from inventory (with a script, or with
		a string), then its forced value is set to -1.
	( ZoriaRPG, 25th March, 2020 )

//Beta 36
Backport ZQ Minimap Enhancements from 2.55
Backported non-rect minimap frame from 2.55.
Backport ZQuest ABCList Options in Settings Dialogue from 2.55
Backport all JWin Enhancements to this date and time from 2.55.
	( ZoriaRPG, 23rd March, 2020 )

Backported updates to JWin abclist procs.
	( Venrob, 23rd March, 2020 )
	
Fix crash in filelisters and optimise abclist_proc.
	( ZoriaRPG, 22nd March, 2020 )

Fix backslash in IMPORTSTRING
	( Venrob, 22nd March, 2020 )

No-matter what colour you set as trans, the unused tile spots in
	the tile editor are now always black with a grey X. They no longer
	use the colour assigned to the 0th index of their cset.
	InvalidStatic mode is unchanged.
ZVersion 0.7.3: Fixed missing lessthan token.
Sort lowest match in ABC List Search and jump to it, not highest.
You can now type more than one character in any alphabetic
	droplist, including file listers. You can press backspace to change
	the current text, and the search term is displayed on the dialogue UI
	panel.
Prior to this change, if the user were to set the 'Use Pal CSet'
	tickbox in the Enemy Editor, they could not un-set it without mucking
	about with the CSet on the tile. This change fixes this issue, and
	un-ticking the box will now revert rhe CSet of the enemy from '14' to '8'.
	( ZoriaRPG, 20th March, 2020 )
	
The emulation option for Old / Bugged Bush->Next+Flag is on by default for 2.50.3 or earlier.
	( ZoriaRPG, 19th March, 2020 )

Add H, S, L Hotkeys (Shift or Control) to Colour Picker
Fix include paths ordering grabbing incorrect files.
File: Unimplemented AST Expressions
	( ZoriaRPG, 9th March, 2020 )

File: Import/Export Hero Sprites
	( ZoriaRPG, 6th March, 2020 )

Updated cset.txt
	( ZoriaRPG, 5th March, 2020 )

Optimize arithmetic in 2.53 parser
	( Venrob, 4th March, 2020 )
	
Optimize comparisons to '0' in 2.53 parser
	( Venrob, 3rd March, 2020 )
	
Updated ZScript.txt
Update Linux Build Requirements List
Added additional PC < 0 check.
Prevent crash, and log issue, on ZASM overflow.
	( ZoriaRPG, 2nd March, 2020 )
	
We now have a viable Linux build environment and preliminary 2.53.1 Linux builds thanks to the trio of 
	Peter Hull, roracle, and ZoriaRPG. Teamwork. 

//Beta 35
Added the .zdoors file type.
	Added Import Doorsets: You can set a desired first destination,
	first source, and count fro the first source. This will load
	doorsets starting at src, ending at src+count, to dest, ending at
	dest+count-1. 
		Overflow beyond the current doorcount is skipped, displaying
		a dialogue that it overflowed. 
	Added Export Doorsets: You can specify a starting doorset, and a 
	count (min 1), exporting doorset 'first' through 'first+count-1'.
	Added a contextual menu to the Edit Door Set list dialogue with 
	the options 'Save' and 'Load'.
		Saving will save that doorset only; while loading loads
		the first doorset from a .zdoors file to the selected index
		of the lister.
	( ZoriaRPG, 2nd March, 2020 )
Fixed crashes with long filenames overflowing the char buffers[]
	on some save and load routines. 
	( ZoriaRPG, 1st March, 2020 )
Fixed issues compiling on Linux/g++.
	( ZoriaRPG, roracle, 27th February, 2020 )

//Beta 34
Fixed a crash when using header guards and also declaring
	constants in the buffer.
	( ZoriaRPG, 16th February, 2020 )

//Beta 33
Disable anti-cheating memory nobfustification to see if it
	is the cause of virus scanner red flags.
Added ASCII Art Logo to Console
Quest [METADATA] is now shown in the console, and I added
	logging for older formats (back to 1.80) along with build, gamma,
	and beta metadata, as much as possible with known variables and the
	available source allows.
Added zprint2(). This ALWAYS prints, with no regard to log level settings, to
	be used for critical metadata displays and special system messages
	such as holiday greetings (e.g. terminal motd).
Added colour console andzprint to Zuest to matchh 2.55.
Added byte __isZQuest to both programmes.
	If the editor is running, it has a value of 1, otherwise 0, so that
	shared functionscan reference this to know which of the two components
	is calling the function.
	( ZoriaRPG, 15th February, 2020 )

//Beta 32
Added Link->Eaten, backported from 2.55.
Init Bwpn andAwpn to 0 on start and on game select.
Added sanity bounds and error logging to Screen->Combo*[pos].
	Assigning an illegal alue, or accessing an inalid
	index will now generate errors instead of crashing ZC.
	( ZoriaRPG, 12th February, 2020 )
	
//Beta 31
Probably fixed clash between tile warp and warp ring dialogues. 
	( ZoriaRPG, 6th February, 2020 )

//Beta 30
Added fire/animation to the new AGN logo. It's done. Please...No more.
	( ZoriaRPG, 4th February, 2020 )

//Beta 29
Added new splash logo theme, by stk13, resequenced into a shorter loop.
	( ZoriaRPG, 4th February, 2020 )
	
Packaged nom-UPD'd bins; added UPX'd bins to ./upx
Fixed title screen copyright years. They are now automated at compilation.
Added new AGN Splash Screen and Audio
	( ZoriaRPG, 3rd February, 2020 )

//Beta 28
Fixed vine tiles in story scroll; updated qst.dat.
	( ZoriaRPG, 1st February, 2020 )

//Beta 27
Disabled a trace on dustpile creation.
	( ZoriaRPG, 30th January, 2020 )
	
All roomtypes now allow a 'Generic Catchall' set via the menus.
	( ZoriaRPG, 27th January, 2020 )

//Beta 26
The Item 2 and Item 3 counters of subscreen objects are intended
	to stack with counter 0, but someone disabled that to prevent stacking
	values with Life at all times.

	I corrected the issue by making '0' for item2 and item3 an ignored
	field.

	Further, if item 2 == item 1, or item 3 == either item1 or item 2,
		then they will not stack. This will prevent having all
		three at the same ID from tripling, or two or more of the same
		ID from doubling the true count.

	Quests saed in versions < 2.53.1 ignore this.
	( ZoriaRPG, 26th January, 2020 )
Fixed an unintentional fallthrough in switch(itemtype) inside subscr.cpp
	where there is a missing break instruction after all script cases.
	Should someone have added anything after those, then script counters
	would fall through to the newly added counter.
	( ZoriaRPG, 26th January, 2020 )

//Beta 25
Experimentally Allow setting all item pickup flags. None are blocked.
	Unblocked some item pickup flags in ffscript.cpp, that were
	blocked--probably by L or Joe123?--until it causes some old quest
	to break. 
	In quests last saved in 2.50.x Build 32 or lower, it remains blocked.
	( ZoriaRPG, 21st January, 2020 )

//Beta 24
Reset combo anims before importing or exporting .ZCOMBO files
	as otherwise they will be corrupted by offsets.
	( ZoriaRPG, 19th January, 2020 )
	
Make ZASM errors for scommand printf format %lu, not %ld.
Fixed the DMap Selection window not drawing a preview or other data.
	The array passed to dlg->dp3 was passing invalid data, but it is hardcoded
	to specific values, so I coded it into the function as 
	nothing else uses this jwin proc type. 
	( ZoriaRPG, 18th January 2020 )

//Beta 23
Made header guards strict to the filename, instead of the
	quotedstring. They are still case-insensitive.
Disabled compiler import/include logging. Re-enable by setting LOGLEVEL
	to '1' in ffscript.ypp.
	( ZoriaRPG, 16th January, 2020 )

//Beta 22
Updated ghost.zh to v2.8.8
Correct std.zh file date.
<std> 1.5011 : Add missing remchr(ptr) to string.zh.
	Also removed 'string' as identifiers; replacing it with 'ptr'.
	( ZoriaRPG, 12th January, 2020 )
	
Updated year to 2020 for copyright and file dates.
Added IsValidArray(int) to ZScript + Docs
TheRandoHmeader is now in ./headers, updated to v2.1, optimised for 2.53.1
	( ZoriaRPG, 10th January, 2020 )

Add TheRandomHeader, Optimised for 2.53.x to ./headers
	( ZoriaRPG, 9th January, 2020 )

//Beta 21
nly set map flag mTMPNORET for traps if it is not already set
	on the current screen. This prevents logging slowdown from setting
	it every frame.
For some reason, D_REFRESH isn't occurring on the first time
	that the user sets a KB button. This circumvents text errors
	by padding both key strings and key/button integers.
	( ZoriaRPG, 4th January, 2020 )
	
Decimal map number was too large to fit in small mode. Removed.
	( Venrob, 3rd January, 2020 )
	
std.zh Version 1.5010
	Fix a sanity check in float Distance(int x1, int y1, int x2, int y2, int scale)
	Convert import to #include for 2.53.1
	Old format is in std_imports for legacy versions.	
	( ZoriaRPG, 2nd January, 2020 )	
	
Report script exiting on command 0xFFFF.
	( ZoriaRPG, 28th December, 2019 )

//Beta 20
The #include directive now scans all include paths first, root last,
	while the import directive scans root first; to match 2.55.
	( ZoriaRPG, 23rd December, 2019 )

//Beta 19
Fixed animation type on Daira enemy in qst.dat.
Fix line numbers being literal, not *10000. They need to be *10000
	in 2.53.1.
Optimised ZScript compiler function calls to use PUSHV, instead of SETV, then PUSHR.
Added OPushImmediate opcode to the parser.
Added an emulation flag for buggy ->Next combo behaviour.
Fixed the issue reported by Matthew, where a Slash->Next combo
	that transformed into a Step->Secrets combo would immediately transform
	into the secret combo of the step combo, without being stepped upon,
	immediately after being slashed.
	( ZoriaRPG, 17th December, 2019 )

//Beta 18
Fix and clean up Compiler dialoge. 
Added Menu: Tools->ZQuest Settings->Compiler, with option to set
	header guard value.
Note how to cause header guards to match the filename instead of quotedstrings.	
Make header guard tokens case-insensitive.
Added zquest.cfg option HEADER_GUARD. At present, this matches
	the full quoted string, but should we ever want to match the
	filename only, I added a note in ffscript.ypp, line 680
	on how to revert to doing that.
	( ZoriaRPG, 10th December, 2019 )
	
Fixed illegal ternary token error on ':'
	( ZoriaRPG, 8th December, 2019 )

//Beta 17
Fixed a possible crash when saving MIDI files from ZC Player.
	( ZoriaRPG, 8th December, 2019 )

//Beta 16
Clear the panel recent screen buttons when creating a new quest.
Clear the panel recent screen buttons to prevent crashes from invalid maps.
	( ZoriaRPG, 26th November, 2019 )
	
ZQ now displays the decimal value of a screen number in parentheses
	next to the hex value in ZQ.
	( Venrob, 26th November, 2019 )
	
ZScript Dialogue: Import is now Load (hotkey 'L'), to match 2.55. 
	( ZoriaRPG, 25th November, 2019 )

//Beta 15
Display colour in tile editor as hex.
	( Venrob, 24th November, 2019 )

//Beta 14
Changed menu entry 'The Travels of Link' to 'Ambient Music'.
Fixed ambient and boss sounds being killed when using potions.
	The prior fix did not work. 
Fix Memory Leak from Mirrors: This commit should remove a memory leak when 
	reflecting weapons off of mirrors caused by creating a new weapon, 
	then not using it. 
	Notably: 
		weapon *w = new weapon(*this);
		if ( a ) { Lwpns.add(w); } // Safe, because the sprite_list will destroy it.
		else w = this; 
		// Memory leak happens here, because the weapon we added to the heap above
		// isn't added to sprite_list. It is a dangling piece on the heap.

	Changed to: 
		weapon *w = NULL; 
		if ( a )
		{
			w = new weapon(*this);
			Lwpns.add(w); 		// This should have the same effect as above, but
					// the weapon is not being allocated to the heap,
					// UNTIL it is NEEDED.
		}
		else w = this; // Now, we assign the NULL pointer to *this. 
		// Thus, no heap allocation occurs. 
Fix: Potion Kills Ambient SFX
	This fix should pause sfx when refilling (potion, magic, hearts
	or both, including from refill combos; then resume them when the potion 
	effect ends, matching the NES behaviour. 
	( ZoriaRPG, 20th November, 2019 )
	
Added zc.cfg section [ZSCRIPT] with config int ZASM_Hangcount.
	This is used in place of the hardcoded number of instructions to
	wait, ere checking quit keys. It defaults to 1000.
Check for hangs every 1000 ZScript instructions, instead of 100,000.
	( ZoriaRPG, 19th November, 2019 )

//Beta 13
Added Strings Help to the Help submenu.
Changed 'ZQuest Editor Help' to 'Editor Help'.
Edited the item help info for shields to reference ZQ Shield Help
	instead of the ZC.com Wiki.
Changed 'Shield Block Flags' in the Help submenu to 'Shield Help'.
Allow zstrings.txt to be in root or in ./docs
Changed the menu entry for ZQuest>>>Help to a 'Help' submenu.
	Added ZQuest Help, Shield Block Flag Help, and ZScript Help to
	the new submenu. These require zquest.txt, shield_block_flags.txt,
	and zscript.txt, respectively. 
	( ZoriaRPG, 17th November, 2019 )

Added 'skip_layer_warning' config int, under '[zquest]'
	If non-zero, the warning message when trying to place flags
	on layers they don't work on, is not displayed. This is helpful
	for scripts which read flags off of layers.
Changed the level palette editor, so that it starts with the
	palette of the current screen selected, instead of
	level palette 0.
	( Venrob, 16th November, 2019 )
	
Fixed the error messages for Screen->LoadItem, LoadNPC, LoadLWeapom
	and load EWeapon to return a 1-indexed value.
	( ZoriaRPG, 15th November, 2019 )

//Beta 12
Because 'particle' and 'decoration' are potentially already common
	identifiers in scripts, I have reversed the reservation of these 
	tokens, changing them to 'decorationsprite' and 'particlesprite'.
	We can add user typedefs to <std> if we want, later, to shorten
	the datatype to something like 'particles' or 'deco'.
	( ZoriaRPG, 13th November, 2019 )

Reserved 'particle' and 'decoration' as datatypes.
	( ZoriaRPG, 12th November, 2019 )

//Beta 11
Updated qst.dat so that the script buffer uses '#include', not 'import'.
Classic.zh: v1.12. Use '#include', not 'import'.
	( ZoriaRPG, 9th November, 2019 )
	
Fixed instability and improper offsets from Import/Export tiles. 
	( ZoriaRPG, 8th November, 2019 )

Fixed the .cfg file to read monochrome_debuggers = 1 under [CONSOLE]
Add zc.cfg value monochrome_debuggers = 1 to display the new 
	ZScript Debugger in monochrome (white).
Added a menu option in ZC Player under Game to toggle the 
	Windows MIDI patch.
MIDI patch now defaults to 1 if you don't have it in your zc.cfg.
Added additional include paths:
	./include
	./headers
	./scripts
	When #including or importing a file, the parser
	will not scan root first, then scan (in order) include, headers, and scripts.
	It will error only if the file is not in any of these
	paths, and it will select the first instance of the file 
	that it finds.
	Thus, if you have foo.zh in both ./include and in ./headers,
	the parser will select the file in ./include.
	( ZoriaRPG, 7th November, 2019 )

//Beta 10
Fixed quest templates so that when creating a new quest, qr_LOG is on by default,
	and needlessly updated qst.dat.
	( ZoriaRPG, 5th November, 2019 )
	
The build date in ZC Player/ZQ About strings is now in a
	format of: 0th Month, 9999
	Thus, 4th November, 2019, not 4-11-2019.
	This avoids day/month transposition, and is for clarity.
	The datestamp remains auto-generated.
If you load a ZDMAP file made in this build, in the Import Dialogue containing a single, or
	a small number of DMaps, they will load into the slots that they
	occupied in the quest from whence they were exported.
	ONLY the DMap Editor selects a specific slot, but DMaps are NOT
	LOADED into slot 0 from the Import menu, as the previous commit stated!
Refactored .zdmap, removing .zdmapset and merging both types
	into one file.
	You can now import from the dmap editor (single dmap) or from the
	Import menu (multiple dmaps.)
	If a file contains a single dmap, the import menu will load it to
	index 0.
	If a file contains multiple dmaps, the DMap Editor will load the
	FIRST dmap in the file, into the selected slot.
Begin Adding Datatype Versioning
Moved all graphical Import options to new Graphics submenu.
	Added a new All Combo Table Import and added overwrite protection
	to all import combo options.
	Moved old Import Combos to the 2.50.x memnu subsection.
	Moved old Combo export to 2.50 subsection along with some
	other broken types.
		We need to fix the others with new versions soon.
Vers: All files now rely only on metadata/versionsig.h
	( ZoriaRPG, 4th November, 2019 )

Fix: BG Layer stuff in ZQ 
	Hiding layer 0 no longer hides BG layers
	Next-screen previews now draw BG layers properly
	( Venrob, 3rd November, 2019 )
	
Fixed the Goto Page Hotkey (P) in the ZQ main editor view to
	jump to the specified page for combo aliases. Each page is 256
	alias swatches tall (one full bank), and the last quarter page
	cannot be jumped into without overflow, but that tiny limitation
	is, IMO better than not being able to do this, at all, at all.
Temp: A possible fix for Ganon reappearing in deongeons after death.
	his SHOULD fix Ganon respawning after collecting the big TF
	in dungeons or screens set with a boss flag, but if quests rely on
	the bugged behaviour, it needs an enemy flag.
	**UNVERIFIED FIX**
Ported item->linked_parent from 2.55, to 2.53.1, moving the
	check for eeGANON off of Misc15 and using the new var to determine
	if a dustpile item was created by Ganon.
	Fixed the drop of the large TF (relly, and trully), to spawn over
	the ASHES if they have moved.
	( ZoriaRPG, 3rd November, 2019 )
	
The little arrows above the combo alias banks now work as intended.
Added Notes on fixing bug where potions kill sfx.
	( ZoriaRPG, 2nd November, 2019 )	
	
//Beta 9
Fix: Item 0 issue 
	(None) in listers was not sorting properly for items.
	( Venrob, 2nd November, 2019 )
	
Feat: Active layer button is highlighted
	( Venrob, 1st November, 2019 )

Parser: Added a few more guards against reserved tokens.
	( ZoriaRPG, 1st November, 2019 )
	
std_zh: Fix GetHighestLevelItemOwned 
	Now no longer has a critical bug, and is much faster.
	Now works the same way 'current_item_id()' does internally.
	( Venrob, 31st October, 2019 )
	
Updated ghost/other.zh and tango/1.2/user.zh to remove 'default' and 'bitmap' identifiers
Added error for logical xor.
The parser now errors, and reports that the user must use ZSxript v14/2.55
	if the user tries to code with datatypes, pointers, tokens, or
	directives that require 2.55+.
Updated std.zh, tango.zh, and ghost.zh to call '#include', not 'import'.
Updated ZScript_Changes.txt
Updated all .ztheme files, and added dark.ztheme, and ruby.ztheme by Shadowblitz.
Made the default cursor size for ZQ large mode match 2.50, again.
Added '#include# as an alternate to 'import' in the parser
	so that simple scripts (ffc, global, item) can be more-easily shared 
	shared between 2.53.1 and 2.55.
	2.53.1 uses the standard import behaviour for this token,
	not the improved behaviour from 2.55. 
	This is purely a semantical addition.
	( ZoriaRPG, 29th October, 2019 )

//Beta 8
Allow block comments and some alternative tokens. 
	( ZoriaRPG, 28th October, 2019 )
	
//Beta 7
Fix crash if compiler sounds are set to 0 and vbound them between 0 and 255.
	( ZoriaRPG, 28th October, 2019 )

//Beta 6
Fixed errors in zscript.txt, now v0.7.6.
Fixed crashes when saving files with very long paths.
Fixed an off-by-one error in .ztile and in .ztileset load/write. 
	( ZoriaRPG, 27th October. 2019 )

//Beta 5
.zmod: Add classic.zmod to 2.53.1 and update zc.cfg to use it.
.zmod: Minor fixes.
.zmod: Fix the default module file from default.zmod to classic.zmod
.zmod: Use moduledats for quests, skipnames, starting dmaps, starting screens,
	and ZC Player datafiles (not for ZQ Editor datafiles!!)
.zmod: Add .zmod (light) format to zelda.exe
	( ZoriaRPG, 24th October, 2019 )

Refactor: Replaced .dmp with .zdmapset
	Deprecated the old Export DMaps format (.dmp).
	The user can still IMPORT that format via Import->2.50.x->DMaps in
	THIS VERSION only.
	Added the new .zdmapset format, to replace this feature, which is future-safe
	for 2.55 and above.
	( ZoriaRPG, 23rd October, 2019 )
Pressing F12 now captures screenshots in the Enemy, Item, 
	and the Weapon Sprite Editors.
	( ZoriaRPG, 22nd October, 2019 )
	
//Beta 4
Refacrored the old 2.50 tileset import/export from .TIL to .ZTILESET
	I rewrote the full tileset import/export so that it will be futureproof.
	The user can import the old .til files in this version (but not 2.55!!)
	using a new submenu: File->Import->2.50.x Files.
	It is mechanically identical to the user, otherwise.
	( ZoriaRPG, 22nd October, 2019 )	

//Beta 3
Added spacer in Export submenus.
Fixed some wrong dialogue titles for Combo Alias Packs
Cleaned up old export saving success messages, and added saving success
	messages to .zalias, .zcombo, and .ztile file saving.
The Z Hotkey works again in the tile editor and the visible hitkey in the
	Etc menu is again there.
	( ZoriaRPG, 22nd October, 2019 )

//Beta 2
Added the ability to save and load Combo Alias files in the format
	of .zalias, with the same GUI options and mechanics as .ZCOMBO and .ZTILE.
	( ZoriaRPG, 21st October, 2019 )

//Beta 1
Fix .ZCOMBO Off By One Error and Wrong Version ID
Fix .ZCOMBO off by 1 error.
Added .ZCOMBO, identical to .ZTILE
All About Version dialogues now exlusively pull data from the
	new metadata header, metadata/versionsig.h
	( ZoriaRPG, 21st October, 2019 )
	Remove Lunaria Brick from 2.53. -Z
Etc>>Take Screen Snapshot
	Takes a screenshot of JUST the current screen, not including GUI elements.
		This captures at proper-scale; i.e. 1 combo is 16x16, regardless of gui scaling.
		If holding CTRL, things such as walkability and flags will appear (if you have them
		visible); if not holding CTRL these will be hidden as well.
	This allows easy capturing of an entire screen, at 1:1 scale.
	Renamed `Take Snapshot` to `Take ZQ Snapshot` to help prevent confusion.
	( Venrob, 20th October, 2019 )
	
Bind .rc files to metadata/resourcesig.h
Timezone for datestamps is now set in ./metadata/sigs/devsig.h.sig
Blot out Lunaria comments in logfile.
Build date and timestamps are not autogenerated at compile time.
	( ZoriaRPG, 20th October, 2019 )
	
Fix: Don't alphabetize '(None)' 
	( Venrob, 19th October, 2019 )
	
Remove Lunaria Brick from 2.53. -Z
Vers: Update to 2.53.1 Beta 1
	( ZoriaRPG, 19th October, 2019 )
	
	
//2.53.0

//Release 3
Better tile image export 
	Fixed - selector no longer shows
	Added - instead of static or X's, it will display color 0 for hidden tiles
	Internal: draw_tiles() has new params, and an overload for default params.
	( Venrob, 19th October, 2019 )
Added Export and Import .ZTILE files.
	You can save a series of tiles, in mixed format to a .ZTILE file,
	and load them into any quest, either in the exact position in 
	which they were located in the source quest, or starting at a 
	position that you specify.
Fixed some error messages on modular object file loading.
Fixed the sanity checks for section_version and section_cversion on modular
	object file loading.
Added the ability to save and load weapon sprites as .ZWPNSPR files.
Added a contextual (right-click) menu to the Weapon Sprites
dialogue, allowing the user to copy and paste weapon sprites.
Changed the error message titlebar text a bit for all .Z*struct files.
Save, Load, Copy, paste DMaps
	Added a contextual (right-click) menu to the DMap Editor.
	You can now Copy/paste DMaps from this, and you can Save and Load DMaps
	to and from .ZDMAP files, as .ZITEM and .ZNPC. 
The user can now save individual npcs from the Enemy Editor 
	in the format of .ZNPC, identical to how .ZITEM works.
Updated icon resource scripts for ZC, ZQ, and ZCL. 
	( ZoriaRPG, 19th October, 2019 )
	
Add 'Hide 8-bit Marker' to the 'View' menu, with the hotkey '8' to toggle it.
	This hides the small '8' in the corner of 8-bit tiles.
Fix Ctrl+U long-standing issue: It was meant to cycle through different sets
	of 'Hide' settings, but, it would always turn off 'Hide Blank', and
	could not turn it back on. Now, it will NOT modify 'Hide Blank' at all.
	( Venrob, 19th October, 2019 )

Fix default cursor scale. Was 1.5, should be 1.
Added file VERSION metadata to EXE files via MSVC VERSION resource script.
	This prevents warnings by Malwarebytes on UPD's binaries.
	( ZoriaRPG, 18th October, 2019 )
	
Added cursor scaling option:
	Config options 'cursor_scale_large' and 'cursor_scale_small', to scale the cursor
	added to zquest.cfg and zc.cfg. Range 1 to 5, decimal allowed.
	( Venrob, 17th October, 2019 )
	
Replaced 'new quest' in qst.dat with Classic 1st 2.50 v1.10.
Added v_build to ZITEM format.
The mapscr selection marker rect is now red in InvalidStatic mode,
	as not to blend in (grey).
Changing the screen colour with hotkeys now allows F2/Memu to save.
Fixed a Crash due to placement of multi-instance code prior to allegro init.
Add Right Click Load/Save Options to Item Editor
	You can now save single items in the item editor as .ZITEM files,
	and load .ZITEM files into the item editor. Uses the contextual menu only,
	Ported from 2.55.
	( ZoriaRPG, 17th October, 2019 )
	
ZCL 2.8.0
Convert ZC Player options 'Skip Logo' and 'Multiple Instances'
to run off of zc.cfg and new ZC Player configs instead of using 
command line switches.
	Requires ZC Player builds after 16th October, 2019.
	( ZoriaRPG, 16th October, 2019 )

You can now set -fast and -multiple CLI flags in zc.cfg:
	multiple_instances : 0 by default; set to 1 to permit multiple instances.
	skiplogo: 0 by default; set to 1 to skip the AGN startup banner.
Update ZQuest.dat with new mouse pointers.
	( ZoriaRPG, 16th October, 2019 )

Now, instead of 3 separate keyboard control menus, and 2 separate gamepad menus,
	now there is one menu of each.
	This makes unique control conflicts less difficult to deal with, and
	overall makes more sense.
	( Venrob, 13th October, 2019 )

RomView loads again,but only small mode.
DAT: Fix mouse cursors for themes.
Fix a bug where init_game() as cllearing the current rendertarget to
	0, instead of -1 (screen), that was causing old ghosted
	enemies to be invisible.
	( ZoriaRPG, 12th October, 2019 )
	
Fix: Misalign arrows hardcoded colors 
	They now load similarly to cursors.
Fix: advpaste_dlg always small 
	Was missing 'is_large' check to upscale the dlg.
Fix: Forgot to rename .ztheme config names
	( Venrob, 12th October, 2019 )

Enlarge layer checkboxes.	
Added the ability to set cursor colours in themes.
	( Venrob, 11th October, 2019 )
	
Implement DEVLEVEL logging.
If DEVLEVEL > 0 logging is forced on for Events and Script Errors. 
	( ZoriaRPG, 10th October, 2019 )
	
ZCL 2.7.7
Move RomView into a sub-directory and bundle old fonts.dat
and allegro.lib with it so that it runs in 2,55.
Change code from commandlibe process to exec process.
	( ZoriaRPG, 10th October, 2019 )

Fix: Don't eat preexisting zc.sav if the zc.cfg file line is blank!
	Sorry all users. :/
	( ZoriaRPG, 10th October, 2019 )
	
ZCL 2.7.6
Added Load Module (.zmod) butons to both the ZC Player and
the ZQuest Editor config tabs. 
	( ZoriaRPG, 9th October, 2019 )

Add error on missing 6th.qst, but do not quit ZC.
Add quest file sanity check to OMNIUS skip.
Added OMNIUS to skip to 6th.qst.
Add shield tile 20327 to 6th.qst on title screen (title.cpp).
	We will update this with a shield that has a 6 inside it in 
	the final build, on tile page 1 of the qst.dat.
Prepare ZC Player for 6th quest, and add Linear Quest Progression menu option
	to play quests n the order of 1->2->3->4->5->6.
	
	If that is DISABLED:
		if you beat the 5th but died, go back to the 4th AS BEFORE, 
		or move on to 6th NOW, if it exists.
	I will redact this and use the ZC2.55 modules method if I backport that. 	
	( ZoriaRPG, 9th October, 2019 )

ZCL 2.7.5
Split up Theme/Colour settings for ZC Player and ZQuest
Added / replaced some tab icons (drivers, colours tabs, notes tab).
	( ZoriaRPG, 9th October, 2019 )

ZCL v2.7.4
Added User Theme Load Button, User Theme lister selection, 
	and User theme preview image (using Legacy theme, small mode).
	( ZoriaRPG, 9th October, 2019 )

Added numpad PLUS and numpad MINUS with CONTROL or SHIFT to the last commit.
The keys used to change the current CSet (- and =, but let's call them MINUS and PLUS)
	now allow changing the Level Palette by +/-1 or +/-16, in addition
	to working on CSet as before.
	
	Unmodified Minus:	Reduce CSet by One
	Unmodified Plus: 	Increase CSet by One
	Shift Modified Minus:	Reduce Level Palette By One
	Shift Modified Plus:	Increase Level Palette By One
	Control Modified Minus:	Reduce Level Palette by 16
	Control Modified Plus:	Increase Level Palette by 16

Added the following hotkeys:
	% :Set Current Level palette to 15 (0 to 14 were previously possible). 
	( ZoriaRPG, 9th October, 2019 )

Fixed lvl colours not pulling an average for palettes enfing in E or F.
	( Venrob, implemented by ZoriaRPG, 9th October, 2019 )

Fix: Clear RenderTargets set by Previous Quest
	( ZoriaRPG, 9th October, 2019 )

Theme: Added theme files:
	MooshMood: themes/mooshmood.ztheme
	Ice : themes/ice.ztheme
	Legacy : themes/legacy192.ztheme
	DarkBlue : themes/darkblue.ztheme
	Hotdog : themes/hotdog.ztheme
Feat: Allow .ztheme File to be Separate
	Added theme_filename string to [Theme] section in zc.cfg and in
	zquest.cfg. If set to a valid configuration file, the theme configs will 
	load from the specified file.
	I'm reserving '.ztheme' and '.zskin' for this file type, ZC Theme skins.
Added User Themes
	Added the ability for the user to define custom GUI themes for
	ZC Player, and for ZQuest. The GUI set for the user theme is '99'.
	The values for the theme are set in zc.cfg under [Theme] for ZC Player, and
	in zquest.cfg under [Theme] for ZQ Editor.
Updated Classic.zh to v1.11
	Added ffc script ScreenGuyMusic and fuction: bool __classic_zh_ScreenGuyAlive()
	Added arg for BossExplode ffc for enemy ID override as D7
	( ZoriaRPG, 8th October, 2019 )
	
Display a grid in the mapscreen selector box in ZQ if the current
map is an overworld palette rank (0x00, 0x10, 0x20 ...).
	( ZoriaRPG, 6th October, 2019 )
	
Fix: Revert a Check for .SAV File Filenames
	Fixed incorrect handling of save file filename checking 
	that caused a bug where the save file was always loading the hardcode again.
Added ZCL-changelog.txt to packages.
Included ZCL v2.7.3, with a new button to select the .SAV FILE.
Added a config string for the filename of the SAVE file to zc.cfg.
	( ZoriaRPG, 3rd October, 2019 )

Allow viewing CSets 12, 13, 14, and 15 in the tile editor. 
	( ZoriaRPG, 2nd October, 2019 )

Applied the same changes to writing to MouseY, during Quake
	that I applied to reading it. 
Backported the new ZScript Compiler sound effects from 2.55.
	You can now assign or disable these sounds in zquest.cfg, 
	for the following events:
		Compile Error
		Compile Success
		Script Slot Assign Completion
Fixed a bug where reading the mouse Y position during Quake shaking
	returned the wrong values.
	( ZoriaRPG, 30th September, 2019 )

You can now save the currnt (single) palette in the level
	palette editor, then use the grab function to load it in nother quest
	or another palette index.
Updated Classic.zh:
	v1.08: Added Eagle Dungeon Scripts from 1st.qst
	v1.09: Added screen change tracking and compass beep
	( ZoriaRPG, 27th September, 2019 )
	
Fixed screen palette not properly wrappping from, 0 to 511 with < and > hotkeys.
	( ZoriaRPG, 26th September, 2019 )
	
Added SetEquipment(int a, int b) to std.zh.
Fix: Writing Link->Equipment now works properly.
Added an interpreter case for writing to Link->Equipment.
Reverted build ID back to 33. We need 34->39 for future updates
	as 40 is 2.54, and the new number isn't being used in any 
	manner where it is valuable. 
Updated ZCL to v2.7.2
	Added DXGL Configuration to Video Drivers
Added 'Clear' buttons to Joystick Button and Joystick Direction
	panels for every JS Button. 
	The user can now clear them to 0 as desired. 
Updated build ID from 33 to 34
Update ZELDAVERSION to return 2.5301 instead of 2.5300
Updated qst.dat, adding the Z2 autolantern as an item, and 
	add the autolantern active that item subscreens. 
Fixed missing run() function call in Classic.zh autolantern item
	collect script, and add constant for I_AUTOLANTERN.
Reducing the quest mapcount now also clamps the mapscreens
	that the nine panel buttons (map_page[9]) point to, so that you cannot 
	visit an invald map (and thus crash ZQ). 
	( ZoriaRPG, 23rd September, 2019 )
	
Ported the coloured ZScript Debugging Console from 2.55 to 2.53.
	Added class FFScript in the process. At present, it is only
	handling the coloured console, like a struct.
ZQ About Dialogue ow shows Build Date & Time
Fix: make print_dissassembly non-static for g++.
	g++ doesn't like it as a static function. When I last
		built ZC on Linux, i had to make this change.
Added hotkeys for Save and 'Save As':
	Control+S : Save
	Control+Shift+S: Save As
	S: onString (edit screen string) -- this is unchanged from the perspective 
		of the user, although the code to run it is now different.
Fix: Duplicate function definition for ffc bounding.
	( ZoriaRPG, 22nd September, 2019 )
	
std: Added CMB_QUADRANT_* constants for combo solidity/CSet2 mask bits.
	( Moosh, ZoriaRPG, 21st September 2019 )

std.zh v1.5001
	Fixed WeaponTypeToID() -- Moosh pointed out a transposition in this function.
	Added nstants for version year, month, day, hour, and minute.
	Added functions: __stdzh_getVersionDate(), __stdzh_getVersionTime().
Rename BC::checkFFCIndex to bc::checkFFC to match 2.55.
Add bounds check to all FFC getter/setter instructions in ZScript.
	( ZoriaRPG, 16th September, 2019 )

std: Fixed Superbombs in WeaponTypeToID() 
	Flipped Superbomb Blast and Unexploded Weapon in WeaponTypeToID.
	( Moosh, ZoriaRPG, 16th September, 2019 )
	
npc->Attributes[] is  now read/write, and correctly sized
	to 15 total values (index 0 through index 14).
	( ZoriaRPG, 15th September, 2019 )
	
Classic.zh: Added Passive Z2 Lantern Package Collect Script
Updated Classic.zh for Release 3.
	Added Z2 Lantern to global active script.
	Added version information (may need adjustment. I padded this out to 1.06.)
	Added date and time file information.
	Added some constants, and used them.
	( ZoriaRPG, 14th September, 2019 )
	
Added int GetRenderTarget()
	( ZoriaRPG, 29th August, 2019 )
	
Fix: Hardcoded black in ZQ UI
	"Preview Text", from pressing "X"
	Small mode bottom-panel text
	( Venrob, 23rd August, 2019 )
	
Fix: Allow setting doors and templates on higher MAPSCRs
	This fix should allow setting doors and other templates on
	MAPSCRs up to 0x87.
	( ZoriaRPG, 1st July, 2019 )
	
Fixed array size for ffc->Flags[2], to [11].
	( ZoriaRPG, 21st June, 2019 )
	
Added epilepsyFlashReductionto bomb palette flashes.
Added an Epilepsy Flash Protection option to the Settings menu,
	and to zc.cfg.
	( ZoriaRPG, 26th May, 2019 )

//Release 2
Removed invisible widgets carried over tot he 2.50 interface from
	small mode that allow toggling the cset and layer.
	( ZoriaRPG, 17th April, 2019 )
	
Fixed the return values of lweapon->Jump, eweapon->Jump, npc->Jump
	and item->Jump.
Updated build ID to 33.
	( ZoriaRPG, 16th April, 2019 )

Fixed the easter egg for Lut in 1st/2nd.
	( ZoriaRPG, 9th APril, 2019 )
Re-included Bombchu QR, but this time, as a Compatibility rule.
	It is enabled by default for 2.50.1 or earlier quests. 
Disabled the console by default.
Removed Bombchu QR, because it is not needed.
	The user can set the bombchu explosion type in the enemy editor.
	It's the 'Weapon' field. 
	( ZoriaRPG, 8th April, 2019 )
	
Because of Quest 744...
Added a quest rule to Compatibility Rules for pre-2.50.2
DrawBitmap() offsets behaviour, and patched quest loader to most-approprately
auto-set this bit.
	( ZoriaRPG, 5th April, 2019 )
	
//Release 1
Added Arigatou/ path, and included files on request by contributors and core testers. 
	Thank you to all testers and to all contributors.
Cleaned up the Cheat Modifier Key dialogue.
Added 20th Anniversary banner.
	( ZoriaRPG, 3rd April, 2019 )

//Gamma 8
Revised the Bombchu emulation behaviour, and toggled the QR based on
	quest header data.
	2.50.0 and 2.50.1 quests have superbomb enabled by default.
	2.50.2 and 2.50.3RC1 quests have normal bomb by default.
	The emulation option is unavailable for quests made 
	in 2.50.3RC1 or later. 

Added the following to std.zh:
	const float STD_VERSION;
	float __stdzh_getVersion();
	bool HasKey(int level);
	bool HasKey();
	int NumKeys(int level);
	int NumKeys();
	bool ConsumeKey(int level);
	bool ConsumeKey();

Revamped all keyboard key dialogues:
	Added the ability to clear any keyboard key setting from 
		the GUI using a new 'Clear' button. 
		This button is on all keyboard key dialogues.
	Ensured that modifier key bindings must be unique against all other keybindings.
	Ensured that a keybinding of 0 (None) does not need to be unique.
Added a dialogue to configure cheat modifier keys.
	( ZoriaRPG, 1st April, 2019 )

//Gamma 7
Add docs for std_extension.zh as ./Docs/std_extension.txt
Optimise, revamp, correct, and alphabetically sort std_extension.zh.
	( ZoriaRPG, 29th March, 2019 )
	
Added second row of swim tiles to all Z3 animation styles
	in the default classic tileset blank quest.
std.zh: Optimise std_vars.zh
Updated std.txt to cover all cleanup in std.zh, except for
	std_extension (t/b/a).
Added second row of swim tiles to Z3 animation pages in the classic tileset.
	( ZoriaRPG, 28th March, 2019 )
	
std.zh: Optimise and Alphabetically Re-sort std_functions.zh
	( ZoriaRPG, 27th March, 2019 )

Added a config line 'logo_volume' to the 'zeldadx' section of zc.cfg to
	set the sound volume of the AGN fire logo.
Update Music.zh, fixing NPC_MIDI and NPC_Music scripts.
Cleaned up std.zh:
	Prune functions and fix AdjacentCombo() in std_extensions.
	Restructure std_update.zh, rename as std_extension.zh, 
		and call by default. 
	Delete std_shortcuts.zh.
Fixed the screen info for 'Layer Used By' not updating properly
	when changing maps.
	( ZoriaRPG, 26th March, 2019 )

Added a QR that causes bombchu explosions on contact with Link
	to be superbomb sized. This used the absolute last, unused rule bit for 2.53.
Allow Setting Doors on Mapscreens > 0x82
Fixed the state of 'save' not being set when deleting a favourite
	combo using the contextual menu.
	( ZoriaRPG, 24th March, 2019 )

Fixed illegal esc char in menu listing. 
Fixed copyright year on game ending.
	( ZoriaRPG, 19th March, 2019 )

Fixed cheat hotkey (listed in menu) for Kill All Enemies.
The actual Ky is K, but I had T in there.
	( ZoriaRPG, 17th March, 2019 )

//Gamma 6
Don't allow infinite max bombs in 1.84 quests. 
	Max bombs now set to 8 in zelda.cpp, on `firstplay`. 
	( ZoriaRPG, 17th March 2019 )
	
Moved the ffscript debug namespace into ffscript.cpp.
Added hotkeys for the following Lv4 Cheats
	Kill All Enemies (K)
	Show Overhead (O)
	Show Push Blocks (P)
	Show Hitboxes (C; for Collision)
	Show FFScript Names (F)
Fixed Crash When Removing Cane of Byrna By Script
	( ZoriaRPG, 16th March, 2019 ) 
	
It seems that 1.84 quests do not start with a bomb bag, but
	they should, as the item did not exist in those old versions; and thus,
	the player cannot pick up bombs in quests made using them.
Added another fix to 8-way shots.
	( ZoriaRPG, 12th March, 2019 )

//Gamma 5
Updated all default active subscreens in qst.dat, with the new items. 
Added the following item scripts to Classic.zh, and items
	to the default quest in qst.dat:
	
	MagicBossKey: Acts like the Magical Key, for Boss Locks.
		Set to item ID: 146
	MagicalMap: Gives the player the dungeon map to every dungeon.
		Set to item ID: 147
	Magical Compass: Gives the player the compass item to every dungeon.
		Set to item ID: 148

Renamed all system-wide screenshot files as follows:
	ZC: 
		zc_screen#####.png
	ZQuest:
		Maps:
			zq_map#####.png
		Screen:
			zq_screen#####.png
	( ZoriaRPG, 6th March, 2019 )

The Export ZScript now uses the .zs extension by default (no ZLIB conflicts).
ZCL version is now 2.6.12:
	Fixed default pane of the ZQuest tab in ZCL.
	Removed duplicate 'Misaligns' option box in ZCL.
Cleaned all intermediates, all project files, and all CMake files.
	Built clean.
Changed l_down sprites on 8-way enemy shots to face down.
	( ZoriaRPG, 5th March, 2019 )

//Gamma 4
Classic.zh: Fix BossExplode ffc to work with all segmented bosses. 

Resize fields for text entry to fit five chars. 
Fixed Init Data (and cheat data) field sizes for:
	Heart Containers (was a field size of 2, now 3)
	Starting HP (in hearts, was 3 now size 5)
	Starting Magic (was size 3, now 5)
	Max Magic (was size 3, now 5)
	Super Bomb Ratio (was size 2, now 3)

Updated qst.dat 

Fixed the SignPost ffc script.

Moved the new functions from Classic.zh to std_functions.zh.
Added some relativity functions to Classic.zh--should move to std_functions.zh:
	DistXY(ffc, int), LeftOf(), RightOf(), Above(), Below(), Facing(ffc).

2.50.x quests with a build < 31, or quests with a header 
	version < 0x250 will now write hitsfx = WAV_EHIT, for all guys where 
	the hitsfx sound == 0, on saving a quest in 2.53.

Quests made in 2.53 Gamma 0/1 or earlier (build 31) now load
	WAV_EHIT into the enemy editor hitsfx field when the editor opens.
	This prevents corruption of the quest by modifying the value on quest load,
	and ensures that the value only changes if the user saves the quest in 2.53.

2.50.2 AND EARLIER play SFX_HIT even if Enemy Editor Hit Sound is 0. 
	Thus, I added a special case that causes this to happen in guys.cpp, based
	on header version and build. 

	Arbitrary enemy policy 15610. :P
	( ZoriaRPG, 25th February, 2019 )

Fixed Byrna Cleanup Routine killing SFX 30. This was caused by
	`last_cane_of_byrna_item_id` never being able to be -1 because it was declared
	as byte, instead of int.

Classic.zh Fixes and Improvements:
	Renamed constants to prevent future conflicts.
	BossMusic ffc: 
		Fixed a bug that caused the victory music to re-play when the
		player revisited the screen.
		Added InitD variables to allow customisation by the user.
	BossExplode ffc:
		Added InitD variables to allow customisation by the user.
	DropTRIFORCE ffc:
	DropHEARTCONTAINER ffc:
		Fixed a bug that caused the TF drop to repeat if the player revisited
		the screen.
		Added a dropshadow to the object when falling.
		Slowed falling descent. 
		Clamped screen coordinates of drop to ensure that the object does
		not fall partway off the edges of the screen.
	( ZoriaRPG, 24th February, 2019 )


Added scripts 'DropTRIFORCE' and 'DropHEARTCONTAINER' to Classic.zh.
	Fixed issue where invalid weapons were loaded by 'BossMusic' ffc script
	because of a Waitframe in the loop.
	Removed traces.

Added a case for r_down dir on 8-way EW_MAGIC shots. 
	( ZoriaRPG, 22nd February, 2019 )
	
Updated qst.dat with all of the new goodies. 

Added constants to Classic.zh:
	const int _classic_zc__TRK_BOSS = 25;
	const int _classic_zh__MIDI_VICTORY = 1;
	const int _classic_zh__TILE_FIREWORK = 10140;

Added file Classic.nsf, from klop422 (Legend of Zelda NSF  from the PZC Database). 
	We use track 25 for boss music here.
Added a victory jingle MIDI as MIDI ID 1. 
Add combo to use for Boss Audio FFC to combo page 3 as combo ID 905.
Added BossMusic ffc to classic.zh. This is compatible with the BossExplosion ffc.
Added tile for Boss Audio to tile page 61 as tile 16026.

Added overload functions to Collision() that function as LinkCollision(). 

Updated ffc scripts in classic.zh to clear their combo on init. 
Fixed signpost script. 
Added default fireworks ffc to copy and paste, on map 1, screen 0x82. 
Added combo using the Fire Work tile to combo page 3, as combo 904.
Added tile to use as  marker for fireworks ffc to tile page 61, as tile 16025.
Modified fireworks script constants. 
Added fireworks SFX as sound 61. 
Added fireworks weapon sprite as Sprite 88. 
Added tiles for fireworks to tile page 39 as tiles 10140, 10141, 10142.
Fixed daira tiles on page 38. 
	( ZoriaRPG, 21st February, 2019 )
	
Classic.zh:
	Added item script 'ItemSound'
	Added FFC script 'BossExplode'
	Added constants:
		const int _BOSS_EXPLODE_SPRITE
		const int _BOSS_EXPLODE_DUR
		const int _BOSS_EXPLODE_SFX
		const int _BOSS_EXPLODE_DELAY
		const int _BOSS_EXPLODE_RANDOM_MIN
		const int _BOSS_EXPLODE_RANDOM_MAX
	
		const int I_HALFMAGIC = 	144;
		const int I_LEARNSLASH =	143;
		const int NPC_DAIRA1 = 		177;
		const int NPC_DAIRA2 = 		178;
	
Add item: Message (Example) as item 145.
Adjusted stats of both Daira enemies, and set their defences. 
	Note: 1/4 Arrow damage is intentional for L2, to reflect
	better armour/scales. 
Add Daira (L2) [blue] as enemy 178, renamed Daira to Daira (L1) [red].
Fixed ZCL 'Skip Logo' selection not saving. 
	ZCL is now v2.6.11. 
Default quest changes:
Added ffc scripts:
	PermBlockSecrets : This triggers normal screen secrets.
	PermBlockShutter : Block->Shutter secrets in NES Dungeons
	Daira (autoghost)
Removed ffc script PermSecret
Fixed name of 'CanSlash' item script. 
Added item script 'ItemMessage'
Added Daira enemy as npc ID: 177
Added Daira script to classic.zh
Added Daira tiles to tile page 38 (tiles 9880, through 9959)
	( ZoriaRPG, 19th February, 2019 )
Added call to Classic.zh in the buffer.
	Updated all active subscreens to include the new items. 
	Added items: 'Scroll: Learn Slash', 'Scroll: Half Magic'
	Placed default FFCs with scripts attached on map 1, screen 0x82. 
		These have their icon set, and their Ethereal flag set. 
	Added the following scripts:
	Default active script with Tango and Ghost.
	Half Magic Item (item, pickup)
	Learn Slash Item (item, pickup)
	Change Room Guy (ffc)
	Perm. Secrets (ffc) 
	Signpost (ffc)
	
	Added freezeall and freeze only ffc default combos to combo page 3:
		
	Added tiles on page 61 for icons to represent the FFC scripts. 
	(Tile IDs: 16002, 16003, 16004, 16005, 16023, 16024, 16061, 16062)
	Added combos for ffc icons to combo page 3:
		IDs: 892, 893
		Icons for the above, are combos: 888, 889. 
	Added tiles for the icon combos for freeze combos to tile page 61 as 
		tiles: 16000, and 16001. 
Commented out some conflicting constants in stdExtra.zh
Moved stdWeapons and Laser.zh into an 'extras' path.
Corrected power rating of remote bombs. 
	This will only affect quests saved in 2.53, and 
	only if the power of the bomb is > 1. 
Reverted back to Gleeok's forced on bit for half tile collision 
	in quests made in 2.50.0 and 2.50.1 Or lower 2.50 builds).
Expanded the Emulation menu toggle to cover builds through 2.50.1. 
	I'm tired of this one, too. 
Began adding some default scripts to Classic (as Classic.zh), and 
	corrected some constants in the included scripts, to match.
Fixed the selection mark for Bombchu Emulation, and ensured that
	it is enabled by default for 2.50.0 and 2.50.1 quests. 
Added an emulation option to restore the large blast radius 
	(superbomb) if Link is hit by a charging bombchu.
	This is enabled by default for 2.50.1 and earlier quests, and disabled in 2.53 quests
Fixed 8-way shots always using WAV_FIRE.
	Added an emulation memu option to force using WAV_FIRE for all 8-way shots.
	This is enabled by default in quests < 2.50.
	This menu option is disabled in 2.53+ quests.
	( ZoriaRPG, 18th February, 2019 )

//Gamma 3
Updated qst.dat, to strip out some remaining rubbish pal cycle data. 
Fixes for Palette Cycle Issues:
	Palettes above 256 were not set up to have palette cycles in 2.50.
	The array in QMisc is [256][3], where it should have been [512][3].

	Because of this, palettes above 0xFF had rubbish data associated to their cycle data.

	To remedy this, I have done the following:

		All palettes > 255 have a null palette loaded into them, in the editor and as
		palette data, to zero out their cycle information.

		This should occur both in ZC, and in ZQuest.

		I disabled clicking the Cycle button in the Level palette editor, and display
		a jwin-alert that the palette doesn't support cycling.

	Let's hope this doesn't cause crashes in any quests, in ZC.


Added leading zeros to the 'Select Item' 'Pow: ' field, so that
items with powers greater than 10 don't carry over digits to items with
powers < 10.
	( ZoriaRPG, 17th February, 2019 )
Re-fix 1st.qst Level 9 Rupee issue. I had set the wrong type. 
	( NightmareJames, 16th February, 2019 )
Updated include 'tango.zh', and its associated demo to current versions of both.
Pressing the Enter key, or the numpad Enter key, while viewing
the Quest Header dialogue now EITHER activates the selected element, 
	or saves the dialogue changes, instead of opening the
	'Change Quest password' sub-dialogue. 
	It will auto-save if the selected element is OK, or any TEXT field.
	Otherwise, it triggers the selected element.
	This should also work from the numpad Enter key. 
	I also made the changes as an EXAMPLE chain, for making all
	JWin DIALOGUES more user-friendly, in the future. 
		See Commits: 
			b479871e9d38d8245874bc6cffc2f72e93f6cd5a
			c638d67cd856cc09e2e937c5a7da3dc9e0743952
			93956d00d4bb933236c6625cb778eb6ddd5caba4
Added a new function, Link.cleanupByrna() and called it in game_loop() (zelda.cpp).
Added a sfx cleanup for the byrna beam to weapons.cpp.
Added a new LinkClass variable, byte last_cane_of_byrna, that functions similar to
	last_lens_id.
	It inits at -1, then when Link uses a cane, it is set to that cane's ID.
	It is reset to -1 in Link.cleanupByrna().
Added kill_sfx() call to three other possible places where the Cane of Byyrna
	sound should probably be terminated:
	Whenever we call stopCaneOfByrna()
	If we can't pay the cost during item / weapon init
	If the beams aren't created during init, for some reason. 
Re-adjust qr_OFFSETEWPNCOLLISIONFIX in qst.cpp, to force it on for 2.50.0 build < 24, 
	instead of build |< 29 (as Gleeok forced it). 

	I tested SIX quest files, CREATED in three versions of ZQuest:
		2.50.0, bit set off (b24)
		2.50.0, bit set on (b24)
		2.50.1, bit set off (b28)
		2.50.1, bit set on (b28)
		2.50.2, bit set off (b29)
		2.50.2, bit set on (b29)
	If we check build < 29, then quests made in 2.50.0 and possibly 2.50.1 have
	the bit forced on, when it wasn't intended.
    
	Unless the actual BEHAVIOUR of this bit has changed (this needs verification), 
	then builds 24, 28, 29, 30, 31, and 32 should never force this bit on. 
	
	It is certainly possible that quests made prior to build 24 (2.50.0 release) have this wrong.
	I would need to check every RC to see, and backtrack from there. 
	( ZoriaRPG, 16th February, 2019 )
	
Fixed a secret rupee in Lv9 (1st.qst) not being secret.
	( NightmareJames, 31st January, 2019; file added to Gamma 3, 14th February, 2019 )
Reverted the patch that stopped Ganon from hurting Link if Link
	is standing on Ganon when Ganon dies. 
	We can apply this as a general rule or fix to all enemy behaviour in 2.55.

	The NES Ganon hurts Link. 

Cleared Link's attackclk before calling saved_Zelda(). 
	This prevents a charged sword, or other weapon, from carrying
	over to the ending sequence as a visual artefact. 
Stop playing byrna beam sfx as soon as the beams die in Link.cpp
Fix stunned peahats hurting Link in 2.50+ quests.
	( ZoriaRPG, 14th February, 2019 )

//Gamma 2
Changed the default length of the short hookshot to 8. 
	At one point, the distance was in pixels, then someone
	changed it to tiles. We'll make pixels an option again in 2.55. 
Reverted the usesound value for the Magic Book in qst.dat.
Reverted the last two changes, and hardcoded WAV_FIRE in weapons.cpp.
Hardcoded wand fire sfx for quests made in builds prior to 2.53 Gamma 2 (2.50 Build 32)
Increased Build ID to 32, and updated qst.dat (again).
	( ZoriaRPG, 13th February, 2019 )
Fixed default sound for magic book on quest load for older quests, and
	set to 13 (WAV_FIRE) in qst.dat for default blank quest.
	(Updated qst.dat)
Corrected copyright year in zdefs.h. 
Fixed the following in std.zh:
	Added revised behaviour to RotatePointX() and RotatePointY().
	Added toggle for old/new RotatePointX() and RotatePointY() behaviour.
	Probably fixed issues with catsizes() in ScreenFlag() and ScreenEFlag().
	Swap lit bomb and bomb returns in int WeaponTypeToID(int wpnt).
	Remove extraneous 's' in bool EnemiesAlive().
	Add float LargeDistance(int x1, int y1, int x2, int y2, int divisor).

	Somehow the file size on disc decreased in the process. Not sure on this one.
Possibly fix some issues with the hammer.
Fixed screenshots saving without using modifier keys.
	This had nothing to do with the cheat system, but rather, was an invalid sprintf
	format in onNonGUISnapshot.
Emulation: Restrict Repeating DMap Intros to 2.11.x
Enabling or disabling the Debig Console (win32 only) now updates and saves
	the zc.cfg file setting for debug_console under zeldadx.
Fixed Link->Misc being multiplied and divided by 10000. 
	( ZoriaRPG, 12th February, 2019 )

Fixed Wealth Medals in Bomb/Arrow upgrade rooms which use percentage zero 
	out cost (integer division != double division) (guys.cpp)
	No code was ever in place to give the discount? (link.cpp)
	( Venrob, 11th February, 2019 )
	
Fixed Combo Aliad dialogue not doing copy/swap for aliases
	greater than 999. Required refactor.
	( ZoriaRPG, 30th January, 2019 )

//Gamma 1
Updated ZCL to 2.6.10:
	The main in-focus page is once again ZC.
	Added the new UI Coloursets (Dark, and October).
Link was not fully cropped during the credits scroll.
	Pixels of his hat were left behind as artefacts. This fixes the issue,
	by resizing the call to rectfill().
	( ZoriaRPG, 29th January, 2019 )

//Beta 36
Fix 'OK' button in joystick button config not saving.
Fix screenshot numbering format to have a width of 5, not 3.
	( ZoriaRPG, 28th January, 2019 )
Added an Emulation toggle to try to permit continuous sword triggers
	in 2.10 and 2.50 quests.
	I'm not sure what the latest 2.50 build is, that should permit this, but if LI
	was saved in a later build, and needs it, then here it is.
Try to fix tall grash animation during scrolling.
Try to fix Ganon's Ashes not spawning.
	( ZoriaRPG, 25th January, 2019 )
	
Possible fix for the following reported issue:
	`Ganon can hurt you when he's red, and doesn't hurt you when he's flashing, but for one frame his hurtbox comes back when he explodes` -P-Tux

Reposition timing of creation of the hammer smack sprites to try to
	prevent them from appearing int he wrong spot if the player changes direction abruptly.
	( ZoriaRPG, 24th January, 2019 )

//Beta 35
Added Emulation menu option 'Don't Flip Firetrails'.
	If enabled (2.10 or earlier), then firetrails on brang weapomns
	will not flip on bounce, and may be allowed to hit and harm enemies.
Add jwin alert messages to all Emulation menu options, to explain what they do.
Apply 1.90 Swim Sprites to all calls to linktile() in link.cpp
Increased screenshot numbering cap from 999, to 99999.
	( ZoriaRPG, 22nd January, 2019 )
Apply 2.10 windrobe emulation, also to 1.92.
Final fix of 1.92 vand 2.10 Windrobe mmechanics, removing extra shot.
Clean up tribble emulation.

//Beta 34
Implemented Emulation Option 'DMap Intros Always Repeat' for 2.55 quests.
Fix: Try again to fix 2.10 Windrobes.
Fix: Wizzrobes appearing in dungeon walls in 1.84 quests.
Fix GEL and KEESE tribbles, in 1.90 (or earlier) quests.
	This now occurs in readguys.
Remove Emulation flag for OLD TRIBBLES.
	( ZoriaRPG, 16th January, 2019 )

//Beta 33
Potentially fixed Triforce Warp-Out in item cellars (2.10 and earlier, no rule, no emulation flag).
	Added a ternary statement in getTriforcePiece()
Begin Adding Emulation Menu Options:
	Restore 2.10 Windrobes
	DMap Intros Always Repeat
	--removed this one, because I have a possible in-source fix: Fix Triforce Cellars
Try to fix wizzrobes in 1.90/1.84 quests.
	They were spawning in walls, and never should.
Try to make it possible for Windrobes in 2.10 quests to nbot line up.
	( ZoriaRPG, 16th January, 2019 )
	
Fix some emulation options. 
	( ZoriaRPG, 14th January, 2019 )

//Beta 32
Fixed emulation (item/segment) appearing in quests older than 1.92. 
Clear emulation array, except on F6/GameOver->Continue.
Added the ability to copy Link#s walking sprites over his swimming
	and diving sprites in 1.90 quests with BS Link Animation.
Begin adding 1.90 BS Animation Toggle
Begin adding 1.9x Tribble Emulation.
Begin adding emulation of half-tile (off-grid) collision.
Fix emulationm of segmented enemy drops.
Fix crash when saving screenshots caused by filename buffer overflow. 
	( ZoriaRPG, 14th January, 2019 )

//Beta 31
Added an Emulation Menu option to enable drop-per-segment
	for Lanmola, Manhandla, and Moldorm. 
	This needs testing in older quests, and further verification.
	neither the menu option, nor the config section option
	should work in 2.50+ quests.
	( ZoriaRPG, 8th January, 2019 )
	
//Beta 30
Re-added the 'Menu' button configuration option to
	Joystick Button configs.
	( ZoriaRPG, 8th January, 2019 )
	
//Beta 29
Fixed colour issues when using DrawScreen(), DrawLayer(), 
	and FastCombo(), drawing combos with a CSet2 value.
	( ZoriaRPG, 7th January, 2019 )
	
//Beta 28
Renamed entry [0] in Emulation Menu to 'Flip-Flip Cancel and Wave Warps'
	Disabled this option if the current quest was made in 2.10 or
	( ZoriaRPG, 22nd December, 2018 )
	
Added a new menu to ZC Player: 'Emulation'. 
	This is used for enabling/disabling certain internal behaviour, when playing some
	legacy quests where it is desirable to have this option. 
	( ZoriaRPG, 21st December, 2018 )
	
//Beta 27
Fixed Ganon's HP in 1st/2nd. On the NES, he has 30, not 32.
Fixed vires splitting before their slide() ends.
Fixed MP3s with metadata not playing. 
	Let's hope that this fix doesn't fuck up 2.50.0 or 2.50.1 quests.
	( ZoriaRPG, 16th December, 2018 )

//Beta 26
Probably fixed issues that Avataro reported with Vire enemies.
	( ZoriaRPG, 3rd December, 2018 )

//Beta 25
Backported fix for crash on getWpnPressed(0 on Win10 from 2.55 to
	2.53. I'm not sure why 2.53 didn't crash from this, but, it
	surely would cause problems at some point. 
Backported the UI Widget (radio button) fixes for dark themes
	from 2.55. Let's hope thet these changes don't break
	any of the old 1.9x themes!!
	( ZoriaRPG, 21st October, 2018 )

Backport UI/Theme fixes for tooltips from 2.55
( 19th October, 2018 )

//Beta 24
Added a DARK theme, and the 2018 PureZC Autumn Expo (Halloween)
theme to ZC and ZQuest. Their gui_colorset IDs are 2019 and 201018 respectively.

Fixed Dodongo death sfx in 3rd, 5th, and 4th quests.
Rebuilt clean, fixing some stability issues when ZC and ZQ were running as
background processes.
( ZoriaRPG, 17th October, 2018 )

Fixed Dodongo death sound in 1st.qst and 2nd.qst.
	( NightmareJames, 17th October, 2018 )

Re-fixed the sound that 2.10 Dodongos (and BS Dodongos) make when they die.
The prior patch didn't work, but this one seems fine.
( ZoriaRPG, 14th October, 2018 )

//Beta 23
Fixed 2.10 Dodongo Death Sound:
	In 2.10, according to a report, Dodongos used SFX 15 for their 
	death sound. This forces their death sound (`deadsfx`) to 15, 
	to correct the problem.

	I previously thought that James was reporting the wrong screen
	ambient sound, so this commit also reverses that patch.
	( ZoriaRPG, 4th October, 2018 )

//Beta 22
Rewrote the onSaveMapPic() function to fix issues with it causing
random glitches, including screen drawing glitches while scrolling and other
issues.
	( ZoriaRPG, 4th October, 2018 )

//Beta 21
Added constants for MIN_COMBO_POS, MAX_COMBO_POS, and NUM_COMBO_POS to std.zh.
Rewrote all SetLayerCombo*() and GetlayerCombo*() function sin std.zh.
	Added std.cfg flag: SETLAYERCOMBO_ALWAYS_USE_SETCOMBO
	Setting this to '1' will force using Set/GetCombo on maps instead
	of setting or getting Screen->Combo*[] for layer 0.
	Added error logging to these functions. 
	Added TraceError() to string_functions.zh. 
Fix dodongos using the wwrong sound in 2.10 and earlier quests. 
	( ZoriaRPG, 3rd October 2018 )
	
Fixed improper warp points in 2nd.qst.
	( NightmareJames, 29th September, 2018 )
	
Added two additional levels of key files:
	.cheat: This is a ketyfile that only enables cheats for the player in ZC, but does not allow
		opening the quest in ZQuest. The questb password is hashed so that it is not visible as
		plain ASCII text in the .cheat keyfile.
	.zpwd: 	This is a keyfile that only allows editing the quest in ZQuest, but it DOES NOT enable cheats.
	( ZoriaRPG, 28th September, 2018 )

//Beta 20
Fix: Lens stealing properties of other items (e.g. sound effects); backported from 2.55. 
	( Venrob, 27th September, 2018 )
	
Backported fixes from 2.55 for:
	Sword beam/mirrors interaction (with QR).
	Wand/book costs.
	( Venrob, 26th September, 2018 )

//Beta 19
Require using Alt+Shift modifier keys in conjunction with cheat hotkeys.

//Beta 18.2
Fixed hard crash when loading an ASM script if the filename is invalid. 
Fixed input getting stuuck as if buttons were being hel down, when released.
	( ZoriaRPG, 25th September, 2018 )
	( credit also: Venrob for think-tank.)
	( credit also: Russ for testing.)

//Beta 18.1
Fixed the Cheat Menu 'Max Bombs' so that it is possible to set 
any value from 0 to 0xFFFF.

	( ZoriaRPG, 25th September, 2018 )

//Betas 16, 17, 18
Allow setting the Catchall on a room with a type of 'None'. The catchall type is 'Generic Catchall'.
Minor touch-up on qrNOGANONINTRO
Should fix: Nayru's Love decorations do not die, and will eventually wrap the screen.
Should fix: Vires freeze when struck, without split-on-hit.
	( ZoriaRPG, 24th September, 2018 )
Should fix: Lens costs rupees with infinite wallet.
Should fix: Diagonal left-down sprites on 8-way shots are mis-oriented.
Should fix: Charged hammer doesn't strike pound blocks.
Should fix: Ganon Triforce holdup when Link is jumping.
Should fix: Ganon's ashes don't fall in sideview.
	( ZoriaRPG, 23rd September, 2018 )

//Beta 15
Added a compatibility fix for DrawInteger() and DrawCharacter() for quests made
	using the old (broken) scaling factors. ( ZoriaRPG, 4th April, 2018 )

//Beta 14
Added Extra Rule for older quests so that swords with a magic cost only apply it to beams,
	and backported it to 2.53.0. 
	!! This needs to be an item editor flagset: Beams use Magic, Blade Uses Magic
Added a QR No Intro String in Ganon Rooms and backported it to 2.53.0 (beta 14)
	( ZoriaRPG, 28th March, 2018 )
	
//Beta 13	
Fixed swords not obeying magic costs. ( ZoriaRPG, 15th January, 2018 )

Added tooltips to the 'Quest Rev' and 'Min Rev' fields in the
Quest Header dialogue. 

Cleaned up Header dialogue and made the quest number visible (but disabled)
by default. Holding Right Shift while opening the dialogue makes it an editable field. 
	( ZoriaRPG, 14th January, 2018 )

Fixed 'About' version details. ( ZoriaRPG, 14th January, 2018 )

Corrected the tooltip for Slash->Item combos.

Improved efficiency of string.zh functions, and updated the docs.
	( ZoriaRPG, 10th January, 2018 )

Fixed Link->Misc[] not being divided or multiplied (internally) by 10000.
	( ZoriaRPG, 4th January., 2018 )

Applied Item Editor fix for InitD values. (They were clamped from -31768 to 327678, and
	now they are clamped between -214748.3647 and 214748.3647.
	Applied to 2.54 Alpha 22, and 2.53 Beta 12. 
	
VBound ZQuest combo editor fields: Cset to -15/+15, Aframes (0,255), ASpeed (0,255) to prevent rollover from lack
of sanity bounding. ( ZoriaRPG 16th October, 2017 )

Optimised some functions in std.zh that returned boolean values and were comparing against != 0. 
VBund ZQuest combo editor fields: Cset to -15/+15, Aframes (0,255), ASpeed (0,255) to prevent rollover from lack
of sanity bounding. ( ZoriaRPG 16th October, 2017 )

Fixed game ending sequence clipping from carrying over to another quest if ZC is reset during the ending.
Possible fix for the crash reported by Lut where scrolling through a specific pixel of the lower-left corner
of screens would crash ZC. ( ZoriaRPG, 16th October, 2017 )

Fixed a bug in std.zh where GetHighestLevelItem() would fail to return the correct values if the item IDs and levels
were not in a matched ascending order (e.g. item 16 is level 2, item 18 is level 1), and similar.
Added GetHighestLevelItemOwned() to std.zh. ( ZoriaRPG, 15th October, 2017 )

Fixed button interface commandline filenames in ZCL. Updated version to 2.6.4. ( ZoriaRPG, 15th October, 2017 )

Fixed issues with 1.84 quests.
Added possible fix for Win10 slowdown. ( Gleeok, 15th October, 2017 )

Reworded language for controller button dialogue:
The controller button input dialogue used the wording 'Use Analogue Stick Instead of Buttons', which is misleading. 
On standard USB game pads, with a DPad, ZC recognises the DPad as an analogue stick (when using Windows), and thus, 
the controller DPad buttons cannot be mapped on an individual basis. This adjusts the wording to 'Use Analogue Stick/DPad'. ( ZoriaRPG, 10th October, 2017 )

Split up ag.cfg into ag.cfg (RomView, ZCL), zc.cfg (Zelda Classic), and zquest.cfg (ZQuest) to fix some issues with 
ZC/ZQuest creating an access clash with one config file. 
Updated ZCl to use the new files. ZCL is now 2.6.3. ( ZoriaRPG, 6th Oct, 2017 )

Reverted all of the Game->SetCombo* and Game->GetCombo* functions to their 2.50.2 states. 
The revised (2.50.3) functions broke quests using these functions in a way that cannot be resolved
within the scope of the 2.50.x branch of Zelda Classic. ( ZoriaRPG, 2nd October, 2017 )

Fixed DrawInteger() displaying a value that was off by one when sprinting with no decimal places. ( ZoriaRPG, 2nd October, 2017 )

Fixed the array sizes of Game->LKeys[] and Game->LItems[] (256 to 512), and constrained the values on setting them
so that they do not overflow (roll over). ( ZoriaRPG, 2nd October, 2017 )

Added a warning when opening the debug console. ( ZoriaRPG, 1st October, 2017 )

Removed an extra constant declaration in std_functions.zh.
Changed the 'Import Script]' file selection dialogue. It now shows files with types of .zh, .zs, .zlib,
.zscript, and a few other minor typed used by the userbase, rather than solely showing '.z' files. ( ZoriaRPG, 24th September, 2017 )

Refactored the sanity checks for Game->Get/SetCombo* (except for SetComboSolid). These functions will now report
any invalid refs passed to them (invalid map, screen, position) to allegro.log and abort, or return -1 to the user. 
The prior code either allowed passing an invalid ref, or never informed the user that it was invalid. ( ZoriaRPG, 23rd September, 2017 )

Modified GetHighestLevelitem() in std.zh, to use a setting in std.cgf: This setting determines the highest item ID
that GetHighestlevelitem() will check, rather than one version stopping at 143, and another at 255. ( ZoriaRPG, 22nd September, 2017 )

Added a somewhat hackish fix for dungeon maps displaying when Link does not have them, during scrolling warps. ( ZoriaRPG, 22nd September, 2017 )

Fixed issue with NPCs behaving as if they were drunk. ( Gleeok, 21st September, 2017 )

Fixed issues with flying/floating/teleporting NPCS. ( Gleeok, 20th September, 2017 )

Slightly adjusted left and right doors in 8-way movement. ( ZoriaRPG, 20th September, 2017 )

Removed std_constants_shortcuts.zh from std.zh.
Removed extra (unintended) array 'GlobalBuggr[214747] from std.zh. 
Fixed some issues with NPCA_* constants. 
Added NPC Attribute constants for all npc types, and every field with a lister.
Fixed values for Direction to Degree and Radian conversions in std_functions and std_constants. ( ZoriaRPG )

Fixed a bug where Link's weapons hurting him, in water, would cause buggy (uncontrolled) movement or land-swimming. ( DarkDragon ) 

Fixed NES Dungeon Doors with diagonal movement. ( ZoriaRPG )

Fixed a crash when using arrow and bow subscreen objects. ( Saffith )

Updated qst.dat. Now, new quests will autosave, if you have timed save, or quest backup enabled. The error 'This quest
was created in an older version of ZQuest' will no longer appear on new quests. ZoriaRPG, 1st September, 2017 )

Applied a fix for numerous packfil_password() related problems. 
Fixed PNG saving in ZQuest. ( ZoriaRPG, 1st September, 2017 )

Re-added New favourite commands, for Quest Reports (Combo Locations, Combo Type Locations, Enemy Locations, Integrity Check
Item Locations, Script Locations, and What Links Here) to the Favourite Commands list. (This was in 2.future, but never
ported to orthodox ZQuest.) ( ZoriaRPG, 1st September, 2017 )

Fixed file selection dialogues in Zelda Classic. After selecting a quest in the Load Quest dialogue, the default button
is now 'OK', rather than browse, so hitting the enter key after selecting a file does not put you into a file select loop.
This was likewise something that I did before, but it was somehow lost in various commits. ( ZoriaRPG, 1st September, 2017 )

Unfixed buggy wizzrobe compat issue. Proper fix is still pending... ( Gleeok, 28th August, 2017 )

//Beta 7

Initial update of ZLaunch, to add a ROMView launch button.
Fixed a bug where the Tile Editor refused to load image files on the first attempt. ( ZoriaRPG, 27th August 2017 )

Fixed a crash when loading corrupt 2.50.2 (and earlier) quest data; and recompiling scripts. ( DarkDragon, 25th August, 2017 )

Fixed crash when viewing Compatibility Quest Rules. ( ZoriaRPG, 20th August, 2017 )

Fixed a bug where the lens of truth stole the script of the last item used, and ran it every frame. ( ZoriaRPG, 20th August, 2017 )

New Allegro libraries using Allegro 4.4.3, with some patches.
Fixed issues with the infinite wallet.
Fixed Link's attack not being cancelled when he is frozen.
Fixed the race condition issue with keyboard input in Allegro 4.4.3. ( DarkDragon, 13th August, 2017 )

Fixed an issue with scrolling between land and water. ( DarkDragon, 11th August, 2017 )

Fixed an issue where the subscreen did not always update, by checking item validity when changing dmaps. ( DarkDragon, 10th August, 2017 )

Reverted the quest rule for COMBOSDM. We'll come back to this, later. ( DarkDragon )
Added compatibility rule for old quests that rely on screen item pick-up disabling hunger, for old quests. ( DarkDragon, 21st July, 2017 )

//Beta 6
Added a few functions to std.zh. ( ZoriaRPG, July 2017 )

Fixed a bug in ZQuest that was corrupting ag.cfg. ( DarkDragon; and ZoriaRPG, July, 2017 )

Fixed a bug where MIDI files could not be loaded in ZQuest. ( DarkDragon, July 2017 )

Updated std.zh to 2.50.3 version, plus some rearranging in a std_zh path.
Updated all included headers to their current versions. 
Pruned some files.
Unlocked 1st.qst and 2nd.qst. ( ZoriaRPG, 11th July, 2017 )

Fixed incorrect types for CollDetection and some other boolean return variables in ZScript. 
    This includes Link->CollDetection, Link->Invisible, npc->CollDetection, lweapon->CollDetection and 
    eweapon->CollisionDetection ( ZoriaRPG, 2nd July, 2017 )

Seem to have fixed reported bug of ZC crashing if the user shifts focus when assigning joypad buttons. 
In any case, I can not replicate it in this build, and I did change a read_button function that was a bit bonkers. ( ZoriaRPG, 2nd July, 2017 )
	
ZC and ZQuest now use Allegro 4.4. (DarkDragon, 2nd July, 2017)

Fixed 3rd quest with zero deaths not going to 5th quest. ( ZoriaRPG, 20th June, 2017 )

Reverted COMBOSDM change made by Saffith, as it caused different bugs with older players. 
This is properly fixed in 2.51+. ( ZoriaRPG, 20th June 2017 )

Fixed long-standing bug where setting Link->Item every frame causes lag. ( ZoriaRPG, May 2017 )

Fixed lweapon->Behind not working. ( ZoriaRPG, May 2017 )

Fixed ffc->Link being unable to be cleared, or otherwise set to 0 ( ZoriaRPG, May 2017 )

Fixed scale args for DrawChar() and DrawInteger(): Both of these now scale per zscript.txt documentation. ( ZoriaRPG, Jan 2017 )

Zelda Classic Menus: Added Etc->Show Debug Console. This opens the Allegro debug console or closes it if it is open. ( ZoriaRPG, Jan 2017 )

ZScript Variables in scope are destroyed when their scope exits. ( DarkDragon, Jan 2017 )

Fixed long-standing keyboard issues with alt+tab, and hopefully) issues with the keyboard losing focus. (DD/Z, Dec 2016-Jan 2017)	

Added a checkbox to disable analog stick movement.
Changed joystick config dialogues to match keyboard config dialogues. 
Added more joystick options to ag.cfg. 
Small fixes to joystick input. 
Fixed minor issues in key config dialogues. ( Saffith, 18-Dec-2016 )

Additional fixes with Link exiting water. ( Saffith, 15-Dec-2016 )

Fixed an invalid read in draw_wavy(). ( Saffith, 14-Dec-2016 )

Fixed Link's position being offset improperly on continue when quakeclk > 0. 
Ensure overscan rectangle is black while the screen is shaking. 
Fixed an issue with Link exiting water. 
Fixed Stone of Agony sensitivity. ( Saffith, 11-Dec-2016 )

Fixed an issue where bitmaps may be drawn improperly based on ZQuest version. 

Fixed incorrect screen calculation and possible crash in warp with combos that carry over. ( Saffith, 6-Dec-2016 )

Global script OnExit now works. In prior versions, this script did not run. 

Fixed a crash when loading a sfx file with more than 35 chars or without any extension. ( Gleeok, 2015-12-30 01:05:05 )

Fixed negative constants being read incorrectly.
Fixed incorrect screen calculation and possible crash in Game->SetComboSolid(). ( Saffith, 2015-12-19 19:41:38 )

Fixed a crash when importing combos. ( Saffith, 2015-11-27 09:30:31 )     

Replaced the built-in MIDIs with versions edited by zaphod77 to sound more like the NES game. ( Saffith, 2015-10-14 10:41:20 )

//!! Older Versions
//!! What follows are the old Shardstorm.com SVN log entries for 2.50.2 and earlier. 

//2.50.2
Build 1793 - linux , windows
* Not a new build, just a launcher update. ( Saffith, 2015-10-13 22:54:03 )

* Fixed a couple of issues with moldorms.
* Fixed some errors in zscript.txt. ( Saffith, 2015-10-13 09:51:14 )

* It's now possible to scale up ZQuest in large mode. This hasn't been extensively tested, but it seems to work fine. Keep in mind that it runs at multiples of 800x600, so the next size up is 1600x1200.
* Fixed an issue with using -fullscreen and -scale arguments together. ( Saffith, 2015-10-11 19:44:50 )

* Reworked mass combo creation (what happens when you select multiple tiles and press M). ( Saffith, 2015-10-11 18:51:32 )

* Added a mass recoloring tool to the tile editor. ( Saffith, 2015-10-11 11:37:23 )

* When a script hangs the game, it's now possible to rest or quit with F9 and F10 (F7/F8 on Mac). These are the only options; the menu still won't open, and F6 won't work.
* Fixed an issue with drawing after Waitdraw() while scrolling.
* Drawing transparent text should work correctly now. ( Saffith, 2015-09-28 13:25:16 )

* Alt+click will now select a combo. You can also hold shift to select the CSet and ctrl to scroll to the combo. ( Saffith, 2015-09-24 21:31:19 )

* Fixed half-solid lock blocks not always unlocking.
* Fixed some issues with walking enemies firing weapons on death.
* Projectile shooters will no longer shoot at Link if he's too close.
* Shooters that fire single fireballs will once again fire double shots occasionally. ( Saffith, 2015-09-10 19:56:31 )

* Fixed some long withstanding relative and absolute path bugs in ZC when loading from save files. You can move things like quests and save files around now without ZC freaking out about it. ( Gleeok, 2015-07-15 00:40:42 )

* Enter "JEAN" at the name select screen to play the 5th quest. ( Gleeok, 2015-07-09 20:44:13 )

* Added the 5th quest winning contest entry bu BigJoe. Congrats and thanks again to everyone who participated!
* Beating the 3rd quest without dying will let you skip straight to the 5th quest, and beating the 5th quest without a perfect no-death game will drop you to the 4th quest. ( Gleeok, 2015-07-09 18:51:23 )

* After changing screens while walking against a conveyor belt, Link will not immediately be pushed back to the previous screen.
* Added a right-click menu to copy and paste level palettes. ( Saffith, 2015-07-07 08:40:15 )

* Added a compatibility rule allowing weapons with collision detection disabled to move offscreen. ( Saffith, 2015-06-12 13:19:44 )

* Fixed itemdata->Keep and itemdata->MaxIncrement compiling incorrectly.
* Fixed subscreen items jumping when scrolling from sideview to top-down. ( Saffith, 2015-06-04 10:42:53 )

* Fixed weird values of Link->Jump above about 3.2. ( Saffith, 2015-05-29 13:51:13 )

* Added more information when script errors are logged. ( Saffith, 2015-05-19 20:57:11 )

* Added an even faster screen scrolling option. Name pending.
* Fixed the 'correct offset eweapon collision' rule, which was a bit tricky. Firstly, the toggling of this rule may have swapped behavior sometime after build 400, or just stopped working altogether, or both. Secondly, this is now enabled for compatibility reasons in all older quests. ( Gleeok, 2015-05-19 06:11:53 )

* Fixed an issue with the "Continue With Full Life" rule in old quests not working correctly.
* Grabbing tiles from a pre-2.50 quest will no longer clear combo aliases. ( Saffith, 2015-05-10 16:49:59 )

* Using an invalid index with Link->Item[] will no longer crash the game.
* Game->SetDMapEnhancedMusic() will no longer reset the DMap's subscreen. ( Saffith, 2015-05-10 15:13:11 )

* Fixed some issues with wealth medals. ( Saffith, 2015-05-10 11:59:24 )

* Scripts can now save only once per frame per script. This prevents while(true) Game->Save(); from nearly guaranteeing a corrupted save file. ( Saffith, 2015-04-12 15:38:19 )

* Fixed a bug where scripts drawing to bitmaps before drawing to a screen layer un-offset the sub-screen offset causing them to be rendered in wrong position on screen. ( Gleeok, 2015-03-25 09:43:09 )

* Users Choice Award winner of 2014 is in: "Dmaps Spam'd" - Now you have the ability to Copy/Paste Dmaps in the Dmap dialog with the usual keys 'C' and 'V' respectively. ( Gleeok, 2014-12-12 23:08:38 )



Build 1703 - linux , macosx-Tiger-and-Leopard , windows
* Let's try this again... ( Saffith, 2014-10-05 08:49:40 )



Build 1700 - linux , macosx-Tiger-and-Leopard , windows
* Red potion or heart container rooms will no longer be usable repeatedly when not in caves. ( Saffith, 2014-10-01 20:26:28 )

* The "Items Disappear During Hold-Up" rule no longer stops guys in special item rooms from disappearing when the item is taken. ( Saffith, 2014-10-01 10:46:26 )

* The screen saver is now disabled by default. ( Saffith, 2014-09-27 23:04:17 )

* Weapons with collision detection disabled can no longer move offscreen without limit. ( Saffith, 2014-09-27 21:36:07 )

* Fixed vires being knocked back too fast and sometimes splitting in the wrong place.
* Fixed some issues in new quests.
* Updated the credits. ( Saffith, 2014-09-27 15:22:28 )

* Since the string editor's "Duplicate" button is no longer needed, it's been replaced with a button to add a new string after the one currently selected.
* Clicking a text field in large mode should now put the cursor in the right place. ( Saffith, 2014-09-27 10:00:07 )

* Added a right-click menu to the string editor with options to copy and paste a message's style.
* It's now possible to select a message to use as a template when adding a new one. ( Saffith, 2014-09-26 21:44:37 )

* Added a right-click menu with copy and paste options to the enemy and item editors. ( Saffith, 2014-09-26 11:08:52 )

* Corrected the way ZC selects directories to search for music files. ( Saffith, 2014-09-22 21:38:43 )

* Setting Link->Action will now remove Link from whirlwinds and cancel Farore's Wind if the casting hasn't finished. ( Saffith, 2014-09-22 16:27:00 )

* In the subscreen editor, editing an object's properties will now affect all selected objects of the same type. This attempts to behave intelligently and only copy properties you would want applied to multiple objects. For instance, the heart container number of a life gauge piece or the text of a text object will not be copied.
* Added copy and paste properties options to the right-click menu, which behave in the same way.
* Also, canceling out of the properties dialog when creating a new subscreen object will now cancel the creation of the object. ( Saffith, 2014-09-04 16:25:27 )

* Sped up the spawning of traps a bit. ( Saffith, 2014-09-01 09:47:19 )

* Tweaked the tile grabber's recolor algorithm. ( Saffith, 2014-08-31 17:03:00 )

* Fixed a crash when shifting blocks of tiles at the beginning or end of the tile buffer. ( Saffith, 2014-08-31 13:07:53 )

* In the tile grabber, you can now press 4 or 8 to switch between grabbing tiles as 4-bit or 8-bit.
* You can also press Shift+R or hold Shift while clicking the Recolor button to recolor in 8-bit mode. ( Saffith, 2014-08-30 19:10:05 )

* Items of type Bow and Arrow and Letter or Potion can no longer be made equipment items.
* Improved compatibility with ID3-tagged MP3s. ( Saffith, 2014-08-27 12:22:25 )



Build 1669 - windows
* Fixing the Windows build; the last few changes weren't included before. ( Saffith, 2014-08-27 08:30:48 )



Build 1667 - linux , macosx-Tiger-and-Leopard , windows
* 2.50.1 RC3 ( Saffith, 2014-08-26 19:36:05 )

* Link can no longer turn around while charging the hammer.
* Timed saves will no longer fail for new quests. ( Saffith, 2014-08-24 16:14:59 )

* Hopefully fixed the issue where the GUI occasionally stops responding to the keyboard. ( Saffith, 2014-08-23 23:08:32 )

* Made a change to input reading in hopes of fixing screen saver issues. ( Saffith, 2014-08-21 10:54:13 )

* Fixed a few issues with favorite combos and aliases. ( Saffith, 2014-08-18 08:47:50 )

* Improved Link's interaction with damage combos in sideview. ( Saffith, 2014-08-17 23:00:28 )

* The Cane of Byrna will no longer continue running when it's removed from Link's inventory.
* Canceling out of the Link sprites dialog works correctly now. ( Saffith, 2014-08-17 14:12:37 )

* Improved selection of item-carrying enemy when unbeatable enemies are around. ( Saffith, 2014-08-17 13:06:45 )

* Fixed Screen->DrawInteger(). ( Saffith, 2014-08-17 12:49:19 )

* The "Lens Shows Raft Paths" quest rule now includes raft bounce flags.
* Fixed an issue with letter/potion slots not being selectable in the subscreen editor. ( Saffith, 2014-08-03 16:10:12 )

* Saving a map with F5 now follows the same rules as viewing the in-game map in deciding which screens to include. ( Saffith, 2014-08-03 15:39:02 )

* Loading and saving an old quest using the "Continue With Full Life" rule no longer leaves that rule permanently enabled. ( Saffith, 2014-07-31 10:21:14 )

* Fixed an issue with the trigger enemy loading incorrectly in the editor. ( Saffith, 2014-07-23 10:03:43 )

* Reverted the change that fixed push blocks leaving pushable under combos, since that caused other problems. ( Saffith, 2014-07-23 08:41:03 )

* [ZCL] Cosmetic Fixes ( Sean, 2014-07-01 20:07:26 )

* [ZCL] Added some pretty icons to the sub tabs. - Deviance ( Sean, 2014-07-01 19:38:28 )

* [ZCL] Finished saffith's implementation of the multiple instances for ZC option for ZCL -Deviance (Sean) ( Sean, 2014-07-01 18:49:33 )

* ZCL's source updated to the latest Lazarus build.
* Tnotebook property was removed from the newer Lazarus builds thus breaking the source code. Has been replaced with the TPageControl property instead thus making the source code working again.
* More to come ;) -Sean ( Sean, 2014-07-01 18:14:05 )

* Fixed magic sometimes not triggering flags on magic-blocking combos. ( Saffith, 2014-04-29 20:45:21 )

* Link can buy free items and info again. ( Saffith, 2014-04-29 20:06:23 )

* Fixed a script drawing crash when attempting to draw a bitmap with out-of-range source rectangle arguments. (Bad Zecora, bad. No treat for you!) ( Gleeok, 2014-04-08 00:43:19 )

* Added new project directories for Visual Studio and C::B projects. ( Gleeok, 2014-03-13 15:26:05 )

* Fixed an issue with enemies spawning in incorrect location. ( Saffith, 2014-02-13 07:40:46 )

* Peahats are invincible while moving again. ( Saffith, 2014-02-07 13:16:12 )



Build 1634 - linux , macosx-Leopard , windows
* 2.50.1 RC 2 ( Saffith, 2014-02-04 20:40:07 )

* Blocks with two push flags should no longer make under combos pushable. ( Saffith, 2014-02-04 19:04:44 )



Build 1632 - linux
* Hopefully fixed some issues with tracker files playing incorrectly. ( Saffith, 2014-02-04 13:02:23 )

* Added a compatibility rule to make peahats vulnerable when frozen by clocks.
* Also fixed an issue with their behavior when that rule is disabled.
* Adjusted patra orbiters' hitboxes.
* (None)-type subscreen objects no longer have editable properties from every other object type. ( Saffith, 2014-02-04 09:52:05 )



Build 1629 - linux
* Again, ignore the download link. It's not a new build.
* It's possible to run multiple instances of ZC again with the -multiple command line argument.
* FFCs placed via the right-click menu should no longer appear in the wrong place.
* The compiler will now provide filenames when reporting lexical errors. ( Saffith, 2014-02-03 13:23:51 )



Build 1628 - windows
* Ignore the download link; this isn't a new build.
* Enabling the quickload option in the launcher should work correctly now. ( Saffith, 2014-02-03 09:58:41 )

* Fixed an issue with push blocks with both secret-triggering and silent flags.
* Opening locked chests will no longer open unlocked chests on the same screen.
* Link will no longer become invisible if picked up by a whirlwind while using the hookshot. ( Saffith, 2014-01-31 16:54:44 )

* Fixed some issues in the 4th quest.
* Importing DMaps should work again.
* Fixed a crash when changing music tracks in ZQuest.
* Moving Link while on a fairy ring flag should no longer cause him to be permanently stuck. ( Saffith, 2014-01-31 08:31:10 )

* The reset and quit functions have been moved from F7 and F8 to F9 and F10.
* F6 is now disabled when the "Skip Continue Screen" rule is enabled. Game > End Game still works.
* Enemy shields should no longer block ignored weapons. ( Saffith, 2014-01-31 06:31:29 )

* Fixed an issue where changing Link->Action might leave his sword stuck in place.
* Fixed float-to-text functions in string.zh.
* Added BPAL_DODONGO to std_constants.zh. ( Saffith, 2013-11-29 10:48:08 )

* Hopefully fixed the problem with clicking at the ends of sound effects. This was a quest saving and loading issue, so any sounds already affected will need to be reloaded. ( Saffith, 2013-11-23 17:01:47 )

* Possibly fixed the screen-saver idle freeze bug.
* Added "ss_enable=1" to the config file. ( Gleeok, 2013-09-08 15:09:51 )

* Fixed a 60 FPS/CPU usage issue on various windows platforms. ( Gleeok, 2013-09-08 14:14:05 )

* Fixed price alignment when an item has a price of 0. ( Saffith, 2013-09-06 12:18:41 )

* Improved speed while palette cycling is active. ( Saffith, 2013-09-05 21:16:00 )

* Fixed Link being unable to enter water in some places. ( Saffith, 2013-09-04 21:41:26 )

* Fixed an issue with Link->Equipment when arrows are selected.
* Here are the major changes in 2.50.1 RC1, since I failed to list them before.
* Crashes fixed:
* - Enemy has "Breath" firing type but no weapon
* - Warp with wavy effect while the screen is shaking
* - Too many drawing commands used in one frame
* - Tribble carrying an item
* - Parts of segmented enemies are killed in unexpected ways
* - Selecting an item
* Compatibility changes:
* - Adjusted the hammer's hitbox
* - The hookshot can pass downward through a solid combo in old quests
* - Adjusted the hookshot's grab point in old quests
* - Overworld DMaps can be offset in old quests
* Other problems fixed:
* - Other-type enemies can have bomb blast weapons
* - Clocks no longer make Peahats vulnerable
* - Tile select screens that should allow flip always do so now
* - Quest->Defaults->Map Styles now resets map styles instead of tiles
* - Fixed some errors in the first and second quests
* - After loading a quest, it no longer lists the scripts from the previously loaded quest
* - Link can no longer through pushed blocks
* - Fixed item scripts sometimes being unable to set ffc->Script
* - Wizzrobes should no longer get stuck in the corner
* - The hookshot and raft work better in sideview now
* - Fires created by scripts no longer permanently light the room when the temporary lighting rule is enabled
* - Five-digit string control code arguments should now be read correctly
* - Inherent flag 10 on pound combos works now
* - The info type editor should now handle reordered strings correctly
* - Fixed the Bow & Arrow item class not displaying the items' names
* - Fixed some bugs in std.zh
* - Fixed possible graphical corruption on the file select screen
* - Rocks' misc. attributes are displayed correctly now
* Other changes:
* - Only one instance of ZC may run at a time (Windows and Linux only so far)
* - Added a compatibility rules dialog
* - The game window doesn't close until it's finished saving
* - Added an optional save indicator
* - Added help text for the Bow & Arrow and Letter Or Potion classes and made it clearer that they shouldn't be assigned to items ( Saffith, 2013-09-04 08:51:59 )



Build 1608 - linux , macosx-Leopard , windows
* 2.50.1 RC 1 ( Saffith, 2013-07-29 13:08:26 )



Build 1606 - linux , macosx-Leopard , windows
* Updated build number and date.
* Set IS_BETA to 0. ( Saffith, 2012-12-21 07:47:07 )

* Fixed Moldorms and Lanmolas never returning after only one segment was destroyed. ( Saffith, 2012-12-20 12:59:38 )



Build 1586 - linux
* Reverting patches.dat (really shouldn't have changed it in the first place). If this creates a download link, ignore it; it won't be a new build. ( Saffith, 2012-12-19 21:35:04 )

* Fixed a bug that allowed Link to jump through solid combos.
* Fixed mouse position handling in ZScript.
* Fixed a couple of issues with whistle whirlwinds.
* String control codes should no longer cause the message preview to show extra characters.
* String control codes can now take five-digit arguments, up to a maximum of (I think) 65278.
* Made the hidden counters usable; script counters now go up to 25. ( Saffith, 2012-12-19 21:13:20 )

* Fixed crashes when passing invalid maps to Game->SetScreenState and Game->GetScreenState.
* Fixed blue leevers appearing simultaneously when the BS-Zelda Animation rule is enabled.
* Life meters should no longer revert to two rows whenever a quest is reloaded. ( Saffith, 2012-12-18 12:58:09 )

* Fixed boomerangs and hookshots not reflecting weapons correctly.
* Weapons and miscellaneous sprites should now update when their tiles are moved. ( Saffith, 2012-12-18 07:43:06 )

* Fixed an issue with stepping on a fairy flag while charging a spin attack.
* Made Link a bit less picky about scrolling onto raft flags. ( Saffith, 2012-12-17 18:52:14 )

* Hopefully fixed a possible hang when terminating the screen saver.
* Fixed some issues with the active ring color not updating when it should.
* Fixed rafting between screens in dungeons. ( Saffith, 2012-12-13 09:37:04 )

* Fixed an issue with drawing FFCs that wrap around the edge of a tile page.
* Fixed a possible crash in ZQuest when displaying side warp info. ( Saffith, 2012-12-07 10:18:49 )

* Fixed certain enemies gettins stuck at the edge of the screen.
* Fixed Aquamentus sometimes walking in one direction forever.
* Fixed an issue with the ladder on half-solid tiles.
* Fixed a problem that could unload MIDI patches on some Windows systems.
* Changing the title screen type no longer resets the game. ( Saffith, 2012-12-04 10:05:58 )

* Added a couple of shops missing from the second quest.
* Whether rupees already being drained can be used is now controlled by a quest rule.
* Lanmolas and Moldorms now have an attribute that determines whether each body segment drops an item.
* Fixed some issues in the shop and info editors.
* Shop prices can now be set up to 65535 rupees.
* Added Game->GetFFCScript(). ( Saffith, 2012-11-20 12:58:30 )

* Peahats are now vulnerable when frozen by clocks. ( Saffith, 2012-11-18 23:06:47 )

* Fixed a bug that could make Ghinis immobile.
* It's no longer possible to use Game > End Game to get out of a door repair charge.
* Added Game->DMapMap[]. ( Saffith, 2012-11-17 14:41:27 )

* Unbroke the ladder.
* Fixed splitting enemies background sounds. ( Saffith, 2012-11-15 07:24:32 )



Build 1571 - linux , macosx-Leopard , windows
* 2.50 RC5 ( Saffith, 2012-11-04 17:30:55 )

* Fixed some issues with the ladder when diagonal movement is enabled.
* Added functions to get the current screen's side and tile warp data. ( Saffith, 2012-11-04 14:26:25 )

* Fixed music not playing in ZQuest.
* Expanded enhanced music filenames to 255 characters. This affects scripts using enhanced music functions.
* Script import statements can now use either / or as a path separator on all platforms. ( Saffith, 2012-11-03 10:32:20 )

* Fixed the "Is continuation of previous string" flag.
* Fixed Link getting stuck going through walk-through walls. ( Saffith, 2012-10-30 20:39:53 )

* Hopefully fixed issues with enemies walking offscreen.
* Added Game->DMapOffset.
* Added functions to std.zh to convert between map and DMap coordinates. ( Saffith, 2012-10-26 22:55:28 )

* Fixed a crash when leeching tiles.
* Fixed joystick index and scanlines.
* Multiple whistles with different warp rings now work correctly. ( Saffith, 2012-10-11 09:14:57 )

* Split std.zh into multiple, smaller files to make them more easily peruse-able. There is no need to have to alter scripts that import std.zh. ( Gleeok, 2012-10-03 00:08:12 )

* Fixed a bug with DrawLayer not drawing layer 6 correctly. ( Gleeok, 2012-10-02 23:53:32 )

* Removed the map and screen flipping functions, as they were extremely buggy and not that useful.
* Added the ability to paste a screen's palette.
* Fixed Paste to All not pasting CSet data. ( Saffith, 2012-09-26 22:14:40 )

* Fixed 1st-4th quest handling. ZC will now allow them to be in either the ZC directory or the quest directory.
* Fixed an issue with DMap intros when Link arrives via whirlwind.
* Wizzrobes' misc. attribute 4 now controls whether teleporting wizzrobes can appear on solid combos. This is enabled for old quests.
* Palette cycling no longer functions in ZQuest when interpolated fading is disabled.
* Fixed an issue that could stop projectile shooters from spawning. ( Saffith, 2012-09-25 11:00:37 )

* It's no longer possible to buy items with rupees that are already being drained away.
* Fixed a problem with large sprites using incorrect tiles.
* Drawing transparent ellipses on offscreen bitmaps works now.
* Added Link->SelectAWeapon() and Link->SelectBWeapon(). ( Saffith, 2012-09-23 13:03:38 )

* Fixed the sword sometimes failing to hit Like-Likes from the inside.
* Fixed a warp arrival issue that could break some quests. ( Saffith, 2012-09-13 22:19:45 )



Build 1558 - macosx-Leopard , windows
* RC4 with the support files fixed. These zips do not incorporate Saffith's latest changes (below) ( DarkDragon, 2012-08-26 14:08:08 )

* Fixed ZQuest sometimes showing solidity incorrectly.
* Solid damage combos no longer function in quests made before those were implemented.
* Adjusted bombs' flag-triggering area.
* The bomb, super bomb, and key counters are no longer capped at 255. ( Saffith, 2012-08-25 07:30:57 )



Build 1555 - linux
* Rebuilt RC4 for Linux to fix a mistake in linking. If the previous build worked, you don't need this one. ( Saffith, 2012-08-24 08:00:59 )

* Shardstorm scripts fixed ( DarkDragon, 2012-08-23 14:52:31 )

* More testing ( DarkDragon, 2012-08-23 14:50:21 )

* Test of the Shardstorm scripts ( DarkDragon, 2012-08-23 14:45:37 )



Build 1550 - linux , macosx-Leopard , windows
* This is RC4. Again, the links won't work, so check the forums. ( Saffith, 2012-08-18 20:11:50 )

* Fixed a crash when opening certain old quests in ZQuest.
* Fixed some hitbox issues.
* New quests will no longer have weird combo cycling set up. ( Saffith, 2012-08-18 10:29:50 )

* Fixed Link walking a pixel too far into a new screen in dungeons. ( Saffith, 2012-08-16 20:34:46 )

* Improved Link's behavior with walkable water. ( Saffith, 2012-08-15 13:39:30 )

* Guy fires and fairy guys will now continue to animate during messages if the Messages Freeze All Action quest rule is enabled.
* Added ZScript variables to handle moving blocks and under combos.
* ZC will now treat a 0 byte save file as a new file rather than an invalid one. ( Saffith, 2012-08-14 09:16:32 )

* Fixed a couple of errors in std.zh.
* ZC now checks for the 1st-4th quests in the quest directory rather than the game directory. ( Saffith, 2012-08-12 20:13:41 )

* In the palette editor, you can now drag colors between CSets. Ctrl+click to swap, Ctrl+Shift+click to copy. ( Saffith, 2012-08-08 16:08:47 )

* The timed warp timer will now pause when the screen is frozen.
* In the tile editor, you can now use Alt+plus/minus to shift colors in 8-bit tiles by a full CSet. ( Saffith, 2012-08-06 12:34:03 )

* Fixed tile flipping sometimes ignoring tiles in rectangle select mode.
* Rotating tiles now affects all selected tiles.
* In the CSet editor, you can now rearrange colors by pressing Ctrl+left/right or clicking and dragging. ( Saffith, 2012-08-04 13:07:20 )

* Corrected the size of subscreens in ZQuest's large mode.
* Adjusted when subscreens are updated during certain warps. ( Saffith, 2012-08-03 23:14:58 )

* Fixed BS Patra's hitbox.
* In the tile editor, you can now press ctrl+plus or ctrl+minus to shift the selected pixels' colors up or down by one. Hold shift and transparency will be ignored. ( Saffith, 2012-08-03 18:21:47 )

* Fixed Mapmaker crash on OS X. ( Saffith, 2012-08-01 15:09:25 )

* Fixed text wrapping when a message is skipped by pressing B.
* Added Game->ClickToFreezeEnabled. ( Saffith, 2012-07-29 08:35:31 )

* Updated zscript.txt: -- New zscript.txt format for 2.5. This will allow zscript documentation to be put into a nicer doc/html/pdf etc.. format in the future. ( Gleeok, 2012-07-26 19:31:30 )

* Hopefully fixed a bug where Link's sprite and hitbox could become misaligned.
* Fixed blank slots appearing in the FFC script list.
* Added Game->LastEntranceDMap and Game->LastEntranceScreen. ( Saffith, 2012-07-26 09:19:11 )

* Fixed tiles not redrawing correctly after overlaying a tile over a blank one.
* Fixed boomerang movement when made to bounce by a script.
* Added opacity constants for drawing commands to std.zh. ( Saffith, 2012-07-24 09:23:51 )

* FFCs will now be drawn on the correct layer again.
* Link will now stop charging his sword when picked up by a whirlwind.
* Enemies that leave fire trails should no longer leave lots of fires when knocked back.
* Added copy and paste functionality to the string editor.
* Added Game->ShowSaveScreen() and Game->ShowSaveQuitScreen(). ( Saffith, 2012-07-22 17:29:26 )

* Stairs will no longer trigger if no combo is set.
* Added a new command line argument, -standalone <quest>. This will run ZC using the given quest and a single save slot.
* Added Game->Standalone.
* Added another command line argument, -notitle. This will always skip the title screen, even when resetting. ( Saffith, 2012-07-21 13:54:41 )

* Fixed some age-old combo cycling bugs. ( Saffith, 2012-07-19 12:03:37 )

* Door repair rooms will no longer function more than once.
* Fixed an error in std.zh. ( Saffith, 2012-07-18 19:41:58 )

* Fixed Armoses walking upward through solid objects when first activated.
* Fixed spinning tiles spawning incorrectly on entering a screen.
* Fixed slowdown when using a Lens of Truth with a large radius.
* Fixed a bug that could cause unvisited screens to be shown on dungeon maps.
* Added misc. attribute labels for enemies that didn't have them yet. ( Saffith, 2012-07-08 10:22:57 )

* Increased the maximum usable combo aliases to 2048. Pro Tip: Don't use them all for trees! :P
* Added Import and Export Combo Aliases functionality in the File->Import/Export Menu. ( Gleeok, 2012-06-11 01:06:28 )



Build 1527 - linux , windows
* Launcher update. Disregard the links. ( Saffith, 2012-06-04 09:25:41 )

* Fixed a compatibility bug where ladder-only combos were broken in 2.10 and allowed the hookshot also ( Gleeok, 2012-06-03 21:26:19 )

* std.zh: Added Clamp(x,min,max) as a sane alternative to VBound() which takes the arguments backwards. Aaaah! ( Gleeok, 2012-05-25 22:12:16 )

* Added npc->Hunger and npc->BreakShield(). ( Saffith, 2012-05-25 17:24:54 )

* std.zh: Fixed a bug with Round(). Added boolean utility functions IsOdd(int), and IsEven(int); ( Gleeok, 2012-05-23 19:12:19 )

* ZQuest: Implemented a new feature in the Graphics->Edit Door Combo Set Dialog: Now holding down shift and clicking "Auto" will, in addition to the normal auto behavior, auto-generate all the door types based on what you have set for the "Passage" door combos. Right now this duplicates the passageway set, which can still save a lot of time editing these.
* ZQuest: Added two new menu functions: Import/Export Guys. This will allow you to save and load the Enemy List as set up in the Enemy Editor. ( Gleeok, 2012-05-22 16:39:18 )

* Fixed the bug where setting Link->Dir while attacking would make the sword sprite vanish. ( Gleeok, 2012-05-21 21:06:13 )

* Fixed a possible crash when Link's weapons go offscreen.
* Fixed screen state carry over to the same screen on the previous map not working.
* Raised the limit on the number of heart and magic containers that can be set via cheats. ( Saffith, 2012-05-19 20:39:35 )

* FFCs will now respond to the same changer repeatedly after wrapping around the screen.
* Fixed incorrect screen calculation in Game->Guys[].
* Reorganized the item editor's pickup tab a bit. ( Saffith, 2012-05-18 14:09:12 )

* Fixed bookmarking strings with --
* Rewrote the tile recoloring code, hopefully fixing some of its bad color choices. ( Saffith, 2012-05-14 13:26:35 )

* Fixed the longstanding "skip y" combo animation bug. Fun fact: This has actually been "fixed" three times before, so due to it's ever changing undefined behavior no backwards compatibility for this broken feature is given If you have used this previously.
* Fixed a possible truncation when setting animation frames to large numbers. ( Gleeok, 2012-05-13 19:11:07 )

* Increased the maximum editable and usable enemies in the Enemy Editor from 256 to 512. Now there is no fear of running out of free enemy slots to customize! This changes the way quests are saved so once again you cannot open them in older versions.
* Now when updating quests to 2.5, the unused enemy default names are updated to use newer naming convention so there are no problems with list ordering in the Enemy Editor.
* ZC: Added "vsync" option to the config file. This generally shouldn't be needed, however it may fix some rare screen tearing issues on some hardware. ( Gleeok, 2012-05-12 19:02:17 )

* Fixed possible crashes when trying to load music files with long filenames.
* Link->PressMap works now.
* Game->GetScreenFlags and Game->GetScreenEFlags now correctly expect map numbers to start at 1. ( Saffith, 2012-05-12 07:52:19 )

* ZQuest: Fixed the bug where only one combo could be inserted or removed. Now pressing 'I' or shift-I properly inserts or removes a number of combos as what you have currently selected. ( Gleeok, 2012-05-09 23:25:37 )

* Fixed a bug where a crash can occur while using the 'grab' option in the tile pages, or possibly any other place where memset is used on potentially unallocated memory. ( Gleeok, 2012-04-28 05:04:36 )

* Now FFCs created or pasted with the right-click menu are initially placed 'snapped-to-grid'. This is more intuitive and requires less dragging of FFCs. ( Gleeok, 2012-04-28 02:16:09 )

* Added copy/paste functionality to the Enemy Editor. !
* Added "force_exit" to the config file to fix a rare bug where allegro may hang after being closed. ( Gleeok, 2012-04-28 01:09:37 )

* ZC EARTH DAY UPDATE. Making the Earth a greener place one CPU cycle at a time.
* Added a "frame_rest_suggest" option to the config file. What this does is suggest to ZC what argument to use when putting the main thread to sleep. This should alleviate the 100% CPU bug in most cases (I hope). For most users the default value should be sufficient. ( Gleeok, 2012-04-18 19:55:34 )

* In the combo editor, it's now possible to change a combo's tile by 20 (one row) by pressing Ctrl + Shift + [+]/[-].
* Pasting combo solidity works correctly now.
* Added Link->Flip to complement Link->Tile.
* Fixed an incorrect error message in Game->GetMessage().
* Fixed an error in GetMessage() in std.zh. ( Saffith, 2012-04-13 07:19:58 )

* Fixed a problem that could cause moldorms to move offscreen. ( Saffith, 2012-03-10 15:52:12 )



Build 1497 - linux , windows
* Disregard the links again.
* Timed saves and automatic backups can now be disabled in the launcher.
* Added Link->Tile, which is effectively read-only (it can be set, but it'll be reverted before it would make a difference).
* Successful timed saves no longer prompt you to click OK. ( Saffith, 2012-03-08 16:37:52 )

* Reverted a change that hurt the game's framerate on many systems. ( Saffith, 2012-03-08 07:19:46 )

* Damaging boomerangs and hookshots should no longer hit enemies repeatedly.
* Fixed another issue with the subscreen cursor disappearing.
* The cursor should now initially appear over the A button item if nothing is assigned to B. ( Saffith, 2012-03-05 22:37:27 )

* It is now possible to change CSets in combo alias mode. This works differently than in other drawing modes; only the current alias is affected, and it resets when a new one is selected.
* Fixed Farore's Wind making Nayru's Love's sound effects loop forever. ( Saffith, 2012-03-04 08:55:10 )

* Added a joystick index option to the config file in ZC so you can specify which gamepad id to use if you happen to have a bunch of those things plugged in. ( Gleeok, 2012-02-29 22:04:30 )

* Disabled by default the win_proc arguments in the config. This fixes some crash problems.
* Fixed the scanlines resolution scaling bug.
* Fixed the numerous DrawLayer() and DrawScreen() bugs. It should now draw, rotate, and not crash on invalid map sceens as expected. ( Gleeok, 2012-02-28 17:23:57 )



Build 1489 - linux , windows
* This is 2.50 RC3. These links won't work; check the forums instead. ( Saffith, 2012-02-26 15:13:03 )

* The "Cool Opening/Closing Wipes" rule has been renamed "Circle Opening/Closing Wipes" and uses a circle wipe like it did in 2.10.
* The Super Mario All-Stars type wipe now has a separate rule, as do the previously inaccessible triangle and oval wipes. If more than one rule is enabled, wipes will be chosen randomly. ( Saffith, 2012-02-24 11:43:18 )



Build 1485 - linux , windows
* Same thing again. ( Saffith, 2012-02-23 09:38:26 )



Build 1484 - linux , windows
* Updating the launcher with new resolution options. Again, not a new build, ignore the links. ( Saffith, 2012-02-21 12:39:47 )

* The compiler should now give a line number for lexical errors. ( Saffith, 2012-02-21 08:39:06 )

* ZC: Enlarged the AG Logo to better fit the selected screen resolution.
* ZC: Fixed a bug where the input resolution settings might of been altered from the config file.
* ZC: Deprecated the "sbig" and sbig2" arguments. These now do nothing as commands and are removed from the config file.
* ZC can now be opened in any arbitrary sized screen, and will now properly scale the graphics by integral values to match the window resolution based on a "best fit" policy. For example: 1600x1200 will fit exactly inside the window the equivalent of a pixel-scale x5, whereas a screen resolution of 1600x797 will scale by 3 and center the playable area of 960x720 within the window with a surrounding black border. To put it another way, this is basically the same as a "preserve aspect ratio" flag on a resizable window. I hope this makes sense. &_& ( Gleeok, 2012-02-21 04:14:20 )



Build 1478 - linux , windows
* Disregard the links. This isn't a new build, and they probably don't work, anyway. ( Saffith, 2012-02-20 11:23:39 )

* Large Mode: enlarged the Combo Aliases Editor. Also, fixed the font for Item Editor buttons. ( _L_, 2012-02-17 05:09:20 )

* A trapped enemy's fire breath will no longer come from the top-left corner of the screen. ( Saffith, 2012-02-12 18:31:28 )

* Sideview: Fixed the bug where enemies sometimes start moving into the ground after falling more than 2 combos' distance.
* Item Editor: Added a 'Falls in Sideview' checkbox to Din's Fire, which is on for all prior quests. To be honest I can't recall if the 'flattened sideview Din's Fire' was originally a bug or a thing I thought was appropriate for the side-on perspective, but now you can toggle it.
* Item Editor: Fixed the bug where the 'Defaults' button wouldn't default the right-most flag checkboxes.
* Enemies with a Summon (Layer) attack will now stop summoning when there are 40+ enemies onscreen, rather than 200+. This is the same as the current limit for the standard Summon shot type. ( _L_, 2012-02-12 02:10:27 )

* Updated std.zh. Also since pivot rotation and x,y scaling arguments are not consistent across all script drawing and other vector or 2D functions, I've added the following functions to std.zh: RotateScalePointX(), RotateScalePointY(), ScalePointX(), ScalePointY(), RotatePointX(), RotatePointY(). ( Gleeok, 2012-02-11 21:31:21 )

* Fixed a bug where file save dialogs used the wrong font in Small Mode.
* New Default: Fixed the Walk-through Walls markers in all of the Door Combo Sets, and fixed the 'Auto' button's visual dimensions and responsiveness.
* Large Mode: Added tooltips for the eight buttons in the main panel and the Enemies pane.
* Large Mode: Enlarged ZC's Screen Saver Settings dialog.
* Quest Reports: Now, the palette names for listed locations have padding spaces, to ensure that the data appears in straight columns. Also, you can now save quest reports to a text file.
* About the Windows debugging console.. Mac OS X comes with a Console program designed for displaying .log files such as Allegro.log, so the OS X version of ZC will come with an alias to Allegro.log inside the ZC application bundle. ( _L_, 2012-02-11 06:17:30 )

* Fixed the bug with the flip arguments in all the other script drawing.
* Added two new functions: 1)Screen->DrawLayer(), which will draw all the combos from any layer on any screen on any map to a location on the current screen or bitmap with opacity or rotation. 2)Screen->DrawScreen(), which is similar to the above with the exception that it draws all the available layers from a screen to the current screen or bitmap. --Example usage, Minimaps: Draw a block of 4 screens once to a bitmap, then scale that down to a small rectangle when you draw it to the screen. ( Gleeok, 2012-02-10 02:38:43 )

* It should no longer be possible for the item selector to disappear when the subscreen changes. ( Saffith, 2012-02-05 07:50:04 )

* Hungry Goriya rooms are no longer useless if messages disappear. ( Saffith, 2012-02-04 07:34:03 )

* ZScript: Rewrote Quad3D() and Triangle3D() Screen Functions (Which have been completely broken for a long time) so they don't crash anymore. ( Gleeok, 2012-02-04 01:48:31 )

* New quest rule: enemies flicker when hit. ( Saffith, 2012-02-02 19:11:59 )

* Certain warps would reset enhanced music, but not MIDIs. They now should not reset any music.
* Added ZScript functions to control enhanced music.
* Modified the way quest filenames are read when loading saved games. Hopefully, this will make zc.sav files somewhat compatible across platforms. ( Saffith, 2012-02-02 13:40:53 )

* Favorite combos and combo aliases are now saved in quest files.
* Fixed bomb bags' "Super Bombs Also" flag. It's been broken for a long time, and a lot of quests depend on incorrect behavior, so the flag is enabled in existing quests. It is also now enabled by default. ( Saffith, 2012-01-31 20:27:32 )

* Tektites can spawn on solid combos again.
* FFCs in quests from RC1 and before will run while Link is holding up an item.
* Finally found a fix for stuck MIDI notes on Linux.
* Fixed CSet 5 not being reset after warping out of a dark room. ( Saffith, 2012-01-31 10:51:31 )

* Fixed scrolling warps not setting continue screens correctly. ( Saffith, 2012-01-30 15:18:47 )

* Increased the range of values that can be set for enemies' misc. attributes. ( Saffith, 2012-01-30 09:00:42 )

* Fixed some errors in the string editor. It may still do odd things with invalid control codes, but it should work otherwise. ( Saffith, 2012-01-29 15:15:18 )

* Homing Moldorms should now animate correctly. ( Saffith, 2012-01-27 23:09:13 )

* Fixed the bug where Quad() and Triangle() would sometimes display garbage pixels. ( Gleeok, 2012-01-27 20:41:27 )

* Invisible Link's weapons will be invisible again. ( Saffith, 2012-01-26 09:54:29 )

* ZScript: Upped the Off-screen Bitmap dimensions to 512x512 - the maximum size allowed by most script drawing routines. ( Gleeok, 2012-01-25 16:27:42 )

* Fixed the drop in framerate when magic is refilling or Link has a magic ring.
* Fixed some weapons not working when Link is invisible. Incidentally, this also makes those weapons visible. ( Saffith, 2012-01-25 14:51:20 )

* Shields' unused ice magic block/reflect flag is now used for script weapons instead. By default, the Magic Shield blocks them and the Mirror Shield reflects them. For compatibility, all shields in existing quests will block script weapons.
* Replaced the unused ice flag (97) and combo (previously hidden) with No Ground Enemies.
* Fixed enemies ignoring the No Enemies combo when entering from sides.
* The selected item name subscreen object now shows the name of whatever item the selector is on. ( Saffith, 2012-01-25 08:10:14 )

* The game should no longer fail to save control changes.
* Goriyas' boomerangs will no longer go all the way across the screen.
* Link should now always collect items retrieved with a boomerang.
* Shields and spawn animations can now be set for other- and other (floating)-type enemies. ( Saffith, 2012-01-24 14:52:03 )



Build 1437 - windows
* Added a rotation argument to Screen->DrawBitmap(), which if used rotates the destination rect about its center in degrees. ( Gleeok, 2012-01-23 17:34:11 )

* Adding counter items (rupees, bombs, etc.) via string control codes will no longer ignore the counter's maximum.
* Fixed current items on the passive subscreen disappearing after buying something or picking up a special item.
* Tile warps and side warps can now have different warp returns set.
* Scripts will no longer see a trapped enemy's direction as -1.
* Modified the script interpreter to increase the limit on script size. ( Saffith, 2012-01-23 15:12:52 )

* Fixed the Cane of Byrna's sound not stopping.
* Added FFCF_IGNOREHOLDUP and LW_CANEOFBYRNA to std.z.
* Reworked the undercombo dialog. It now shows current and new combos side by side again, with the new combo defaulting to the currently selected one. ( Saffith, 2012-01-22 13:32:28 )

* Fixed the ladder incorrectly activating over dried water and direct warps.
* Fixed possible graphical errors when Link has bombs, but not the bomb item.
* Fixed the screen not going dark if a fire is removed by a script. ( Saffith, 2012-01-21 14:21:24 )

* ZScript: Fixed a bug where flip arguments were not respected with DrawCombo() and FastCombo().
* Optimized all internal per-combo drawing.
* Windows: Fixed any rare windows-specific crashing that a few people may have seen - which I accidentally introduced to ZC - between RC2 and current revision. If anybody still has issues with obscure crashing from this you can disable the newer 2.5 windows-specific fixes all at once via the "*_win32_proc_fix" option in the config file. ( Gleeok, 2012-01-21 03:53:51 )

* Fixed a bug that made Link unable to get out of water by unwalkable combos.
* Screen freeze combos now work as FFCs. ( Saffith, 2012-01-15 17:14:11 )

* ZC: Fixed the bug where reading the color depth setting in the config file would reset it to 8 before it could be used. Sorry!
* ZC: (Windows) Now zconsole (dbebug console) respects the Quest Rules in the 'Other' category: "Log game events", and "Show Script Errors". ( Gleeok, 2011-12-05 12:05:37 )

* Fixed a recent problem with deleting and reordering strings.
* Corrected the name of item->DrawStyle. ( Saffith, 2011-12-02 06:20:04 )



Build 1427 - windows
* Let's try this once more... ( Gleeok, 2011-12-02 04:38:25 )



Build 1425 - windows
* WINDOWS version update to 2.5RC2. ( Gleeok, 2011-12-02 04:00:00 )

* Fixed the bug where items in the active subscreen animated at double their proper speed.
* ZQuest: Fixed the bug where the last rows of the file list in the Open dialog were sometimes unresponsive.
* NES Consistency: now, Moldorms use the Default item drop set in New Default and all four 'official' quests (excluding the boss Moldorms in 4th.qst).
* Also, for NES consistency purposes, Moldorm segments no longer drop items individually when killed.
* Fixed the bug where Line of Sight Traps placed via ZScript wouldn't return to their 'rest location' correctly. Just a note: if you move an existing Line of Sight Trap via ZScript while it is lunging or returning, it will keep trying to return to its original rest location until it has done so, but if it is moved while at rest, it will correctly regard its new location as its rest location the next time it lunges. ( _L_, 2011-10-23 05:41:17 )

* ZQuest: Newly added to the right-click menu is 'Follow Tile Warp', which lets you right-click any tile warp combo and find out where it goes, instantly! This should make navigating your quests' environments in ZQuest slightly easier.
* Also, there's 'Edit Tile Warp' which lets you quickly edit the appropriate Tile Warp (A, B, C or D) for that combo instead of having to reach up to the Screen menu then shuffle through the Tile Warp dialog tabs.
* Also, removed the 'Properties' right-click menu item, as the tooltips provide the same functionality in a more convenient format.
* String Editor: Added a dropdown menu to the string list. It lists all of the strings in your quest that begin with two hyphens ('--'). Selecting one will jump to that string in the list. The idea is that you should place 'unused' strings, beginning with two hyphens and containing some identifying words, at the beginning of large blocks of strings in your quest, so that the dropdown menu serves as a quick index to these string blocks.
* String Editor: Deleting a string now just clears the string instead of physically removing it and decrementing the IDs of all strings after it (which, in this age of ZScript, might be more trouble than it's worth). Since you can re-order the string list at will, you can shuffle this empty string to the end of the list as you will.
* ZQuest: The 'Flip Screen Horizontally/Vertically' and 'Flip Map Horizontally/Vertically' features are no longer tied to hotkeys, due to their being too esoteric. They are now in the Maps submenu of the Edit menu.
* ZQuest: 'Show Squares' is now on by default. ( _L_, 2011-10-07 09:17:07 )

* Fixed the bug where teleporting Wizzrobes ignored No Enemy flags and other restrictions, and also fixed the NES inconsistency where teleporting Wizzrobes wouldn't appear over water.
* Game Event Logging: There is now a log message when Link warps, indicating the DMap and screen destination, and a log message for entering screens, which lists the screen's states. ( _L_, 2011-09-22 09:05:23 )

* Large Mode: Fixed the bug where alert dialogs' text lines would get cut off at the bottom (so that g's, p's and y's would lose their tails).
* Enemy Editor: Renamed 'Is Transparent' to 'Is Translucent'.
* ZQuest: Clicking the Flag button in the Main Panel now opens the Select Combo Flag dialog instead of the more obtuse option of using the last placed flag. Since the last placed flag is already selected in the dialog when you open it, this should only add an extra click to the process of its 'normal' usage.
* ZQuest: Clicking on an item on the screen itself will allow you to reposition it, as if you had clicked the main panel button. Also, clicking the Item button in the main panel will now open the Select Item dialog as well as letting you reposition it.
* ZQuest: Right-clicking on Commands will now bring up the dialog to change them. Previously you had to control-click them to erase them and then click them again.
* Tile Editor: The 'rectangle selection method' in the Select Tile dialog is now the default.
* Large Mode: Fixed the bug where pressing the Drawing Mode button wouldn't alter the checkbox in the Drawing Mode submenu in the Tools menu. Also, now selecting a non-Normal drawing mode (in either the submenu or the Commands menu) will switch the mode back to normal.
* ZQuest: If the quest rule 'Use Warp Return Points Only' is set (which is true for all new quests), clicking the green square arrival point button will notify you that it has no function under the current quest rule settings, before letting you move it.
* Large Mode: Screen information now includes a line telling you how many screens use this screen as a layer, and the first screen which does so. (Since most layer screens are only used by one screen, this should be sufficient.)
* Addendum: The word 'set' in the first line of the previous set of changes should read 'unset'. Thanks and take care. ( _L_, 2011-09-18 07:49:51 )

* Fixed the hookshot handle damage. A thorough examination of the 'hookshot chain damage' behaviour from 2.10 confirms that the source of damage is not actually the chain but the handle. Now, if the Item Editor checkbox is set, the handle does damage to a) Walking Enemies with the Pols Voice walk style or a shield, b) Wizzrobes that don't Ignore the Hookshot, c) Peahats, d) Aquamentuses and e) Manhandlas.
* Renamed the 'No Chain Damage' checkbox to 'No Handle Damage' and made it set by default. Since the handle damage is a 2.10 bug that doesn't even make sense within this game's internal videogame logic, it is recommended that future quests keep the box checked.
* Fixed the NES consistency bug where stunned Dodongos could be killed by sword beams.
* Renamed 'Summoner' to 'Wizzrobe (Summoner)'.
* Addendum: last line on previous set of changes should also say that 'Cane of Byrna Defense' is renamed 'Byrna Beam Defense'. ( _L_, 2011-09-15 05:44:38 )

* Fixed the bug where the inner eye offset for Patras was equal to the outer eye offset if none of the eyes fired projectiles. Now it is equal to 40 if the centre eye does not shoot projectiles, and 120 if it does.
* Fixed the bug where 'Other (Floating)' enemies could not have their Z set by a script. (However, since they don't obey gravity, it is not possible to set its Jump via script.)
* Due to popular demand, Lanmolas no longer obeys gravity. For the record, the following enemy families don't obey gravity: Manhandla, Moldorm, Lanmola, Gleeok, Zora, Leever, Aquamentus, Rock, Ganon, Trap, Projectile Shooter, Spin Tile.
* Fixed the bug where Peahats couldn't be hit with fire boomerangs while in flight.
* Now, damaging sparkles only damage foes if the foes do not have a damage-preventing Defense for the weapon that created the sparkles. This prevents Darknuts, Pols Voices, Wizzrobes and various bosses from incorrectly taking damage from sparkles from boomerangs, arrows, and canes. Note that script-created LW_FIRESPARKLEs will still damage these foes. Also, you may remember that in 2.10 the Pols Voices would appear to take damage from damaging sparkles, but not actually lose HP. This seems to be a 2.10 bug, and in 2.50 they will ignore damaging sparkles properly.
* New Default: Now, the Darknuts have the 'Hammer Can Break Shield' flag set.
* Enemy Editor: Renamed 'Wand Defense' to 'Wand Melee Defense' and ( _L_, 2011-09-12 09:40:06 )

* ZQuest: Fixed the bug where choosing View Map more than once wouldn't refresh the displayed map.
* Fixed the bug where defaulting enemy data would give the Gleeok some incorrect misc. values.
* Fixed the bug where, if a non-Projectile Shooter enemy was generated by the 'Shooting Statues' screen flag, that enemy would sometimes be incorrectly generated twice.
* ZQuest: Fixed the bug where typing the first letter of an enemy's name in the Select Enemy list would not instantly update the enemy tile preview.
* Enemy Editor: Now you can edit the 'Turn Freq' of flying enemies, which is a previously hard-coded value used in their shared movement routine. This determines how often they decide whether or not to change direction. By default this is 16 for Digdoggers and Manhandlas, 9 for severed Gleeok heads, 8 for Patras, Keese and Peahats, and 12 for phantom Ghinis. This takes up the 'Halt Rate' position.
* Peahats, Keese, Ghinis and Big Digdoggers now have editable Random Rates. Previously they were hard-coded at 4 for Peahats and Ghinis and 2 for Keese and Big Digdoggers. Note that Patras, Manhandlas and Digdogger Kids already had editable Random Rates.
* All flying enemies can now use their Homing Rate to affect their direction, in a manner identical to ground enemies. Note that Digdogger Kids already had editable Homing Rates.
* Gleeoks now use Random Rate, Halt Rate, Step Speed and Homing Rate for their severed heads.
* Manhandlas now have an editable Step Speed. It starts at 50 and increases by 50 when it loses a head. It is internally capped at 450.
* Unified the Keese and Keese Tribble enemy families. They had only a few lines of code differentiating them. ( _L_, 2011-09-08 05:18:22 )

* Fixed a couple of subscreen issues.
* Fixed a few enemies not responding to bait correctly. ( Saffith, 2011-08-18 12:53:17 )

* Fixed the bug where menus become unusable when ZC is run in non-8bit color. This also fixes the wrongly colored border issue in zc.
* Finally got around to optimizing certain drawing commands to re-use memory. Functions like Screen->Quad() for instance should be a lot faster. These are about as good now as they're ever going to get.
* (Windows) Added various config file options based on previous commits. ( Gleeok, 2011-08-16 01:31:11 )

* ZC: (Windows) Will now become inactive when minimized or focus lost. (Don't panic, you can still listen to the music!)
* ZC: Added the following command line arguments: -0bit, -8bit, -15bit, -16bit, -24bit, -32bit. -- Also added a "color_depth" option to the config file which can be set similarly. These default to 8. *Note that setting these to 0 will use the current color depth of your monitor, so if you need to change these for any reason it is recommended to use 0 or -0bit for that very reason, which should have the best performance. ( Gleeok, 2011-08-14 01:47:12 )

* Fixed some inconsistencies with DrawString and optimized cache read, insertion etc.. of Script Drawing with large amounts of drawing. Basically a whole bunch of not very interesting stuff. ( Gleeok, 2011-08-11 04:48:19 )

* Pushing a heavy block no longer triggers secrets regardless of which push flag is used.
* Jumping and landing on the ladder over water should no longer play the splash sound.
* Tweaked zscript.txt, std.zh, and std.txt. ( Saffith, 2011-08-06 09:49:31 )

* Now, the Show Walkability cheat in ZC and ZQ shows Hookshot-crossable and Ladder-crossable combo types with gray and brown, respectively. Ladder & Hookshot combo types have brown and gray checkers. Also, damage combos are now shown in yellow checkers (to denote if they are walkable or solid).
* Now, the Show Walkability cheat in ZC (but not ZQ) draws the solidity boxes between layers 2 and 3. This is to prevent flying enemies from being hidden by the boxes. Of course, the overhead layers can obstruct your view of the solidity boxes, but you can already switch those off at will.
* Fixed the bug where generating a Super Bomb via script would cause it to have a small bomb explosion.
* As you know, if you create an LWeapon via script, it is automatically given the qualities of an item of the appropriate family with a Level of 1. Now, instead, ZC finds an item of the appropriate family with the lowest possible level.
* Tweaked the wording of the help string for 'Ladder Only' combo types, to say that they only work on layer 0 (unlike the 'Hookshot Only' type).
* Added a missing potion shop to the Second Quest. ( _L_, 2011-07-28 04:43:52 )

* Fixed the bug where killing a single Patra (BS Zelda) eye would set the 'No Return' screen state (if the enemy was set to 'Never Return After Death').
* Fixed the bug where, when warping to a DMap that played a different track from the same enhanced music file as that used by the previous DMap, the music sometimes wouldn't change to that track.
* Now, Link's jumping animation speed is related to the Gravity constant's setting - if Gravity is lower, the animation is slower, and if Gravity is higher, it is faster.
* Added a ZC setting, 'Click to Freeze', which lets you pause to bring up the ZC menubar by clicking instead of just pressing Esc (as you could for all versions up until around build 749). You can disable it at will in case you're playing a quest that uses the InputMouseB ZScript function to use mouse-clicks for something. I called it 'Freeze' instead of 'Pause' because there's seriously four different ways to pause this damn game (Subscreen, Overworld Map, F3, Esc) and not enough differentiating terminology to go around. ( _L_, 2011-07-13 10:18:59 )

* ZQuest: Added "fps" option to the config file. Accepted arguments are between 12 and 60 frames-per-second. (Default is 60)
* ZQuest: (Windows) Added "frameskip" option in the config file.
* ZQuest: (Windows Fix) : Will now become inactive when minimized or focus has become lost. This will put ZQ in an Idle (Sleep) state and use 0% CPU while it is inactive. Also ZQ now undoes any thread priority set by allegro worker threads; ( Gleeok, 2011-07-09 17:25:59 )

* ZC: (Windows) Added a debugging console. ..(*waits for gasps of terror and astonishment to subside) Yes, that's right: A debug console.
* Now you can view system (allegro.log info), user logging (via zscript trace commands), and extra debugging info regardless of setting any extra flags, quest rules, or command-line args, in real time as they happen. ...I don't know why I didn't add this sooner.
* To enable zconsole use command line switch "-console", "-con", or set the appropriate ag.cfg option to 1.
* ZSCRIPT: Added Bitmap drawing and further transformed script rendering into a state machine with the following Screen functions: SetRenderTarget(int target); and DrawBitmap(...);
* Screen->SetRenderTarget(): sets 'target' as the destination Bitmap for all successive zscript drawing commands. This can be directly to screen or in one of 7 off-screen buffers.
* Screen->DrawBitmap(): draws a source region of one Bitmap to a destination region of another Bitmap, including the screen layer as a possible target. I will post an example of using these pending next release. ( Gleeok, 2011-07-04 02:51:58 )



Build 1402 - linux


Build 1401 - macosx-Leopard , windows
* This corresponds to ZC Release Candidate 2. I'm not sure if I'm supposed to put RC builds in this changelog, but maybe people will be less likely to miss it if I do.
* Item Editor: Now you can't set the Equipment Item status of a Level-Specific Key item. Also, renamed 'Full Max' to 'Refill Max', which is slightly less opaque and tautological than the former. ( _L_, 2011-06-30 08:46:13 )

* Fixed several cases where a DMap's Disabled Item settings were being ignored.
* Changed the 2010 copyright to 2011. ( _L_, 2011-06-30 07:37:19 )

* Fixed the bug where Link, with diagonal movement, couldn't step sideways out of water, and would instead continue swimming on land.
* Fixed the bug where ground enemies couldn't walk on dried water combos. ( _L_, 2011-06-27 10:15:42 )

* New Default: Fixed the boomerang tiles so that they function correctly with BS-Zelda Animation.
* New Default: Rearranged some dungeon combos and added a few more.
* ZQuest: Tile pages and map images are now exported using the set snapshot format (default being PNG).
* OS X: Screenshots and map images are now saved outside of the application bundle.
* Item Editor: Added a help button next to the item class dropdown menu that provides a brief description of the item class. ( _L_, 2011-06-20 00:10:34 )

* Added help buttons to the Combo Editor that provide help messages explaining the currently selected combo type and/or inherent combo flag.
* Changed the call to Allegro's rest function used by the FPS capping mechanism, such that it now rests instead of just yielding. The result of this should be reduced CPU usage for most systems. ( _L_, 2011-06-18 08:07:02 )

* Fixed the bug where the Show Walkability cheat wouldn't reflect changes to combos on layers.
* Added an extra game event log message involving the Hit All Triggers screen flags.
* Made some combo flag help descriptions less ambiguous.
* New Default: Fixed the Nayru's Love Shield (Back) sprite.
* Item Editor: Counter Reference is now a dropdown menu with 16 entries plus 'None'. Since all counters above 16 are reserved for future expansion, you can no longer set an item to use them. ( _L_, 2011-06-06 04:54:41 )

* Fixed possible crashes in ZQuest when viewing screens with invalid combos.
* Fixed a possible crash if Link dies while the screen is shaking.
* Screen->Quake and Screen->Wavy are now reset when Link dies.
* Expanded the number key usage in preview mode to cover all eight possible warps. ( Saffith, 2011-05-23 14:56:50 )

* Fixed problems with the rising fireball weapon in the enemy editor.
* Fixed some issues with enemy sounds stopping at the wrong times.
* Enemies now have a defense for script weapons. ( Saffith, 2011-05-18 12:55:58 )

* 2.10 Consistency Fix: Ladders are now allowed in all NES Dungeon screens regardless of any quest rule or screen flag.
* Fixed the Patra's eyes' CSet in pre-Enemy Editor quests.
* Fixed the upward movement of Fire passing through solid combos in Sideview screens.
* Overworld Map: Fixed the display of Doors of NES Dungeon screens while in non-NES Dungeon DMaps.
* Now, scrolling warps between NES Dungeon and non-NES Dungeon DMaps correctly observe the Secrets screen state and the Door states of the destination screen. ( _L_, 2011-05-14 02:18:11 )

* Fixed the bug where items wouldn't appear in the subscreen after picking up a Triforce piece.
* Fixed an issue with whistle-altered palettes not being reset after warping. ( Saffith, 2011-05-01 17:01:54 )

* Fixed a problem with loading a game when Link's max health includes a fraction of a heart.
* Importing a ZGP will no longer replace all the items; only their graphical data will be changed now.
* Fixed a bug where Link couldn't walk past a moving block on the left.
* Fixed ffc->InitD[] being written incorrectly.
* ffc->Script is now writable. ( Saffith, 2011-04-27 19:50:20 )

* Fixed a crash where sfx.dat was too old to have all the current sound effects, but not old enough that someone bothered to change the version. ( pkmnfrk, 2011-04-23 16:10:27 )

* Fixed a crash when displaying certain compiler error messages.
* Damaging sparkles created by boomerangs shouldn't easily bypass enemy shields anymore.
* Drawing commands are once again cleared when Link is holding an item.
* Relatedly, FFCs now have a flag that controls whether they're updated when Link is holding an item. By default, they're not. ( Saffith, 2011-04-22 14:07:46 )

* Quests opened automatically by the "Reload Last Quest" option no longer bring up the "Save As" dialog when saved.
* Fixed more problems with pushing blocks over damage combos.
* Tweaked drawing while scrolling a bit.
* std.zh: Fixed a mistake in one of the Choose() functions. ( Saffith, 2011-04-19 08:12:28 )

* Fixed the bug where equipment items with magic costs would sometimes vanish from the subscreen whenever you changed screens with 0 magic.
* Fixed the Candle and Cane of Byrna slash animations. ( _L_, 2011-04-11 08:07:47 )

* Fixed the bug where ladders couldn't be used on 'Ladder Only' or 'Ladder/Hookshot Only' combos.
* New Default: Fixed four duplicate water-edge combos. ( _L_, 2011-04-10 03:53:51 )

* Items that decrease counters should no longer cause them to wrap around to very high numbers.
* Link's HP should now be set correctly when continuing when his maximum HP includes a partial heart. ( Saffith, 2011-03-23 09:51:58 )

* The most desired feature in ZC history has been added: Now you can set the Flame sprite for Din's Fire and Magic Book items.
* Fixed the bug where saving sometimes wouldn't work for an unsaved quest in the Mac version.
* Filled in the new ZQuest.txt with the remaining features from the Quest menu, features in the Edit and View menus, and Screen Data. ( _L_, 2011-03-19 07:05:43 )

* Gleeoks, Moldorms, and Lanmolas with 0 segments will no longer crash the game. ( Saffith, 2011-03-16 21:09:06 )

* If a trigger combo and a misc. secret flag are on the same combo, the misc. secret combo will now be the one that appears if the secret is triggered. ( Saffith, 2011-03-16 08:40:01 )

* The start page option is no longer ignored when importing a combo table.
* Canceling out of the "Scroll to Combo Page" dialog will no longer cause it to scroll to page 0. ( Saffith, 2011-03-14 15:48:07 )

* Fixed a bug that could cause strings to be changed incorrectly after deleting one. ( Saffith, 2011-03-12 07:29:34 )

* Finishing one of the NES quests shouldn't screw up the next one anymore.
* Fixed a bug that could make FFC changers fail to activate. ( Saffith, 2011-03-10 18:06:11 )

* Keese should no longer get stuck on the left edge of the screen.
* Step triggers will trigger repeatedly as long as Link is standing on them in 2.10 quests.
* Z3-animated Link now animates when entering and exiting caves. ( Saffith, 2011-03-10 10:18:39 )

* Fixed a possible crash on sideview screens.
* Current Items on the passive subscreen animate now.
* Fixed (none) not appearing in the item override menu. ( Saffith, 2011-03-07 11:55:12 )

* Fixed possible errors and crashes after the active global script has quit.
* Enemies can once again move over walkable water if "Link Drowns in Walkable Water" is unchecked. ( Saffith, 2011-03-01 17:34:54 )

* Fixed a possible crash when saving in ZQuest.
* Fairy flags on solid combos should work the way they did in 2.10 again.
* std.zh: Corrected a few IC_ constants and added the missing ones. ( Saffith, 2011-02-28 20:58:43 )

* New Default: Adjusted the level of the Key (Level-Specific) item to 1.
* New Default: Fixed the tiles of the subscreens' magic gauges.
* New Default: Adjusted the (unused) tiles for the (nonexistent) Bat Wizzrobe 2's bat form.
* Presumably fixed the Kill All Enemies cheat killing non-beatable enemies. ( _L_, 2011-02-27 23:40:07 )

* Fixed pasting of screen warps (previously, it would not paste the side-warp side selection trigger thingies) ( pkmnfrk, 2011-02-21 02:14:32 )

* Fixed the bug where the ladder would sometimes appear when scrolling vertically with Walkable Water on.
* New Default: Fixed some non-animated water combos, and made the Outlands waterfall tiles fit in better with the other water tiles. ( _L_, 2011-02-09 02:58:45 )

* Added a default sound effect for the Cane of Byrna.
* Changed the Cane of Byrna's default Beam Speed Divisor to match the sound effect.
* Now, the Cane of Byrna's beam appears within the hook of the cane regardless of Link's direction.
* Changed the default Zelda's Fanfare sound to one with less noise.
* New Default: Changed some sprites for various Traps and Octoroks.
* Added the 'Show/Hide Walkability' level 4 cheat. This has the same functionality as the Show Walkability option in ZQuest.
* Non-Gameplay Items' Equipment Item checkbox can no longer be set. ( _L_, 2011-02-06 21:36:54 )

* Boomerangs are no longer treated as swords when determining whether they do damage.
* Boomerangs should no longer be able to bypass enemy shields.
* Fixed npc->Defense[] being read incorrectly.
* Fixed the problem of screens showing up on the map when they shouldn't, hopefully without causing any problems.
* Individual Lanmola segments will drop items again.
* std.zh: Corrected Randf(). ( Saffith, 2011-02-04 13:33:10 )

* Warping into a dark room no longer makes it all black.
* Fixed some issues with transparent sprites and drawing commands in dark rooms.
* Fixed transparency not being updated when ESP enemies appear.
* The Triforce pickup jingle should no longer get cut off. ( Saffith, 2011-02-02 09:08:41 )

* Fixed another little enemy animation issue.
* Changed the way conveyor belts are detected to fix issues with standing halfway on one.
* Fixed Link getting stuck on corners while swimming.
* Implemented Arrange->Reverse in the subscreen editor.
* Renamed the Enemies->Perm. Secret enemy flag to make it clearer what it actually does. ( Saffith, 2011-01-28 06:55:06 )

* Fixed Gohmas moving randomly when they first appear.
* Fixed some internal issues with local arrays and strings in ZScript. ( Saffith, 2011-01-27 08:36:02 )

* Fixed Gohma 4's fire in old quests.
* Link should no longer be hurt by a damage combo he's pushing a block onto.
* Fixed the button list for button items in the subscreen editor.
* FFCs now freeze when Link is holding up an item.
* Shadows should now be centered correctly under extended enemies.
* A boomerang's sound will now stop when it's removed by a script.
* Timed saves work normally again. ( Saffith, 2011-01-25 14:03:05 )

* Changed the way enemy halt time is determined. It should work more like before now.
* Rings can now use all 30 extra sprite palettes.
* Enemies should no longer be drawn too high after being carried over through a warp.
* Fixed an issue with the hookshot hitting solid combos on layers. ( Saffith, 2011-01-24 14:30:55 )

* Drawing commands should work while scrolling again, and now without little glitches. ( Saffith, 2011-01-23 22:13:20 )

* Fixed another walking enemy animation error.
* Dodongos should no longer avoid the right edge of the screen.
* Screens on new maps will again have the lens effect set to normal.
* Winning a quest should no longer reset its icon to the green tunic icon.
* A couple of small tweaks in std.zh. ( Saffith, 2011-01-08 21:39:29 )



Build 1352 - macosx-Leopard
* I'd like to again apologise for my absense. My hard drive broke down. Don't worry; I lost nothing except for my dignity.
* New Default: Fixed some enemy tiles (Goriya L3, Magic Pols Voice) and altered some other tiles (Digdogger, Zol & Gel Tribble, fast Octoroks).
* New Default: Spin Tile (Enemy Sprite) now uses the 4-Frame 4-Dir animation type.
* Hopefully this new build works on other people's systems... ( _L_, 2010-12-22 22:01:14 )

* Hopefully fixed issues with rings and peril rings with a damage divisor of 0.
* The hookshot should now pause while the subscreen is active. ( Saffith, 2010-12-22 09:07:18 )

* Fixed a graphical issue with walking enemies with odd frame rates.
* Sparkles now disappear after their animation completes. ( Saffith, 2010-12-17 10:43:12 )



Build 1348 - linux , windows
* Did what I could to fix hanging MIDI notes on Linux. It's an Allegro issue that we probably can't fully fix, but it should be less severe now.
* Added Game->DMapMIDI[] to zscript.txt. Turns out it's been available for quite a while.
* It's been using the wrong numbers, though. It's about fixed as possible now; not all built-in MIDI's numbers match Game->GetMIDI() and Game->PlayMIDI(). ( Saffith, 2010-12-15 10:55:32 )

* Zols and gels move correctly now.
* Pressing A or B with no weapon in that slot should no longer fire a 0-damage sword beam.
* Weapon types that aren't supposed to be affected by gravity aren't anymore.
* "Tall Grass->Next" combos now leave items when slashed. ( Saffith, 2010-12-13 21:18:57 )



Build 1346 - linux , windows
* Fixed some more alternate music crashes.
* The CSet editor should have a black background now. ( Saffith, 2010-12-13 06:04:05 )

* Fixed some alternate music-related crashes.
* ZC now checks the quest directory as well as the program directory when searching for alternate music.
* Killing enemies created by scripts should no longer decrement the screen's enemy count.
* Fixed incorrect warps out of level 5 in the 4th quest. ( Saffith, 2010-12-12 12:21:44 )



Build 1343 - linux , windows
* The previous fix turned up another array issue. Everything's good now, hopefully... ( Saffith, 2010-12-10 14:38:39 )



Build 1342 - windows
* New Windows build. I haven't done one of these before, but now seems a good time to try it. ( Saffith, 2010-12-10 12:35:19 )



Build 1341 - linux
* Fixed a major problem with saving games in quests with global arrays. You should probably start a new save file; this was seriously messing stuff up.
* Normal ghinis are once again opaque in old quests.
* Fixed a small error in zscript.txt. ( Saffith, 2010-12-10 07:33:17 )



Build 1340 - linux
* Items created by scripts should no longer be hard to pick up.
* Projectile shooters' breath firing type works now. ( Saffith, 2010-12-04 09:09:32 )

* ZC should no longer overflow the stack when initializing save data.
* Optimization/Fix: Drawing primitives should no longer be called multiple times on layers 3,4,5,6. This might of caused some lag for render-intensive scripts. ( Gleeok, 2010-12-02 15:14:48 )



Build 1337 - windows
* Fixed the bug where quest icons would sometimes change to those of other quests. Saves that already have the wrong icons won't be fixed. ( Saffith, 2010-12-01 22:41:14 )

* Fixed a saving and loading problem that came up a few builds ago. Saved games might be affected.
* Fixed Link reappearing in the wrong place when he drowns after warping with the whistle. ( Saffith, 2010-11-29 15:49:01 )

* Corrected length of default short hookshot.
* Fixed crashing bug with carried items and tribble enemies.
* Fixed bug where using the hookshot downwards directly above a hookshot combo would allow the hookshot to pass through it. ( DarkNation, 2010-11-27 08:35:40 )

* Adjusted some weapons' hitboxes. The sword should no longer hit enemies a full tile to its right.
* Fixed a bug that could make the active global script run twice a frame.
* Changed the way ZScript's drawing functions work when scrolling. ( Saffith, 2010-11-26 08:56:03 )



Build 1331 - macosx-Leopard
* Fixed the bug where the 'Holding Up Items Does Not Restart Music' and 'Leaving Item Cellar/Passageway Does Not Restart Music' rules would restart the DMap music instead of the screen-specific MIDI.
* New Default: added yet more tiles for enemies.
* New Default: phantom Ghinis now flash, and Pols Voice (Magic) have been slowed down to 50.
* Trigger enemies (which are '(None)'-type in ZQuest) added to new quests now continue working as they always did. However, they are left in purely for backwards-compatability, and aren't really recommended for use in modern quests.
* Fourth Quest: reduced Ganon's HP from 300% of normal to 200% of normal.
* Also removed the two top statues from Level-2's boss room because, to be honest, the bottom statues are already hard-boiled murder as it is (and I like the geometric symbolism of Link in a triangle of fire between 2 statues and Gohma). ( _L_, 2010-11-26 02:22:58 )



Build 1330 - windows
* The 'Win Game' combo type is now labelled 'Unused'.
* A new build. My apologies for its delay. ( _L_, 2010-11-25 23:15:45 )

* Items once again bounce a bit when they fall.
* Push blocks' combo types should no longer be ignored in on sideview screens.
* The application windows should now use the appropriate icons on Linux. ( Saffith, 2010-11-20 19:29:14 )

* Added Screen->RoomType and Screen->RoomData, which correspond to the Screen->Room Type and Screen->"Catch all" menus in ZQuest.
* Also added RT_* constants to std.zh to go with this. ( pkmnfrk, 2010-11-17 15:15:51 )

* Fixed a few internal issues.
* Fixed a mistake in some of the new std.zh functions. ( Saffith, 2010-11-17 11:36:16 )



Build 1326 - linux
* Fixed Game->SetScreenState() getting the wrong screen on higher-numbered maps.
* FFCs now have to move farther (more than 4 tiles) off the top or left of the screen before they're blanked.
* Added a couple of functions to std.zh and expanded NoAction().
* Yeah, another Linux build. 1324's Allegro changes didn't quite work for everyone; it should be better now. ( Saffith, 2010-11-16 20:41:10 )

* Fixed npc->DrawYOffset being incorrect.
* Fixed ladder only combos allowing the hookshot to pass through.
* Fixed block fireball combos not blocking fireballs.
* Fixed items sometimes ignoring conveyor belts. ( Saffith, 2010-11-15 09:38:40 )



Build 1324 - linux
* Patched Allegro to fix some sound problems on Linux, particularly with PulseAudio.
* Fixed eweapon->isValid() always returning false.
* Fixed a problem with enemy explosions drifting to the left. ( Saffith, 2010-11-14 20:39:22 )



Build 1323 - linux
* Fixed a bug where global scripts kept running after they should have quit.
* Fixed bitwise NOT in ZScript. ( Saffith, 2010-11-11 12:49:34 )

* Fix a few annoying warning messages while compiling ( pkmnfrk, 2010-11-10 17:10:12 )

* Fixed a couple of documentation errors (GetMessage() is part of Game, not Screen, and the Text Formatting constants are TF_*, not TEXT_FORMAT*) ( pkmnfrk, 2010-11-08 23:17:05 )

* Fixed the fix to the non-penetrable bosses - I'd gotten it backwards and made every enemy except the three bosses non-penetrable by penetrating weapons. That's reverted now.
* Fixed the bug where Link's raft would disappear while scrolling. Related note: from now on, while Link is scrolling the screen on a raft, Link->Action will equal LA_SCROLLING, not LA_RAFTING.
* Fixed the bug where Link would drop his sword when boarding a raft while charging his sword.
* Fixed the bug where Lanmolas' BG Sound wouldn't stop playing when they died.
* Fixed the bug where Lanmolas wouldn't use the Death Sound enemy editor value. ( _L_, 2010-11-06 02:03:19 )

* Fixed TraceB() always printing false.
* When setting a DMap's alternate music, ZQuest will now load the file correctly if it's in the same directory as the quest file. ( Saffith, 2010-10-27 09:13:47 )



Build 1318 - windows
* A new build. By the by, I'm going to be personally busy with work for the next two weeks, so my apologies if I seem even more absent than usual during that time.
* Fixed the bug where completing a Maze Path with an east Side Warp would scroll the screen upward instead of rightward.
* Fixed the bug where the screen would scroll twice if completing a Maze Path resulted in triggering a scrolling Side Warp. ( _L_, 2010-10-13 19:41:15 )

* Fixed a crash when Link gets hit while wearing a ring with a damage divisor of 0. ( Saffith, 2010-10-11 11:01:54 )

* ZScript: Fixed numbers should no longer spill off digits when performing divide operations.
* Tweaked the AG fire logo screen in case anyone was having any weird behaviors with it before. ( Gleeok, 2010-10-05 17:33:39 )

* Fixed a crash that could occur when doing a CSet-only fill (ctrl+shift+click).
* Fixed a typo in std.zh (WT_ENTRANCEEXIT). ( Saffith, 2010-10-03 15:57:25 )



Build 1314 - macosx-Leopard
* Fixed the Import Map crash by changing the .map export file format to use the quest file map loading/saving routines instead of the aged, ad-hoc, and (evidently) crash-prone method it was already using.
* This means that the .map format has changed! If you've somehow got a stockpile of .map files, you'll need to import them to a quest file using an older build, then export them using this latest build. (If you're interested, the format last changed, unintentionally, in build 1046.)
* Fixed the bug where making a splitting enemy split into copies of itself would lead to a ludicrous amount of enemies being spawned.
* The above also indirectly fixes the bug where split-off enemies sometimes can't split into further enemies. ( _L_, 2010-09-29 03:11:45 )



Build 1313 - windows
* New Default: Added several new tiles/combos, including some from the NES game Legacy of the Wizard. While we approve of a wide range of available tiles, we are careful to ensure that the default combos should not be too high in number, so as not to overwhelm new users.
* Sorry for the lateness of this build. (If something in your scripts suddenly seems off, it might be because of an obscure missed case in Joe123's ZASM rewrite. Check carefully.) ( _L_, 2010-09-21 00:49:35 )



Build 1312 - linux
* An animated boomerang sprite with a speed of 0 should no longer crash the game. ( Saffith, 2010-09-13 13:00:17 )

* ZScript: fixed the recent bug where eweapon->UseSprite() wouldn't work.
* ZScript: fixed the recent bug where dividing a number larger than 21 wouldn't work.
* Fixed the bug where Patras would sometimes have incorrectly placed or overlapping outer eyes.
* Fixed the bug where walking enemies that split into 3 or more walking enemies would have their 3rd and subsequent children be immobile.
* Now the Armageddon Games splash screen can be dismissed a bit faster. ( _L_, 2010-09-06 08:45:33 )

* Corrected the enemy data validation.
* Hopefully fixed some crashes in ZQuest. ( Saffith, 2010-08-31 21:42:08 )

* Implemented the pre-fix increment and decrement operators in ZScript ( Joe123, 2010-08-30 06:29:35 )

* Comparing Link->Action against LA_SCROLLING should now work properly in the active global script ( Joe123, 2010-08-29 12:14:53 )

* Fixed the bug where you would have to press Joystick button 1 or 2 multiple times to get it to register. ( pkmnfrk, 2010-08-24 09:07:44 )



Build 1304 - macosx-Leopard
* New Default: Fixed the Fire Gleeok's S. Tile.
* Fixed a bug where string control code 3 (Goto If Screen Variable) used the wrong amount of arguments.
* Made the 'Error: Not a custom quest' loading message more meaningful.
* Subscreen Editor: implemented the Arrange submenu items 'Bring to Front' and 'Send to Back'. ( _L_, 2010-08-24 01:20:42 )

* a[b[i]] (or even a[b[c[i]]] etc.) is now a valid operation ( Joe123, 2010-08-23 14:53:45 )

* Whoops! Added the other half of the implementation of Link->HitDir ( pkmnfrk, 2010-08-23 13:09:05 )

* Fix part of the script interpreter ( pkmnfrk, 2010-08-23 09:26:02 )

* Fix the bug where trying to open an old quest (with no Slot 4 script) would crash ZQuest (and, possibly ZC, never tried) ( pkmnfrk, 2010-08-23 09:05:46 )

* Re-wrote quite a lot of the insides of ZASM, which should result in some (albeit probably small) increases in speed, less RAM wasted and much more readable code.
* I've tested this quite thoroughly, and seeing as I've only really changed the way data is passed around inside ZASM it shouldn't introduce any bugs. If you find any, report them and I'll fix them as soon as I can (should only be things like typos though to be honest)
* Fixed LOAD1/2 and SETA1/2, which were wasting away when ZASM got updated internally some time ago. Global scripts now have A registers.
* Each item script's 'this' pointer now points an itemdata rather than an actual item sprite, seeing as the item sprites only lasted for one frame anyway
* Added 'AimEWeapon', 'AimLWeapon' and 'WeaponTypeToID' to std.zh, and overloaded 'GetScreenDBit' to work on different screens to the current one ( Joe123, 2010-08-23 04:16:33 )

* Added documentation for Link->HitDir
* Fixed the line endings in the text files (and, set svn:eol-style to native (as they should have been already!)) ( pkmnfrk, 2010-08-22 23:47:38 )

* Added Link->HitDir. Turns out that if you set Link->Action to LA_GOTHURTLAND, it actually works (it stuns him and knocks him back). Now, we can control that knockback! Link will be knocked back into the direction specified by this variable (if he is facing the right way, of course). ( pkmnfrk, 2010-08-22 23:46:41 )



Build 1296 - windows
* New build for everyone using CreateItem
* Added bounds checking to all of the Screen->Create* and Screen->Load* functions ( Joe123, 2010-08-17 10:14:43 )

* Fixed a crash involving Screen->CreateItem().
* Fixed a recent bug where trying to set npc->Jump with a script would result in too small a value being set.
* Fixed the alphabetical sorting of the script dropdown menus.
* Removed the word 'Slot' from the script dropdown menu items because it makes them a bit hard to visually differentiate names and numbers. ( _L_, 2010-08-14 08:05:16 )



Build 1294 - windows
* Had lots of complaints about std.zh compiling in 1283, it works in this build. Apologies.
* Added 'IsSideview' to std.zh courtesy of Wolfman2000.
* Fixed the 'AngleToDir' functions from std.zh which had their angles the wrong way round. ( Joe123, 2010-08-12 15:22:29 )

* Fixed the line endings on the source files (guys, when you add a new source code file, you should add the 'svn:eol-style' property to it with the value 'native', so that svn manages the end of lines for you!) ( pkmnfrk, 2010-08-09 20:22:32 )

* Fixed a recent bug where trying to set Link->Jump with a script would result in too small a value being set.
* std.zh: Fixed an off-by-one bug with HitboxBottom() and HitboxRight().
* std.zh: HitboxTop(), HitboxBottom(), HitboxLeft() and HitboxRight() can now take FFCs as arguments. The left and top functions aren't really that useful but are included for completeness.
* std.zh: Renamed LoadNPCOf() to LoadNPCOfType(), and added LoadNPCOf() which takes an NPC ID rather than a type. Please adjust your scripts accordingly. ( _L_, 2010-08-08 01:01:52 )

* Put the number of each script next to its name in the ffc dialog, and put a droplist for the scripts in the item dialog ( Joe123, 2010-08-06 03:29:14 )

* Fixed a typo in the script parser ( pkmnfrk, 2010-08-05 17:04:36 )

* Changed the way global arrays are loaded from the save file, which means we no longer need the '~Continue' script - the slot is now free for user scripts. Afraid this means any scripts using global arrays will need to be recompiled again, I'm pretty sure this'll be the last time though.
* Added some names in the 'Assign Compiled Script' dialog which give a little more information about what the global scripts actually do. ( Joe123, 2010-08-05 12:29:56 )

* Added the 'Log Script Errors To Allegro.log' quest rule, which traces things like trying to use invalid NPCs, out of bounds arrays etc. separately to the 'Log Game Events To Allegro.log' rule.
* Arrays can now be initialised to a set of expressions rather than just a set of numbers (ie. int b; int a[] = { I_SWORD1, 3 * 4, b, Pow(5, 6) }; ).
* Memory allocated to strings is now the right length (was slightly too large before), and strings (or initialisers) which are too large for the allocated space will be flagged up at compile time - this allowed for strings with no null terminator to be allocated, but no more!
* Added itemdata->InitD ( Joe123, 2010-08-04 07:52:29 )



Build 1287 - linux
* Hopefully fixed the random crashes that occur when scrolling through the combo list.
* New Linux build. Remember, this will invalidate your old save file, and scripts will need to be recompiled. ( Saffith, 2010-08-03 19:41:39 )



Build 1286 - macosx-Leopard
* Fixed a bug related to the Cycle Combos On Screen Init screen flag an layered cycling combos.
* Fixed the bug where loading 2.10 quests wouldn't properly read their 'Rope 2 Doesn't Flash' and 'Ghini Doesn't Flash/Flicker' quest rules.
* ZQuest: Added a message to the Assign Compiled Script dialog indicating that script slots are automatically updated with the recently compiled scripts.
* Fixed the bug where LW_FIRE lweapons created by a script disappeared about 14 frames earlier than what they ought.
* Fixed the bug where boomerangs would be blocked by screen items if the 'New Boomerang/Hookshot' rule was set but the 'Boomerang/Hookshot Grabs All Items' rule was not set.
* Now, penetrating sword beams and arrows cannot penetrate Aquamentus, Manhandla or Gohma enemies. ( _L_, 2010-08-01 22:49:33 )

* Fixed a bug to do with out of bounds user array elements in ZScript, and improved error tracing when trying to use invalid array pointers
* Added functions for accessing some strings from ZQuest, namely item and npc names, message strings and dmap names, titles and intro strings
* Added a bunch of variables for accessing DMap information to the 'Game' pointer
* Added itemdata->Power
* Added '%x' and '%X' to sprintf, plus a couple of new functions to std.zh
* Started some much better tracing for passing invalid object pointers ( Joe123, 2010-08-01 12:29:14 )



Build 1283 - windows
* New build to address the 'copy file' fix
* Added 'SizeOfArray' and 'Game->GetSaveName' to ZScript
* Added 'ComboFI', some direction handling functions, functions for placing weapons in front of Link and NPCs and 'CreateTimeoutItem' to std.zh ( Joe123, 2010-07-23 15:51:12 )

* Fixed the bug where instantly collecting items with a Boomerang, Hookshot or Arrow wouldn't trigger the Screen State or perform other necessary checks.
* Seemingly fixed the copy file-related startup crash.
* Combo Editor: replaced 'Move' with the somewhat more useful 'Swap' in the right-click menu.
* Added an incomplete version of a new ZQuest.txt revised and rewritten for v2.50. Yes! A new ZQuest.txt! ( _L_, 2010-07-20 09:05:36 )



Build 1281 - windows
* Fixed a slight oversight about changing number of arrays and re-saving your .qst files, updating to this build if you were using the previous one would be a good idea.
* Forgot to point out that the ASM code for array allocation has changed slightly, so any scripts written in previous builds will have to be put back through the parser to work correctly now, apologies.
* Added some script-specific combotypes.
* Seeing as std.zh is getting quite large now, I wrote up an 'std.txt' to go with it - should save some time wasted in trawling through such a big file. ( Joe123, 2010-07-08 14:53:33 )



Build 1280 - windows
* Myself and Gleeok have revamped ZScript's arrays to use random-access memory rather than the current procedural access, which was very slow for large arrays.
* Changed the order of de-allocation of array memory to more closely resemble the 'stack'.
* I'm afraid that this invalidates any save files from previous builds as globals are now saved differently.
* However! Arrays should now be much faster to access and they can be arbitrarily large.
* There are 4095 local arrays to play with, and you can now store as many global arrays as you like with your save file.
* Pointers now work differently (again), and can no longer be offset to access elements further up an array - you must use the array dereference operator from the start of the array.
* string.zh hasn't yet been updated fully to accommodate for this change, apologies.
* Removed 'PointerOffset' and 'Declare' from ZScript.
* Added 'NoAction' and 'WaitNoAction' to std.zh.
* Added 'Round' to std.zh, courtesy of Wolfman2000.
* New build! If you notice any problems with the new arrays, please report them ASAP. ( Joe123, 2010-07-07 12:22:21 )

* Custom Counters! Just what everyone's always wanted, right? 10 of them for use with scripts. ( Joe123, 2010-06-30 13:35:03 )



Build 1274 - macosx-Leopard
* Re-tweaked the walkable water combo hit detection.
* Fixed the Stomp Boots causing Link to get hit while stomping.
* Fourth Quest: fixed the death sounds for Dodongos and Digdoggers. Also slightly decreased Ganon's HP.
* Fixed the running-out sounds for Nayru's Love shields created by removed Nayru's Love items.
* Fixed the bug where an item's Pickup script couldn't call Screen->Message(). ( _L_, 2010-06-30 00:43:04 )

* Added Screen->SetTileWarp to ZScript, which functions similarly to Screen->SetSideWarp.
* Added Game->GetScreenFlags and Game->GetScreenEFlags, which allow access to flags on screens other than the one Link is currently on. ( Joe123, 2010-06-28 11:46:13 )

* Added 'Game->ComboTile', which returns the tile used by a combo
* Added some functions to std.zh for drawing sprites to layers, checking whether Link is using a certain item and checking how many Triforce pieces Link has ( Joe123, 2010-06-28 02:41:02 )



Build 1271 - linux
* The undercombo dialog will now default to the active combo if one hasn't already been set.
* Fixed a problem displaying info types. ( Saffith, 2010-06-26 22:28:55 )



Build 1270 - macosx-Leopard
* Enemy Editor: fixed the Dodongo misc. value dropdown menu. It referred to Misc. Attribute 1 instead of Misc. Attribute 10.
* New Default: fixed the Fire Gleeok weapon damage, the Sword 4 weapon sprite, and the BS Dodongo's death sound effect. ( _L_, 2010-06-23 03:47:21 )



Build 1269 - windows
* Fixed the recurring DMap intro message bug.
* Fixed the bug where using the Link Equipment cheat would incorrectly reset the Super Bomb Ratio.
* Fixed the bug where the Din's Fire and Nayru's Love items wouldn't work right if they had the 'Remove Item When Used' flag.
* Hopefully fixed the bug where flying enemies could intrude on No Flying Enemies/No Enemies combo flags or combos.
* Now, Stomp Boots can have a magic cost and item script attached, and the 'Remove Item When Used' flag works.
* ZQuest: fixed the bug whereby you could edit the '(None)' enemy from the Select Enemy dialog. ( _L_, 2010-06-23 02:59:15 )

* Fixed the bug where Permanent Jinx enemy touch effects weren't working.
* Made the string appearing/disappearing code less crumbly, fixing a bug or two involving empty strings and the Messages Freeze All Action quest rule. ( _L_, 2010-06-16 05:37:32 )



Build 1267 - macosx-Leopard
* Fixed the Combos Carry Over crash.
* Link should no longer be frozen when a timed warp activates while a DMap intro message is printing.
* NES Movement: Fixed the bug where Link wouldn't spin correctly if he pushed against a solid combo while hurricane spinning.
* NES Movement: Fixed the bug where Link could move while slashing if he'd just finished tapping his sword. ( _L_, 2010-06-06 03:37:00 )



Build 1266 - windows
* Very minor optimizations to ZScript. ( Gleeok, 2010-05-31 23:37:02 )

* Fixed the bug where the EX buttons in the Key Buttons dialog couldn't be clicked.
* Fixed a bug where strings longer than 72 characters wouldn't work with the 'Messages Freeze All Action' quest rule.
* ZQuest: Fixed the 'Automatic Save Screen' screen info message.
* String Editor: Fixed the bug where clicking 'Duplicate' then 'Cancel' would mess up the '<New String>' option. ( _L_, 2010-05-29 23:25:30 )

* Fixed a bug where layered damage combos (and who knows what else) from previous screens were recurring invisibly in subsequent screens.
* Seemingly fixed a bug where null enemies were being instantiated and not being put in the guy list... presumably causing a memory leak.
* Now, shallow water ripple and tall grass decorations aren't drawn when Link vanishes with Farore's Wind (or Link->Invisible is set). ( _L_, 2010-05-23 00:35:55 )



Build 1262 - linux
* Fixed a couple of issues with reflected weapons. ( Saffith, 2010-05-18 17:40:03 )



Build 1261 - macosx-Leopard
* Fourth Quest: fixed the Abei 2 guys, the Dodongo CSet and the exits to Level 5.
* Fixed the bug where old quests had incorrect Dodongo or Digdogger Hit Sounds and Death Sounds.
* Fixed a crash involving temporary filenames... I think. ( _L_, 2010-05-17 09:49:57 )

* Corrected super bombs' flag triggering region.
* Flying Peahats are no longer immune to things that kill all enemies.
* Link can once again use the ladder to walk over half a tile of water when he has the flippers. ( Saffith, 2010-05-17 09:39:34 )

* Fixed enemies in old quests. That doesn't necessarily mean they all behave corectly, but they should all act the same in both old and new quests now. ( Saffith, 2010-05-15 13:17:17 )



Build 1257 - linux
* And here it is for Linux. ( Saffith, 2010-05-13 06:19:35 )



Build 1256 - windows
* New Windows build. *IMPORTANT* PLEASE REMEMBER TO BACK UP YOUR DATA!
* Portions of the code for the way screens/maps in ZC and ZQuest have been modified/fixed/re-writ to fix many underlying stability and memory issues for the next release. As a result of this any previous bugs dealing in that regard are presumably fixed. For anyone beta testing this build the above changes are number one priority if something doesn't work right.
* Temporarily disabled the timed autosave function in ZQuest for the benefit of ...well, for the benefit of your own good. =P (Just a safety precaution is all.)
* ..Sorry for all the grim warnings; ZC is now presumed to be stable after all these builds, we don't want anyone to lose any work due to a slight oversight, is all. -Also be sure to test out the 4th quest. :-D ( Gleeok, 2010-05-13 01:31:54 )

* ZQuest: May have fixed a preview or misalign error in large mode. ( Gleeok, 2010-05-11 13:16:49 )

* Fixed trap movement in old quests. ( Saffith, 2010-05-10 19:45:42 )

* Added the Fourth Quest. The quest-making contest resulted in a tie of sorts between Questwizard and HeroOfFire, and both of their quests had some great parts and some not-great parts. So, I got approval to make a quest file containing only the great parts from both quests. Fourth Quest consists of HeroOfFire's overworld and Questwizard's dungeons. (Due to luck, very little of either quest had to be adjusted to make them fit together.)
* It was, of course, not a requirement that the Fourth Quest submissions be harder than Third Quest (a task which is itself a bit hard to imagine). But, given the oddness of sending the player to the easier Fourth after finishing Third, I decided to make things a bit more interesting than that. So, if you finish Second Quest with all 16 heart containers found, you get sent to the more exploration-based Fourth Quest. Otherwise, you get sent to the combat-based Third Quest. (Yes, I've tested this.)
* There is, of course, a password to skip to Fourth Quest directly. It is 'GANON'.
* Also, creating a Fourth Quest save file will turn the select menu's colours to redder hues, as an easter egg.
* Replaced 1st.qst, 2nd.qst and 3rd.qst with their proposed versions.
* Added a level 4 cheat, 'Kill All Enemies', which just does the same thing that the Kill All Enemies item does.
* Fixed the bug where 2.10 quests' Armos enemies had their type set to '(None)'.
* New Default: changed the walkability of those half-sized Pound combos.
* Large Mode: enlarged the 'Requires Authentication' dialog. ( _L_, 2010-05-08 10:12:38 )

* Fixed a memory leak shared from the maps code in zc and zquest. How bad it is depends on how many maps your quest has and how many times you reopen or reload it in zquest in a single instance. This should be pretty much the last of them in zc, so that's the good news. ( Gleeok, 2010-05-07 10:09:08 )

* Minor fixes to the way some memory is handled in zc. ( Gleeok, 2010-05-03 16:50:05 )

* Fixed some rather nasty memory leaks when loading quests in the player. ( Gleeok, 2010-05-03 03:37:55 )

* Fixed a bug that prevented several enemy animation types from correctly drawing extended enemy sprites larger than 1x1.
* Fixed the bug where ZC's Sound Settings dialog wouldn't save changes.
* New Default: now, 'import "std.zh"' is included in new quests' ZScript buffers. ( _L_, 2010-04-30 09:40:10 )

* Sayonara to the critical bug where dialogs could get corrupted in the player...Especially the Joystick configuration menu for some reason. ( Gleeok, 2010-04-28 03:13:38 )



Build 1233 - linux
* Sorry, screwed up 1231. This one's good. ( Saffith, 2010-04-25 13:55:17 )



Build 1232 - windows
* Third time lucky; I definitely actually added string.zh and string.txt ( Joe123, 2010-04-25 10:28:12 )



Build 1231 - linux
* Added an integrity check in hopes of tracking down a data corruption bug. ( Saffith, 2010-04-25 07:36:40 )



Build 1229 - macosx-Leopard
* Fixed the bug where the Hover Boots' Hover Duration didn't work quite right in top-down view.
* Fixed the Death SFX for Walking Enemies that Split On Death.
* String Editor: Added a Help button which, when clicked, describes all of the Control Codes and their arguments as documented in the wiki. A somewhat blunt solution, but nonetheless a usable one. ( _L_, 2010-04-20 08:35:53 )



Build 1228 - windows
* Sorry to put out a new build so soon, but string.zh should now be finished.
* Fixed a small problem with PointerOffset, restricted TraceS to 512 characters as very large traces were causing issues, removed the '
' from the end of TraceS (you can add one in the string with printf) and removed some garbage traces that were occurring when script memory was allocated.
* string.zh brings you most of the string manipulating functions from cstring.h, plus sprintf and printf and some new ones which should help bring a lot more functionality to our ZScript strings. ( Joe123, 2010-04-20 02:25:50 )



Build 1226 - linux , windows
* Seemingly fixed the issue with the palette getting corrupted in fullscreen under Windows.
* About time for a new Linux build, too. ( Saffith, 2010-04-17 12:11:32 )

* The default Win32 gfx mode settings when running zc for the first time is now 640x480 for the benefit of modern video hardware. ( Gleeok, 2010-04-16 01:23:42 )

* DrawString should now sort correctly on layers in somewhere around log(n) time. ( Gleeok, 2010-04-15 14:33:15 )

* Added PointerOffset to zscript.txt
* ...Which should allow string.zh to be added soon; check on the forums to see a beta version ( Joe123, 2010-04-15 04:39:53 )

* Due to the upgrade of arrays I've swapped the last two arguments of DrawString to match the API of the other string functions. Due to a loophole in the previous system, the pointer to array had to be input last, but no more! My apologies if this affects your scripts. ( Gleeok, 2010-04-15 03:09:32 )

* Fixed the bug where enemies with the 'Invincible' flag set could be killed by the ring leader enemy dying or the kill all enemies item
* Fixed the bug where draw primitives from the previous screen would appear for a frame after warping via a zap warp
* Added some more string-related functions to std.zh ( Joe123, 2010-04-12 03:37:43 )

* Added more math functions to std.zh. These are: CrossProduct(); DotProduct(); SmoothStep(); DistanceSquared(); and MidPoint(); . ( Gleeok, 2010-04-11 22:18:18 )



Build 1213 - windows
* Changed the way DrawString reads its string argument; it now accepts the array pointer rather than the first element of the string
* Added TraceS, which traces a string to std.zh
* Added some functions to std.zh for dealing with strings and ascii characters
* New windows build. Hopefully it won't cause any issues; we've had a lot of compiler-specific bugs recently... ( Joe123, 2010-04-11 14:01:04 )



Build 1211 - macosx-Leopard
* Large Mode: enlarged the Tile Grabber. With this, I do believe that the ZQuest large interface is complete. If you can find any remaining dialogs that haven't been updated, do tell.
* Added a 'Load Quest' menu option to Zelda Classic, which new users can use to load custom quests in addition to the unusual method we currently use. It is only available when a registered but unoccupied save file is selected.
* ZScript: Fixed a bug where creating a '(None)'-type enemy with a script would crash ZC. ( _L_, 2010-04-09 08:20:35 )

* Combos Carry Over now carries combos on layers to the next screen
* Fixed a bug with the layer 7 draw-primitives involving insta-warp with blackout ( Joe123, 2010-04-07 12:18:59 )

* Fixed an inconsistency with 2.10 where having solid combos on layers 1 and/or 2 above 'Hookshot Only' combotypes would stop the hookshot from being able to pass through
* Made it a bit clearer in the Init Data how initial amounts of magic should be set
* Now if the quest rule 'Subscreen Appears Above Sprites' is set, draw primitives can access layer 7 which is above the subscreen ( Joe123, 2010-04-07 10:23:22 )

* Fixed a problem where warps with combos carried over copying garbage instead, as well as a related crash.
* Fixed crashes in the MIDI info dialog. ( Saffith, 2010-04-06 12:14:30 )

* ZScript: Fixed a bug where moving a Like Like that was eating Link wouldn't also move Link.
* Enemy Editor: renamed 'Bomb' and 'S.Bomb' to 'Bomb Blast' and 'S.Bomb Blast'. As you know, previously these functioned identically to 'Lit Bomb' and 'Lit S.Bomb'. Now, non-Bombchu enemies with these weapons will have their data updated to use the 'Lit' weapon, and using 'Blast' weapons from now on will do nothing unless the enemy is a Bombchu (Rope Walk Style + Explode Death Type).
* Enemy Editor: added misc. value labels for Traps. Note: combining '4-Way' and 'Constant' will just make the Trap randomly choose vertical or horizontal when it's spawned.
* Mac OS X: Fixed the bug where the ZQuest default path wasn't outside the application bundle. ( _L_, 2010-04-04 04:13:48 )

* Fixed the bug where a Like Like eating Link while he was exiting water would freeze Link.
* ZScript: Fixed a bug where calling Screen->ClearSprites() while Link was using the hookshot would freeze Link.
* Enemy Editor: Added two more misc. attribute labels for the Projectile Shooter.
* Now, items with a tile of 0 will be invisible. ( _L_, 2010-03-29 08:57:24 )

* Fixed the bug where Wizzrobes could be knocked back.
* Increased the Super Bomb's combo flag-triggering hitbox back to 2.10 size.
* Large Mode: fixed most all of the Subscreen Editor's options dialogs. They should all look fine now. ( _L_, 2010-03-24 03:12:06 )



Build 1204 - windows
* Fixed the bug where Sensitive Warp combos didn't function as FFCs.
* Now, the 'Combos Carry Over' warp checkbox works for Entrance/Exit warps.
* Subscreen Editor: Fixed the bug where clicking to select elements wouldn't work. ( _L_, 2010-03-21 03:50:42 )

* Fixed the bug where Vire-type and Pols Voice-type Walking Enemies could spawn on solid combos.
* Fixed the bug where Gohmas could use the 'Breath' and 'One Shot' firing types at the same time.
* New Default: Restored the Gohma 4's default weapon to 'Flame'.
* Fixed the bug where the Tile Editor's right-click menu would sometimes be shorter than what it ought depending on the recent use of the Combo Editor.
* Now, Lock Block combos are suppressed if they are used as part of a Locked Door, to ensure that the door's trigger takes precedence over the Lock Block. The same applies to Boss Lock Blocks and Boss Doors.
* Now, most all door-unlocking events are correctly logged to Allegro.log. ( _L_, 2010-03-20 00:45:13 )



Build 1202 - linux
* Fixed a set of crashes that could occur when changing the map count, placing flags on layers, and possibly other times. ( Saffith, 2010-03-17 08:07:22 )



Build 1201 - macosx-Leopard
* Fixed the bug where the default Link boomerang sound would prematurely cease when Link killed a Walking Enemy.
* Fixed a momentary bug where flying enemies could fly downward onto 'No Enemies' combos.
* Sideview: Now, both diagonal and NES movement (formerly just the latter) permit Link to use the Stepladder to ascend upward, which is, as you know, useful insofar as it synergises with the Hover Boots or extends the vertical reach of the Roc's Feather. ( _L_, 2010-03-15 09:43:22 )



Build 1200 - windows
* Fixed a divide-by-zero crash concerning an enemy with a Summon shot type but set to summon 0 enemies.
* Fixed the death sound of Walking Enemies with Rope movement and a projectile weapon.
* Fixed the use of Death Attr. 1 and Death Attr. 2 by Walking Enemies with the 8 Shots death type. ( _L_, 2010-03-14 00:59:47 )

* Now, Link can attack while inside a Like Like regardless of the 'Can Use Items/Weapons on Edge of Screen' quest rule.
* Fixed the bug where Patra outer eyes used the wrong hit and death sound effects. ( _L_, 2010-03-13 06:43:08 )

* Improved the enemy Sideview behaviour a bit more with regards to half-walkable combo platforms.
* Fixed the bug where some Hookshot chain links were left behind if Link's direction was changed by a script while using the Hookshot.
* Enemy Editor: now, misc. values which are bounded by a dropdown list are bounded by the droplist's range as soon as you change the enemy to that particular family.
* Spin Tile enemies can no longer fall. ( _L_, 2010-03-12 06:37:52 )

* Large Mode: enlarged the Subscreen Editor, the Palette Grabber, the Tile Leech dialog, and the Open and Save dialogs.
* Fixed the position of the OK button in the CSet Editor.
* ZQuest: Removed the 'Save as 2.10' option. ( _L_, 2010-03-07 03:31:06 )

* Fixed some more memory issues.
* One last fix (hopefully) to that level 1 bug in proposed1st.qst.
* Also fixed a couple of incorrect tiles in the proposed quests' overworlds. ( Saffith, 2010-03-06 14:50:52 )

* Changed some implicit casts with Jump variables
* All weapons obey their Jump variables on top-down screens
* Documented item->Jump which was missing from ZScript.txt ( Joe123, 2010-03-06 13:44:44 )



Build 1194 - windows
* Fixed many issues with the gui and reverted some changes I made around build 1170. This fixes a whole slew of things. -END_OF_MAIN is now correct.
* Fixed the palette grab crash bug. (Finally) -Removed some debug logging info related to that. ( Gleeok, 2010-03-05 19:02:51 )

* Fixed the bug where the quarter hearts tiles on the File Select screen were often incorrect.
* ZScript: now, Game->GetScreenState() and Game->SetScreenState() now correctly count maps from 1 upward (as indicated in zscript.txt) rather than 0 upward.
* Improved the logging of screen state changes - distant screen state changes are differentiated from current screen changes, and correctly report the Door states' changes.
* Now, items without a 'Once Per Screen' flag set won't suppress similar-classed items with a 'Once Per Screen' flag set if both were used in succession in one screen. ( _L_, 2010-03-05 09:08:23 )



Build 1191 - linux


Build 1190 - windows
* Let me try this again. ( Gleeok, 2010-02-28 16:42:59 )

* Hopefully fixed some underlying problems from the last few Windows releases which manifested mainly in ZQuest/ZQuest GUI and might have led to possible corruption, crashes, petty shenanigans, or nothing at all. Please remember to backup your quest files!
* - THESE CHANGES APPLY TO BUILD 1188! - ..Sorry, I kind of messed up the previous message. ( Gleeok, 2010-02-27 17:28:52 )



Build 1188 - windows
* Fixed the bug where the cancel button in the tile goto page dialog didn't work right. ( Gleeok, 2010-02-27 16:24:20 )

* Fixed some implicit casts from double to long which were causing problems with some of the trig functions and logarithms in ZScript.
* Documented ArcSin and ArcCos, which I added some time ago but were affected by the casting issue.
* Link->Equipment can no longer be set - I overlooked some (quite large) issues when adding this functionality. My sincerest apologies to those who were using this in their scripts.
* Made a slight change to how array 'pointers' are stored internally which should now make it valid to pass them as arguments to functions. ( Joe123, 2010-02-27 09:37:49 )

* Finally fixed the bug where the control codes 13, 14 and 15 weren't working quite right.
* Enemy Editor: fixed the bug where changing an enemy's family in the editor would cause the wrong set of misc. labels to be used until the dialog was closed.
* Enemy Editor: Added misc. attribute labels for Wizzrobes, Dodongos, Keese Tribbles and Keese.
* ZQuest: changed the names of several fonts to more accurately describe them. For instance, 'lfont' is now 'GUI Font Bold'. ( _L_, 2010-02-26 22:47:07 )

* Fixed the bug where hitting grave combos in quests where there are no grave enemies defined period will crash the game.
* Fixed the bug where placing a secret flag on top of a sword trigger flag prevents the secret from ever triggering when hit. ( jman2050, 2010-02-23 08:59:39 )



Build 1182 - windows
* For great Justice, someone set up us the Windows build!
* Link should no longer be able to spawn touch enemies without touching them.
* Fixed the bug where viewing flags on layers were totally wrong. ( Gleeok, 2010-02-23 06:16:42 )

* New Default: Swapped around the pickup sounds for the 'Triforce (Fragment)' and 'Triforce (Whole)' items, which were somehow incorrect.
* New Default: Added back a tile used by the ending cutscene when the 'BS-Zelda Animation' rule is set.
* New Default: Updated the tiles for the Magic Pols Voice.
* Zelda Classic will now use zelda.nsf for the title screen and the ending music. Also, Triforce Pieces with the Cutscene MIDI value set to 0 will use zelda.nsf. But if that file is missing, ZC will fall back on the MIDIs.
* Proposed1st, proposed2nd and proposed3rd now use zelda.nsf for their DMap music.
* Now, ZC will attempt to load extended music files from the directory the quest file is in as well as the assigned Quest Directory. This should remedy some confusion!
* Mac OS X: The default path for loading custom quests is now outside the
* Tile Editor: Now, you'll no longer get Destination Warnings for unimplemented enemies. ( _L_, 2010-02-22 18:59:46 )

* Increased Heart Containers' maxmimum from 16 hearts to 24 in old quests and default data.
* Hopefully fixed crashes related to MP3s and Oggs. ( Saffith, 2010-02-21 22:59:11 )

* Fixed the bug where Link would be frozen in mid-spin if he started falling in sideview while hurricane-spinning.
* ZQuest: Fixed that bug where the cursor disappears in Combo Alias mode. Score!
* Added several Combo Aliases to the New Default tileset.
* The Combo Selector's tooltip now shows the inherent flag of a combo if it has one. ( _L_, 2010-02-21 04:41:02 )



Build 1177 - linux
* Fixed some memory issues that may have been causing problems. I know at least one crash on Linux is fixed. ( Saffith, 2010-02-19 14:39:26 )

* Scripts can read enemies' misc. attributes 11 and 12 now.
* Link should no longer drop his sword if hit when charging or spinning.
* Finally fixed the problem of the cursor going off the right side of text fields in large mode. ( Saffith, 2010-02-18 10:12:02 )



Build 1174 - linux
* High time we had a new Linux build.
* Fixed grave-spawned Ghinis in old quests.
* Link again holds up items correctly in the water.
* BS Patras no longer crash the game. ( Saffith, 2010-02-15 08:17:28 )

* Fixed the bug where Breath weapon-using Walking Enemies had a tendency to fire southwest more often than not.
* Fixed the bug where shop items could be stolen with the Hookshot.
* Made it so that shops won't crash if a script destroys the 'rupee sign' item or shop items.
* Fixed the fix to the bug where it was possible to pick up multiple items from 'Take One Item' and 'Red Potion or Heart Container' room types if the 'Items Disappear During Holdup' rule was unchecked.
* Fixed the bug where Dive Warp and Swim Warp combos weren't working.
* Fixed the bug where Link wouldn't hold up an item collected with an upward-facing hookshot. ( _L_, 2010-02-14 05:52:06 )

* Fixed the this->misc[] bug leftover from last build. ( Gleeok, 2010-02-13 20:22:53 )

* std.zh: ComboAt() has been broken for a while. It's fixed now.
* Enemies' Misc. Attributes 11 and 12 should stay set correctly and save now. ( Saffith, 2010-02-13 19:34:07 )



Build 1170 - windows
* Obligatory Warning Message: Change to allegro42.dll. For this reason executables from this build (or higher) will not work with older allegro DLLs. So don't try to copy them around to different folders without including the proper DLL. ..Assuming I've done this right and haven't forgotten anything that is..(*crosses fingers and sacrafices a virgin to Microsoft. "Oh great one, show us the way.")
* Added even more annoying allegro.log traces to help track down a palette grab crash bug.
* Hopefully fixed all the scripting misc[] arrays so they wouldn't truncate to int. ( Gleeok, 2010-02-13 01:40:10 )

* Set chuck_norris=true thus effectively fixing the following bugs with deadly roundhouse kicks. :^D
* ZC: Issue where some non-guys would use SFX 15 when hit
* ZQuest: Ordering of custom item classes is now ordered properly.
* ZC: Odd disappearing Link intro message bug probably fixed.
* Bug where warping DMaps using different subscreens would delay fixing your A - B selected items until you warped again or changed screens. It's fixed.
* Creating relational and dungeon template tiles in ZQuest now makes the visible. ( Which helps alot :P )
* -Also fixed the bug where you couldn't save after creating all those dungeon template tiles.
* ZScript: Finally got around to finishing Screen->DrawString which, using ancient voodoo magic -woooo, can take all or part of a zscript string array as an argument! :O -Then render it using any one of the internal zc fonts and format it in a few different ways. And so, the drawing commands are considered complete for 2.5. Sorry this took so long.
* zscript.txt and std.zh have been updated accordingly. ( Gleeok, 2010-02-12 04:36:04 )

* Enemy Editor: added 2 more misc. attributes for enemies. These are intended for exclusive use by ZScripts using npc->Attributes[].
* Also, unused misc. attributes are now labeled 'Misc Attr. 2' and such, rather than '<Unused>'.
* Fixed the bug where Pols Voices could have damage knockback. (I checked, and apparantly they shouldn't.) ( _L_, 2010-02-11 09:48:48 )

* Fixed cursor and checkmark position in the CSet editor.
* Fixed (correctly, I think...) the issue where the colors used for transparency would sometimes suddenly change to less accurate ones. ( Saffith, 2010-02-10 11:18:51 )



Build 1164 - windows
* New Windows build! -Tweaked slightly some minor compiler settings. If there is any difference in frame rate from the previous build let me know.
* Romview: Completely disabled the -scale commands as they were completely broken and would do bad things. Very bad things indeed. ( Gleeok, 2010-02-07 21:53:01 )

* Fixed the Patra and BSPatra crash when odds were zero.
* Fixed possibly the Moldorm custom death SXF inselectablllity.. uhh thingy.
* Fixed the Autosave Combos, which should actually work now.
* Fixed the bug where Aquamentus fireballs did not obey the new SFX rule.
* Fixed the bug where picking up items, or some other cases where ZC checks subscreen items, would screw up your selected A - B equipped items. ( Gleeok, 2010-02-07 20:56:11 )

* Small fix to the previous Fire Gleeok neck fix.
* Fixed Dodongo CSet in some old quests. ( Saffith, 2010-02-07 09:45:08 )



Build 1161 - macosx-Leopard
* Large Mode: enlarged the Edit CSet dialog, the Palette Editor dialog, the New Subscreen dialog, and hopefully all of the options dialogs in the Subscreen Editor.
* Fixed the bug where selecting multiple tiles in the Tile Editor and changing them to 8-bit would often alter the wrong tiles.
* Large Mode: Changed the names of the commands 'Main', 'Levels' and 'Sprite Colors' to 'Palettes - Main', 'Palettes - Levels' and 'Palettes - Sprites'. ( _L_, 2010-02-07 02:02:23 )

* Fixed the Dodongo and Digpuppies SFX bugs. ( Gleeok, 2010-02-05 22:19:35 )

* Fixed a bug with the menu in ZC and also tweaked it a little.
* Put some functions into std.zh: SetScreenDBit() and GetScreenDBit(), as well as some others courtesy of Joe123. ( Gleeok, 2010-02-05 21:38:23 )



Build 1158 - linux
* Fixed Fire Gleeoks' necks in default data and old quests.
* Also fixed their failure to breathe fire in old quests.
* Default SFX names are now set correctly for old quests. ( Saffith, 2010-02-04 14:09:44 )

* Fixed the bug where Lanmolas with more than 253 segments would cause a crash.
* Also, now Lanmola, Gleeok, Patra and Moldorm segment counts are internally capped at 254 (which, plus the central enemy, makes 255, the maximum amount of permitted enemies). If there are already too many enemies onscreen at the time, then the boss is simply not created.
* Fixed the bug where the 'Armos (NES)' animation type wasn't working right for hastened Armoses.
* Changed the 2009 copyright to 2010. http://bit.ly/b91UFI ( _L_, 2010-02-03 22:32:01 )

* Fixed a crash in the DMap editor.
* Fixed a possible minor issue with fairies.
* Changed the level 1 locked door glitch in proposed1st.qst a bit. Should be just right now. ( Saffith, 2010-02-02 15:18:32 )

* Fixed a few potentially fatal bugs that might occur trying to copy, paste, or undo across multiple loaded quest files. This is no longer possible. That's what the export map function is for!
* For future compatibility with 2.6, Quad3D and Triagle3D are now simply Quad and Triangle. ( Gleeok, 2010-02-01 15:28:44 )



Build 1154 - windows
* Part 2 :P
* [ZCL] The source code has been updated for Lazarus 0.9.28.2. I was still using 0.9.22 so it needed updated so that means I'm also using the new fpc compiler. ( Sean, 2010-02-01 04:58:47 )

* [ZCL] Corrected some issues pertaining to the window scale modes. The were not showing up like it was supposed to.
* [ZCL] Images on the right side of the color scheme chooser was not supposed to be there. Now gone. A whoops on my part.
* [ZCL] Stripped out old code that wasn't being used there. It was just there for backup purposes. ( Sean, 2010-02-01 04:54:14 )



Build 1152 - linux
* The linux builds need more loving :P A new build for linux ;) ( Sean, 2010-02-01 03:41:51 )



Build 1151 - windows
* Added extra debugging code to the exit routines of zquest and zc.
* "-triplebuffer" option is now also available via command line. ( Gleeok, 2010-01-31 23:48:17 )

* Screen->Message() now respects the default text speed.
* Fixed boomerang movement after picking up an item LttP-style. ( Saffith, 2010-01-31 13:26:16 )

* Fixed a bug where script arrays would not be allocated properly. ( pkmnfrk, 2010-01-28 16:58:48 )

* Changed the way Link->InputMouseX/Y work: Now, the origin of the mouse is the top-left corner of the playing field, rather than the top-left corner of the window. The subscreen exists at negative Y values.
* Twiddled with the start-up code a bit to try and reduce the chance that the programs will crash BEFORE printing out a useful message. Would be best to eliminate crashes altogether, but let's take it one step at a time ;) ( pkmnfrk, 2010-01-28 15:44:41 )



Build 1145 - macosx-Leopard
* Large Mode: enlarged the DMap Editor.
* Integrated the Armos into the 'Walking Enemy' family. They use the 'Armos' Walk Style and their Misc. Attribute 10 determines the alternative step speed they can use.
* Enemy Editor: Added an option to select the spawn animation for Walking Enemies. Its options are 'Poof' (used by most enemies), 'Flicker' (used by Armos and phantom Ghinis) and 'Instant' (the enemy instantly appears). These are used in all cases except when enemies Enter From Sides.
* Now, all non-phantom Ghinis are Walking Enemies, and all enemies in the Ghini family are phantoms. You might seem unsure of this, but rest assured that this is correct.
* Enemy Editor: Removed the unused enemy families from the list, as well as the Fairy and Guy types. Also, other options unusable with the current enemy family are disabled.
* Rule Sets: removed 'Invincible Link Flickers' from the 'Zelda 3-esque' ruleset. ( _L_, 2010-01-28 07:18:22 )

* ZQuest: Possibly fixed a few issues where there might have been a hang or crash on exiting zquest. (Hopefully) there are no side effects from this and zquest is getting more and more stable.
* Optimization: Fixed an issue where the drawing commands were doing extra allocations. The net result is that anyone using a lot of drawing functions should see a noticable performance increase from this. ( Gleeok, 2010-01-28 06:37:18 )

* Fix the bug where disabling the Hover Boots, wouldn't. Also potentially fixes other potential cases where disabling items doesn't work to it's full... potential. ( pkmnfrk, 2010-01-27 18:15:57 )

* Finally fixed the bug where you could not have a negative constant in ZScript. (Gleeok was right, this was more difficult than it sounds)
* Added support for "empty" declared arrays. That is, the following construct:<br><pre>int myarray[] = {1, 2, 3}</pre><br>The result is an array that is three elements long. Good news: Less maintenance to update arrays. Bad news: No sizeof() operator... yet.
* Also, you can do the same thing with strings:<br><pre>int mystring[] = "ZScript is fun!"</pre>
* Do note that strings declared in this manner will get an extra 0-filled element at the end (to terminate the string). Regular arrays will not, however. ( pkmnfrk, 2010-01-27 17:25:05 )

* Fixed the bug where you may not of been able to have multiple instances running.
* Now in the config file you can set another variable 'triplebuffer', which will always try to run zc using video memory when set, which may or may not be what you want to do. This is set to disabled in windowed mode by default. If you are wondering, the doublebuffer setting located right above it takes precedence so there's no point in changing both. ( Gleeok, 2010-01-26 05:06:07 )

* Fix the bug where eweapon->Step and lweapon->Step were returning totally bogus values.
* Fix the bug where allegro.log would sometimes get padded with tons of nulls. While we're at it, perhaps we should have separate logs for Zelda Classic and ZQuest?
* Finally, I (presumably) figured out how to have more than one item show up in the change log. ( pkmnfrk, 2010-01-25 18:05:30 )

* I've tied up some loose ends with regards to the enemy Defenses update. Now, Aquamentuses, Manhandlas, Gleeoks, Gohmas and Patras can use Defense values too. A note about Patras: the central core eye uses the same Defenses as the orbiting eyes, but any weapon that would do damage is ignored unless all orbiting eyes are slain. A note about Gohmas: after Defenses are checked, any weapon that would do damage is blocked if it isn't fired vertically at the Gohma's open eye.
* Enemy Editor: added labels for Aquamentus, Manhandla and Gohma misc. attributes.
* Enemy Editor: in addition to a background sound, you can now edit the enemy's Hit Sound and Death Sound, which are played when the enemy is hit and slain, respectively.
* Also, Defense dropdown menus are disabled for enemies that don't use Defenses, and the respective Anim. Type dropdown menu is now disabled depending on the setting of the 'New Enemy Tiles' quest rule.
* Fixed the bug where the Gohma 4's default weapon was Fireball instead of Flame.
* Fixed the bug where the hookshot could sometimes shoot through Hookshot Grab combos on layers 1 or 2.
* std.zh: Sanitised ComboAt() so that it restricts X and Y to the visible screen. ( _L_, 2010-01-25 08:54:37 )

* Added "Doesn't count as beatable enemy" to the Boulder enemy ( pkmnfrk, 2010-01-24 22:49:12 )

* Stripped all default wizzrobes of their "Not counted as beatable enemy" status, and gave it to all traps! ( pkmnfrk, 2010-01-24 21:44:05 )

* Fixed the bug where the Ring's magic cost was being charged twice, thus doubling its magic usage.
* Fixed the bug where FFCs in screens 0x80 and 0x81 with the 'Run Script On Screen Init' wouldn't have their scripts run before the screen was drawn.
* New Default: Fixed the Bait's default Duration value.
* Changed the Dodongo's CSets in the proposed quest files from 8 to Extra Sprite Palette 2.
* Fixed the bug where Link could be moved out of a Like Like or other enemy that had swallowed him.
* Hopefully fixed the bug where grabbing a screen item with a vertical hookshot while the Hold Up Item Screen Flag set wouldn't let Link hold up the item.
* Fixed the bug where a Walking Enemy with Vire-type movement that ate Link in mid-jump couldn't be attacked by Link. ( _L_, 2010-01-23 06:23:57 )

* std.zh: Added Lerp(), TurnTowards(). Working with angles should be a little easier now.
* Also added some functions by Joe123: SwapTileRow(), SwapTileBlock(). CopyTileRow(), CopyTileBlock(). ClearTileRow(), and ClearTileBlock(). ( Gleeok, 2010-01-22 19:43:03 )

* Fixed a bug where Walking Enemies with a Misc. 10 value greater than 0 wouldn't use their Defenses or Misc. Attributes correctly.
* Fixed the bug where using the sword, then pressing the button for an Item Override item while it is slashing, would glitch the sword's sprite and other attributes.
* Fixed the bug where the Boomerang wouldn't use its Range value properly if its weapon sprite was set to something other than the default.
* ZScript: Added npc->Stun, which is the number of frames that the NPC will be stunned. You can read or write this value. Some types of enemies can't be stunned, or behave differently when stunned - for instance, the Dodongo becomes vulnerable to swords.
* ZScript: Added npc->Defense[], which is an array of the NPC's Defense values. You can read or write these values, so go wild. ( _L_, 2010-01-21 20:20:03 )

* ZQuest: Fixed the palette editing menus so that it allows you to save after editing palettes, names of level palettes, or anything related to palettes. In fact, if you exit the menu without changing anything please do not consider it a bug that you now have the option to save your quest file.
* Insert/Clear in the combo editor is now Insert/Remove. Swapped "Clear" with "Delete" which was backwards in the right-click menu, and _L_ added some warning messages if you try and Insert/Remove mass combos. ( Gleeok, 2010-01-19 00:53:41 )



Build 1129 - windows
* Fixed the bug where changing Link's direction with a script wouldn't properly dispose of Hookshot sprites.
* Fixed the bug where a Fire Gleeok's weapon would always be Flame regardless of the setting. (But, a Gleeok with a Breath shot type but no weapon will use Flame by default.)
* Enemy Editor: fixed the Gleeok's Shot Type labels.
* Fixed screen (2,6D) in proposed2nd.qst.
* std.zh: Removed the NPCT_ entries for deprecated enemy types. ( _L_, 2010-01-16 00:35:46 )

* Fixed the bug where setting a Whistle item's Warp Ring to -1 wouldn't prevent the whistle whirlwind from appearing when said item was used.
* DMap Editor: Fixed the bug where the Map selectors were drawn incorrectly in Large Mode.
* Fixed the bug where Link couldn't be killed by picking up an item that lowers Link's health.
* ZScript: Sanitised the Game->GetComboData() and related functions so that a crash won't occur if zero or negative map or screen values are passed.
* New Default: fixed the default Boomerang weapon sprites. They now use Corrected Animation. ( _L_, 2010-01-14 02:39:16 )

* Fixed old quest compatibility issues with unwalkable doors, fairy guys in dungeons, and the Lens of Truth. ( Saffith, 2010-01-11 12:58:35 )

* std.zh: Reverted the recent fix to Angle() and RadianAngle(). It turns out that the real bug was with the VectorX() and VectorY() functions. These have been fixed!
* Fixed the bug where the ladder would sometimes appear even though Link did not possess it.
* Fixed the bug where tribble-type enemies would sometimes not change at the right time. ( _L_, 2010-01-11 06:55:09 )



Build 1125 - linux
* Fixed a quest loading bug that cropped up in build 1124. Use this one instead. ( Saffith, 2010-01-09 22:09:15 )



Build 1124 - linux
* Fixed a crash when the working layer was disabled.
* New Linux build. ( Saffith, 2010-01-07 14:23:27 )



Build 1122 - macosx-Leopard
* ZScript: changed the implementation of HitYOffset. Previously it included the screen's subscreen offset value (which is 56, or 0 if the No Subscreen screen flag is set). Now, getting and setting HitYOffset won't affect this.
* ZScript: changed the implementation of Game->GetComboData() and such, as well as Game->GetCurMap(), such that maps are now counted from 1 upward rather than 0 upward. That was getting too confusing. (Note also that Game->GetLayerMap() already did it this way.)
* std.zh: Fixed the code of Angle() such that 0 degrees again refers to a right vector rather than (as it was recently) an upward vector. Also fixed the documented direction from clockwise to counterclockwise, and added AngleCW() and RadianAngleCW() for those who still need clockwise angles.
* std.zh: Fixed the WPN_ constants, which were all incorrect.
* Subscreens: Fixed the bug where Current Item elements in a passive subscreen wouldn't be updated as soon as Link grabbed the related item.
* Enemy Editor: added a Walking Enemy Touch Effect, 'Eat (Damage)', where the enemy eats Link and Link constantly takes damage from the enemy, equal to the enemy's Damage value. Link also takes damage from other enemies while this occurs. ( _L_, 2010-01-05 07:18:26 )



Build 1121 - windows
* Fixed the bug I caused while fixing the random crash on exit bug, which would (yeah, you guessed it) crash the player on exit. Ugh... My apologies. Everything should be fixed now. It is recommended to upgrade to the current build if you are using 1119. ( Gleeok, 2009-12-30 22:33:31 )



Build 1120 - macosx-Leopard
* Fixed the bug where Link tapping his sword wouldn't reveal, through the tapping sound, Bomb combo flags on layers.
* Presumably fixed the bug where the 'Show FF Scripts' cheat still showed script names after quitting a quest.
* Boots now have a misc. flag: 'Not Solid Combos'. If set, the boots don't protect against solid damage combos.
* Quest Rule: Hookshot Grab Combos Work On Layers 1 and 2. ( _L_, 2009-12-29 09:59:53 )



Build 1119 - windows
* New Windows Build. ++Documentation. ( Gleeok, 2009-12-28 22:48:01 )

* Possibly fixed a slight oversight which may have caused zc to crash sometimes on exit on certain hardware. ( Gleeok, 2009-12-28 21:56:48 )

* ZScript: Added Screen->Spline(layer,x1,y1,x2,y2,x3,y3,x4,y4,color,opacity) which draws a cubic bezier curve on the given layer starting at (x1,y1), interpolating between the tangent vectors (...), and ending on (x4,y4). Fun stuff. This certainly won't be the last of the parametric curve functions to make it's way into zscript.
* Seeing how DrawTile is about the most used scripting function, and already it is not uncommon to see entire screens rendered entirely with drawtiles, I've added a couple of nice subsets to these - Screen->FastTile() and Screen->FastCombo(), (int layer, int x, int y, int tile, int color, int opacity), which, are much easier to remember the arguments for, for one, and are a reasonably faster speed than thier Draw*() counterparts. A pre-emptive strike for those who want to draw changeable layers with scripts perhaps (or something else that requires hundreds of calls to you know what). ..What, nobody thought of that yet? ( Gleeok, 2009-12-28 05:05:40 )

* ZScript: Added Link->LadderX and Link->LadderY, read-only variables which are the X and Y positions of Link's stepladder.
* Added the NES fix quest rule 'Allow Ladder Anywhere'.
* Changed the screen flag 'Allow Ladder in Overworld' to 'Toggle Allow Ladder Anywhere'. Its behaviour is the same unless the aforementioned quest rule is changed.
* Added the combo type 'Tall Grass->Next'.
* Subscreen Editor: fixed the 'Bring Forward' and 'Send Backward' Arrange menu items. 'Bring to Front' and 'Send to Back' remain forthcoming.
* Enemy Editor: fixed the bug where some Misc. Attribute boxes wouldn't accept any text. ( _L_, 2009-12-27 03:04:03 )

* Fixed the bug where Bait lweapons reacted oddly to enemy shields.
* Fixed the bug where pre-Enemy Editor quests' enemies weren't updated correctly.
* Fixed the bug where Link's sword was sometimes positioned incorrectly. ( _L_, 2009-12-23 06:31:17 )



Build 1114 - macosx-Leopard
* Fixed, properly, the bug involving Link drowning while charging his sword.
* Fixed the Boots. Now, as it should be, a power of 1 refers to 'Damage (1/2 heart)', a power of 2 refers to Damage '(1 heart)', and so forth.
* Default Template: Fixed some of the default weapon sprite settings for Din's Fire and Nayru's Love.
* Default Template: Magic Pols Voices now have the One-Hit-Kill defense for reflected magic. Feel free to apply this to your quests if you wish.
* Default Template: Changed the default Nayru's Love shield sprite slightly. ( _L_, 2009-12-17 08:28:53 )

* Welcome to the first official Scripters Choice Awards. (Drumroll please..) And the winner by a large margin goes to: ..."Why can't we check if Links HP is less than or equal to zero?" -Well now you can. Sorry that this was neglected for so long.
* Remedied a few typos in std.zh. ( Gleeok, 2009-12-17 00:08:50 )



Build 1112 - windows
* Fixed the parser bug where '&&' sometimes wrongly returned true.
* Fixed the bug in the last build where wands and hammers' animations broke.
* Fixed the item position square in Small Mode.
* Presumably fixed the bug where Boomerangs' and Hookshots' block and reflect flags didn't quite work if they were Item Override weapons.
* Item Editor: now, the Select Item window shows the ID and Power of the currently selected item.
* Enemy Editor: repealed the change that disables unused enemy misc. attributes, because of the possibility of scripts making use of unused values for their own purposes.
* std.zh: added several constants related to Walking Enemies' attributes.
* ZScript: renamed npc->D[] to npc->Attributes[]. This is just an act of prudence on my part - in the distant future, if NPC-specific scripts are ever implemented, then surely the NPCs would have to be given a D[] array of default script arguments, as is consistent with items. This renaming today is to prevent such a conflict later. ( _L_, 2009-12-14 00:23:54 )



Build 1111 - windows
* The Projectile enemy family now has the same Shot Type attribute as the Walker family. And, it shoots fireballs correctly now.
* Fixed the bug where, when changing direction while slashing, Link's sword weapon became desynchronised with Link's direction for one frame. This resulted in Darknuts being stabbed through their shields. No more!
* Fixed the bug where the Door Repair room type didn't work if the 'Special Rooms And Guys Are In Caves Only' DMap flag was unset.
* Enemy Editor: now, unused misc. attributes' input boxes are automatically disabled. ( _L_, 2009-12-10 09:21:59 )



Build 1110 - windows
* Fixed the bug where fire-breathing Octoroks' Shot Type was being set to '1 Shot' instead of 'Breath'. Sorry. If your quest file was affected, simply fix it manually.
* Fixed the bug where Breath firing Walking Enemies wouldn't use their Death Attribute 1 correctly.
* Now, the 'Place + Edit FFC' right-click menu item automatically sets the placed FFC's combo and cset to that of the currently selected combo and cset.
* Enemy Editor: Added a 'Set All' button to the Defenses pane that lets you set all of the Defenses to a certain value instantly. ( _L_, 2009-12-05 23:09:06 )



Build 1109 - macosx-Leopard
* Fixed the bug where Pols Voice shadows were misaligned when their Step was greater than 50.
* Fixed the bug where various assorted projectiles ignored Walking Enemies' shields.
* Enemy Editor: added misc. attribute labels for Digdogger, Patra and Gleeok. Also, for convenience, the Select Enemy list now shows the enemy's ID as well as HP and Damage.
* Now, the icon for the item position square shows the tile of the screen's item if there is one. It's convenient if the item is hidden beneath some layers...? ( _L_, 2009-12-05 03:33:32 )



Build 1108 - windows
* Fixed some problems with the previous build.
* Fixed a bug that prevented the 'Summon' Shot Type from working unless instance of the summoned enemies were already present. ( _L_, 2009-12-04 07:18:41 )



Build 1107 - windows
* Fixed the bug where Bubbles, Traps and Rocks wouldn't have the 'Doesn't Count As Beatable Enemy' flag set. Sorry.
* Fixed the bug where the Aquamentus's fireballs moved in the wrong directions.
* Subtly fixed the Darknut's shield's hit detection.
* ZC: Fixed the bug where the Fullscreen menu item wasn't always checked correctly. ( _L_, 2009-12-04 06:47:48 )



Build 1106 - windows
* Fixed a bug where some Link weapons, such as piercing sword beams or script-created arrows, were behaving slightly incorrectly.
* Fixed a bug where the Death Attributes of Zols (but not Zol Tribbles) were being set incorrectly. Sorry.
* std.zh: added HitboxLeft(), HitboxRight(), HitboxTop(), and HitboxBottom(), which return the coordinate of the appropriate edge of the hitbox of the lweapon, eweapon, item or npc passed to it. ( _L_, 2009-12-04 05:46:54 )



Build 1105 - windows
* Windows version of 1104. ( Gleeok, 2009-12-04 02:31:37 )



Build 1104 - macosx-Leopard
* Some have expressed interest in those Enemy Editor improvements I announced, and eventually postponed, two years ago. Now, here's one part of those changes, isolated and refined. I've tested it quite thoroughly these past several days, but it's just me - so do examine it yourself.
* I've combined the Walking Enemy, Walker and Shooter, Gel, Gel Tribble, Zol, Zol Tribble, Rope, Goriya, Bubble, Vire, Vire Tribble, Like Like and Pols Voice enemy families into a single type: 'Walking Enemy'. (The old families are now labeled 'Unused' and will be removed later.) You can now combine some of their abilities (such as 'split into enemies', 'dash toward Link' and 'jinx on hit'). Their Misc. Attributes are changed, but, just for this enemy type, the Enemy Editor now properly labels each attribute and has dropdown menus for some of them. For complete information, go to http://www.shardstorm.com/ZCwiki/Walking_Enemy
* In order to incorporate the Pols Voice and Darknut families, I added a new Enemy Editor pane called Defenses. Enemies now have Defense values for each type of lweapon which affect how they react to the weapon (for instance, 'block', 'stun instead of taking damage' or 'die instantly'). These apply to every enemy family EXCEPT: Traps, Rocks, Dodongos, Aquamentuses, Gohmas, big Digdoggers, Ganons, Manhandlas, Gleeoks and Patras. Also, Peahat defenses only apply when it is grounded.
* In the case of the Darknut's shield, I've reinstated the 'Shielded in Front', 'Shielded in Back', 'Shielded On Left' and 'Shielded On Right' enemy misc. flags.
* In the case of the Bubble, I've added the oft-suggested 'Doesn't Count As Beatable Enemy' enemy misc. flag. It affects shutters, the Enemies->Secret screen flags, and such.
* Vire and Pols Voice enemies now have functional random rates, halt rates, homing factors and such.
* Deprecated the '1.90 Tribbles' quest rule. Quests will be updated with enemy misc. attribute values to match their original preference.
* Deprecated the 'Darknut Shields Can Be Broken With The Hammer' quest rule, replacing it with the enemy misc. flag 'Hammer Can Break Shield'.
* The 'Pols Voice (Magic)' enemy is now available.
* Fixed the 2.10 (or whenever) bug where the Hookshot couldn't ever stun landed Peahats.
* npc->MiscFlags[] has been updated accordingly. ( _L_, 2009-12-03 05:22:51 )

* Editing the button configuration via the controls menu should no longer crash zc. ( Gleeok, 2009-11-26 02:15:51 )

* Fixed some incorrect Item Editor labels.
* New Default: fixed the default weapon sprites for the Hookshot.
* Large Mode: two of the Whistle-related Screen Flags are now shown in Screen Info.
* String Editor: added a button entitled 'Next in List' - when pressed, it sets the current string's 'Next string' to that of the string immediately after it in the list.
* Quest Reports: now, the Enemy Locations report lists enemies in alphabetical order.
* Replaced some built-in MIDIs with better versions done by someone called Hypercrash and slightly modifed by me. (Wasn't this intended to be done earlier?) ( _L_, 2009-11-24 22:47:06 )



Build 1101 - macosx-Leopard
* Fixed the bug where the 'Hitboxes' entry in the Show/Hide cheat menu wasn't ever check-marked.
* Fixed the Lens magic / Item Override fix.
* Fixed the bug where grabbing tiles from a .qst file would reset the Sound FX names.
* ZQuest: Renamed 'Ocean Sound' to 'Ambient Sound'. And, now the screen's Ambient Sound is listed in Large Mode's Screen Info. ( _L_, 2009-11-21 06:51:10 )

* Fixed bug Fixed the bug involving the font for drop boxes in large mode changing, causing potential crash errors when using the mouse wheel afterwards. ( jman2050, 2009-11-16 10:09:38 )



Build 1099 - windows
* Large Mode: at last, a great wrong has been righted. Added a panel to the main display that shows, at a glance, the sprites of the enemies in this screen's enemy list.
* Possibly fixed the bug where the lens's magic cost was forgotten when an Item Override weapon was used.
* Tile Editor: Fixed the bug where deleting tiles and pushing 'U' (Undo) wouldn't update the blank tile hiding.
* Item Drop Set Editor: Now, the editor shows the percentage chance for each item's appearance, given the entered values.
* Enemy Editor: Fixed the Gleeok's tile preview again. ( _L_, 2009-11-14 23:41:32 )

* Fixed the all too long withstanding bug where putting a door (or not) on a screen would always override whatever combos happened to be in any of the four door locations regardless if you changed them or not.
* Hopefully Pow() works now.
* Tinkered with a few other things, either fixing them or updating them to reflect 2.5 functionality...(To be honest, I simply forget what they are...they were all minor issues anyway, I'm sure) ( Gleeok, 2009-11-14 05:59:04 )

* Fixed a corruption in the item editor which may of caused it to crash inexplicably.
* Fixed a possible minor memory leak in the player. A nice little bi-product of this fix is now when triple buffer is disabled due to gfx mode changes to an unsupported environment, triple buffering can be reinstated to its former glory after any amount of subsequent calls to change the screen mode, instead of permanently disabling it. In short: triple buffering whenever applicable...Unless that is:
* Added a new command-line option "-doublebuffer" to ZC. This will permanently disable the use of video bitmaps, or triplebuffering. Could be useful for legacy cards (or) when one couldn't run zc in fullscreen mode, perhaps due to false positives or other mysterious circumstances. By the same token this option is now also located in the ag config file for convenience. ( Gleeok, 2009-11-12 04:22:03 )

* Wasted a lot of time by making the ZScript parser possibly 10% more efficient. Good prioritising, me.
* Some ZASM codes: SETTRUE (1 register operand - sets to 1 if the TRUEFLAG is set, else 0), SETFALSE, SETMORE and SETLESS (sets to 1 if the TRUEFLAG is set or the MOREFLAG is not). These are useless to ZScript coders, so y'all just ignore 'em.
* ZQuest: Removed the 'Default' rule set, since no one really knows what it ought to contain. The remaining 4 sets are sufficient. ('Zelda 3-esque' is now the initally selected radio button.)
* Added the 'Link Drowns in Walkable Water' to the 'Zelda 3-esque' rule set. Choosing it will make all of the water tiles in the template walkable. Also, 'Rings Affect Damage Combos' is now on for all rulesets.
* Default Template: fixed some bugs, made a few more tiles, added combo cycling, BS Grave, Step->Next (All), Step->Next (Copycat), Step->Secrets and Block Hole examples, and added limited Sideview and NPC combo sections. ( _L_, 2009-11-10 09:31:25 )



Build 1095 - windows
* ZQuest: Added a 'Combo Locations' menu item to the 'Select Combo' dialog's right-click menu.
* Now, ZQuest's P hotkey no longer belongs to the 'View Pic' menu item, but to a 'Scroll to Page' feature which scrolls the current combo selector to the appropriate combo page. Convenient for those tilesets with 100 or so pages of combos. ( _L_, 2009-11-09 09:13:22 )



Build 1094 - macosx-Leopard
* Fixed some arithmetic that made the counter-modifying string control codes not work.
* New Default: added the multi-directional enemy tiles that I think someone called Master of Power created. (Hey, didn't DN say he was gonna add these back in 2007?)
* Now, when you push a secret-state-setting push block, the 'Secrets' Screen State is set as soon as you start pushing the block, rather then when the block stops moving. ( _L_, 2009-11-07 08:38:29 )

* Fixed the bug where loading the last timed save after a ZQuest crash... would crash ZQuest.
* Fixed the bug where it was possible to pick up multiple items from 'Take One Item' and 'Red Potion or Heart Container' room types if the 'Items Disappear During Holdup' rule was unchecked.
* ZQuest: Renamed 'Template' to 'NES Dungeon Template' and 'Re-apply template' to 'Apply Template to All'. An explanatory note has been added to the NES Dungeon Template dialog.
* Also, the Screen Enemy Flag 'Enemies Carryover In Warps' has been renamed to 'Sprites Carry Over In Warps' to properly reflect its actual functionality, and moved to the Warp category. This changes the behaviour of the ZScript variables Screen->EFlags[] and Screen->Flags[] somewhat. Be sure to update your scripts.
* Quest Reports: added the Combo Locations Report. Instantly find out how many 'Pound' combos or 'Push (Very Heavy)' combos you've used!
* New Default: changed the default water combos to use animated tiles, changed the CSets of Rope (L2) and 'Octorok (L4)', and fixed the default tile of 'Spinning Tile (Enemy Sprite)'.
* New Default: added a few 8-bit tile examples to the default tiles and combos, so that new users are aware of that feature.
* std.zh: Added ScreenCopy(), which copies the combos and csets from one screen into another screen. ( _L_, 2009-11-05 21:14:35 )

* Hopefully fixed a bug where Link's sword wouldn't vanish if he drowned while using the Spin Attack.
* std.zh: Added GetLayerComboT(), SetLayerComboT(), LastComboTypeOf(), and FirstComboTypeOf(). ( _L_, 2009-10-30 07:52:07 )

* Fixed a bug with the 'Dark Rooms Stay Lit Only While Fire Is On Screen' quest rule, where it would assume that only one fire weapon was onscreen when changing lighting.
* Fixed a bug where script-generated bombs wouldn't damage Link correctly.
* ZScript: sanitised Game->GetComboData() amd Game->SetComboData() so that it no longer crashes when given bad screen or map values.
* Corrected zscript.txt with respect to the Flip values of items and weapons. (Apparantly 1 is horizontal?)
* Increased the MIDI name limit from 20 to 36 characters. ( _L_, 2009-10-27 06:02:59 )



Build 1090 - macosx-Leopard
* ZScript: Fixed Game->GetComboData() et. al. so that they work properly when dealing with screens currently being used as layers.
* std.zh: Added LastComboOf() and LastComboFlagOf(), as well as AngleDir8() and AngleDir4(), which take a clockwise angle and convert it to one of the 8 or 4 standard ZC directions (DIR_UP etc.)
* Default Template: fixed the names of the unused items, enemies and weapons. Now, they follow the name format 'zz###' consistently.
* Default Template: now, the Fire Trail and Ice Magic weapon names have '<unused>' appended to them. This will remain the case until the day they actually are used.
* Default Template: added an initial delay to the Rupee animations, and changed the Clock's animation, added a Roc's Feather animation, and changed the colours of the 10, 20, and 200 Rupees to be yellow, deep red, and orange, respectively.
* Added a preview pane to the Select Weapons/Misc Sprites dialog.
* Now, pressing Return/Enter on ZC's name entry screen without entering a name will cancel the name entry process. ( _L_, 2009-10-25 01:12:43 )



Build 1089 - windows
* Fixed a bug where quests made with builds earlier than build 411 (including quests made with the 'Lost Isle Build') had malfunctioning ZASM scripts, due to 411 changing the function of the ZASM command GOTOLESS from '<' to '<='. Previously I had dismissed such a fix as impossible! But now I've done it using Highly Unorthodox Techniques to identify which build a quest was made in (which, due to insufficient ZQuest bookkeeping in those builds, isn't directly possible).
* What this means, though, is that quests made in those builds will continue to use the legacy version of GOTOLESS (that is, one which functions as '<' rather than '<=') even if you open and save them in the current ZQuest build. However, thanks to some quite minor compiler-jiggering, ZScripts added to such quests from now on will be compiled such that they use a correct implementation of inequality operators (<, >, <=, >=) regardless of all this.
* Fixed a bug where quests made with builds earlier than build 277 (including quests made with the 'Lost Isle Build') had Pols Voice enemies with incorrect Step values. This is brought to you by another Highly Unorthodox Technique, one that you don't have to worry about. ( _L_, 2009-10-23 22:15:01 )

* Fixed the bug where having an infinite Bomb Bag without any actual Bomb ammunition would prevent you from using Bombs or Super Bombs.
* Fixed the bug where Slash->Next combos sometimes created items.
* Sideview: Fixed the Y position of falling Bomb/Bait/Fire weapons. ( _L_, 2009-10-22 22:40:16 )

* ZScript: Fixed the PressAxis functions, which were setting the current input state instead of the press state.
* All the input press functions under the Link pointer are now simply ->Press* instead of only some.
* Also fixed the compiler warnings associated with these. Now they should all compile and work as documented.
* Updated zscript.txt. ( Gleeok, 2009-10-18 13:41:06 )



Build 1086 - windows
* A new build. Don't forget what I said about hitboxes before you report bugs about them!
* Fixed the bug where the Triforce items' default values were incorrect.
* std.zh: added some shortcut routines for getting/setting combos on the current layers, and a LinkCollision() routine for FFCs.
* ZQuest: added the Enemy Locations quest report, which lists every screen that a certain type of enemy appears in. ( _L_, 2009-10-18 10:51:50 )



Build 1085 - linux
* Small change to the enemy editor. Everything works as it should now, probably.
* Fixed a possible buffer overflow in the drop set editor.
* Seems like it's about time for a new Linux build. ( Saffith, 2009-10-16 21:36:12 )

* std.zh: Added LoadLWeaponOf(), LoadEWeaponOf() and LoadNPCOf(), which provide a pointer to the first sprite of a certain ID or type - the first LW_SWORDBEAM, for instance. Also added FirstComboOf() and FirstComboFlagOf(), which returns the location of the first onscreen combo or flag, and Duplicate(), which duplicates the lweapon or eweapon passed to it. ( _L_, 2009-10-15 07:36:14 )

* Fixed the bugs in std.zh in the previous build.
* std.zh: Changed Collision() so that you can pass FFC pointers to it, and check collisions between FFCs and NPCs, or FFCs and other FFCs. It uses TileWidth and TileHeight for the FFC's box. Also: Split CollisionAABB() into RectCollision() and SquareCollision2(), and made SquareCollision() and CircleCollision(), which registers collisions between two squares and two circles, respectively.
* Enabled the hitbox display debug code. Apparantly we always had hitbox display debug code, but everyone forgot? But anyway, it's a level 4 cheat under the Show/Hide submenu. Check it to make Link, NPC, weapon and item hitboxes visible. I just want to note RIGHT NOW that most all of the default hitboxes for items and weapons are bizarrely shaped or counterintuitively offset DELIBERATELY as mandated by either The Legend of Zelda or ZC 2.10. Okay! ( _L_, 2009-10-14 23:31:06 )



Build 1082 - windows
* Spot cleaned up a few loose ends and compiled a new Windows Build. Yay.
* Added some general purpose overloaded CollisionAABB() functions to std.zh.
* Fixed up DrawInteger() (It works now) and realized I didn't document it so here you go: Screen->DrawInteger(layer, x, y, font, color, bg_color, scalex, scaley, float_to_print, num_decimal_places, opacity); ( Gleeok, 2009-10-14 02:48:14 )

* ZScript: Added Screen->DrawInteger(), which pretty much does the same thing as DrawCharacter except with an integer. Can display the number up to four decimal places.
* Added Randf() and Rand2f() as Rand() and Rand2() counterparts. These return a floating point number instead of an int. ( Gleeok, 2009-10-14 00:42:48 )



Build 1079 - macosx-Leopard
* Added some more functions to std.zh. Cond() returns one of two specified results depending on a boolean - it's a bit like an 'if...else' in a single command. Choose() returns one of its arguments, selected randomly and fairly. Angle() is both syntactic sugar and a helper for those who don't know how to use ArcTan to find the angle of a line between two points. VectorX() and VectorY() split a distance and angle into X and Y lengths. Collision() returns true if the hitboxes of the two arguments intersect. It accepts any item, lweapon, eweapon or npc pointer as either of its two arguments. LinkCollision() works similarly, but note that it ignores all of Link's attributes except his hitbox.
* ZScript: Now, if you set an airborne NPC's Tile Height to something larger than 1, its shadow will be drawn beneath all of the tiles instead of just the top row.
* Fixed the bug where it was impossible for enemies with a frame rate of 0 to obey gravity.
* Fixed the jumping physics in a respect - now, a sprite's Jump variable is no longer cast to an integer within the game engine, leading to bizarre linear jump velocities, especially when the quest's Gravity is low. File this under 'things I most definitely shoulda done two years ago'.
* Fixed the bug where having a Maze Path exit to a room outside the DMap would let Link enter invalid screens. ( _L_, 2009-10-13 08:52:01 )

* Fixed the cursed copy/paste function in the enemy dialog. Hopefully that's the last we'll see of that. End of story.
* Fixed the ellipse rotation which actually didn't rotate the ellipse while the ellipse was rotating. Go figure. Conspiracy theory: People like David Hasselhoff more than ellipses. ( Gleeok, 2009-10-13 04:31:42 )

* Fixed the bug where pixel-shifting tiles into blank tiles in some directions wouldn't cause those tiles to become non-blank (with respect to the view controls).
* Fixed something in the default template that made DMap 1 the default starting DMap.
* Fixed the bug where damage combos would do 0 damage in some situations involving the 'Rings Affect Damage Combos' rule.
* Diagonal Movement: Fixed the Stepladder's behaviour for solid combos (Ladder Only, solid water etc.) ( _L_, 2009-10-09 08:44:21 )



Build 1076 - macosx-Leopard
* Fixed the aforementioned Sideview fix: it overstepped its bounds a bit and allowed a bunch of enemies to fall that should not - like Zoras. (This also affected the 'Fall From Ceiling' flag).
* Added something to the combo selector right-click menu: Open Tile Page. This lets you edit the tile of the selected combo with only two and a half clicks! I deem it great for quick alterations.
* Made a fix that allowed Digdoggers to use different animation types instead of just their own routine, regardless of the Enemy Editor.
* Item Editor: Now, all level 0 items will have their level set to 1. Hopefully only good things will come of this.
* String Editor: Here's something new for Large Mode - in the string list, if a string has been placed immediately after a string that links to it, then that string will be indented in the list. This is intended to be helpful for quickly identifying blocks of linked strings in the list. ( _L_, 2009-10-08 07:52:28 )



Build 1075 - macosx-Leopard
* This build is Intel only.
* Fixed the, er, Sideview bug where several kinds of non-falling enemies were frozen in midair. Special thanks to that tester with an eye on the ball!
* Large Mode: Expanded the Edit String dialog and the Map Styles dialog. ( _L_, 2009-09-27 04:48:24 )



Build 1074 - windows
* Diagonal Movement: Greatly freed up the Stepladder's usage. It now no longer adheres to the 16x16 grid when it is placed, and can be walked upon regardless of Link's adherence to the 16x16 grid. This fixes at least a few issues that users have been having with it.
* Sideview: Fixed a long-lived bug where enemies would stop moving after falling. As you know, I prevent enemies from moving horizontally when they're falling. However, when this has occured, enemy movement AI got 'trapped', and the enemy often couldn't move after landing. This is fixed.
* Large Mode: Fixed the Side Warp direction selector's resizing. ( _L_, 2009-09-26 04:17:52 )

* String Editor: Fixed a bug where clicking 'Duplicate' and then clicking 'Cancel' would cause the '<New String>' menu entry to disappear permanently. The next build will restore it if this has happened to you.
* Corrected a comment in std.zh about GEN_MAGICDRAINRATE. Link's magic drain is multiplied by Game->Generic[GEN_MAGICDRAINRATE] divided by 2, not multiplied by one over that value.
* Fixed a bug where the Potions would always usen the highest-level owned item's refill rates, rather than their own refill rates.
* ZQuest: Now, the W and F keys show walkability and inherent flags for combos in the combo selector, too.
* Large Mode: the currently selected combo's type is now listed in the upper-right corner. ( _L_, 2009-09-22 02:39:43 )



Build 1072 - windows
* Fixed a bug with the previous build where duplicating (or, for that matter, deleting) a string without having scrolled through your entire string list first would mess up various things.
* Enemy Editor: renamed the 'Zora (4-Frame)' animation type to 'Zora (NES)' and 'Zora' to 'Zora (4-Frame)'.
* Tooltips: The combo selector tooltip now shows the combo type of the combo. ( _L_, 2009-09-20 07:40:37 )



Build 1071 - windows
* Fixed the bugs where the 'Goto If' string codes wouldn't set the string's tile backdrop correctly, and would skip over or print incorrect symbols regardless of what happened.
* Now, duplicate strings are generated immediately after the original string in the list... thus saving a certain amount of re-positioning.
* Now, right-clicking in the combo selector brings up a menu offering two choices: edit the individual combo, or open the Combo Editor at that combo's page. ( _L_, 2009-09-19 06:19:40 )

* Fixed the bug where Link kept holding his sword while stepping down a Cave combo.
* Now, a Ring item with a damage divisor of 0 will make Link immune to damage rather than crashing ZC. This goes for Peril Rings too. (That would be interesting.)
* Fixed the bug where the preview pane in the screen Enemies dialog was absent.
* Large Mode: enlarged the Autolayer Setup dialog.
* Fixed the bug where Screen->TriggerSecrets() wouldn't compile correctly.
* ZScript: added Game->End(). When this command is run, ZC immediately ends the entire game without saving and goes to the file select screen. What could you use this for? ...Maybe you could put it at the end of a custom 'game over' or 'end of demo' sequence? ( _L_, 2009-09-18 22:45:09 )

* Added a combo type: Eyeball (4-Way). It only needs tiles for the four cardinal directions. It works a bit differently to the other eyeballs - the tilesheet direction order is up, down, left, right. What this means is that you can use 'n-frame 4-dir' enemy tiles as Eyeball combo tiles with no alteration! That's convenient. (P.S: The other Eyeball types are renamed '8-Way'.)
* Fixed the bug where, with a Save Game combo in a dark room, entering the Save Game prompt then selecting 'Don't Save' would cause the room to become lit inexplicably.
* Now, Whistle items with an invalid Warp Ring number (one that isn't between 1 and 8) will never create whirlwinds.
* Fixed the Super Bomb's damage to Link. It is now at 8 instead of 10.
* The Bomb and Super Bomb's Misc. 3 value now determines the damage done to Link when the 'Bombs Hurt Link' rule is set. (Setting these to negative values will presumably heal Link. If you can think of an in-game reason for this to happen, full speed to you.)
* Added some space-saving functions to std.zh - CreateNPCAt, CreateItemAt, CreateLWeaponAt and CreateEWeaponAt. ( _L_, 2009-09-11 05:00:25 )

* Fixed the Whisp Ring so that its default values are correct, and that its Item Editor values are actually used in the game. Because until now, they weren't!
* Fixed the bug where FFCs with inherent Secret Tile Flags wouldn't change when Screen Secrets was triggered.
* Fixed the bug where individual FFCs pasted anew into a screen weren't being saved in the quest file.
* Default Template: Fixed those two counters in the passive B subscreens.
* Fixed the bug where a bunch of string control codes were being displayed wrongly in the String Editor. ( _L_, 2009-09-05 06:24:32 )

* Fixed the bug where setting Screen->ComboD would not update spinning tiles
* ZScript no longer uses floating point arithmetic in multiplication, division or modulus operations.
* Finished implementing setting of InputMouseX/Y, which should now work correctly.
* Added 'Game->DMapFlags[]' and some script-specific DMap flags, which should be the next best thing to having actual DMap scripts.
* Gave the final sprite - Link - its Misc array. You could argue that this is pretty pointless, but seeing as Link inherits his miscellaneous variables from the sprite class anyway I thought it wouldn't hurt.
* npc, lweapon and eweapon now have a 'CollDetection' bool, with which you can turn off their collision detection.
* Renamed Link->Invincible to Link->CollDetection to be consistent with this (sorry if you were using it).
* Screen->TriggerSecrets() (which was in the last build, if you happened to stumble across it) now works.
* Added the maximum number of drawing commands, and some information about the maximum size of variables to std.zh.
* Added 'OnSidePlatform' to std.zh, which uses (pretty much) the same method as the internal code.
* Documented Waitdraw, which we've had for a while... ( Joe123, 2009-09-03 06:45:26 )

* Fixed the bug where passageway warps to different DMaps would use the current DMap's offset rather than the destination DMap's offset.
* Now, if, via placed and inherent combos, you have a Secret Tile or Armos->Secret type flag and a Hammer or Strike flag in the same spot, and you hammer-pound the spot, the Secret Tile / Armos->Secret flag will no longer take precedence over the Hammer/Strike flag.
* Fixed the bug where 2.10 and earlier quests had their Ghini Transparency and Ghini Flickering Quest Rules set to the opposite of what they ought to be.
* Fixed the Wall Master's movement. Now, if their Misc. 1 is 1, they will advance farther from the screen edge depending on their Step speed. If not, they will only advance two tiles from the edge regardless as to how swift they are.
* Large Mode: enlarged the Init Data/Link Data dialog, AND all of the popup alert boxes. This applies to both ZQuest and Zelda Classic. Note: largeness of Zelda Classic depends on your settings.
* Also enlarged the Quest Info, Controls, Quest MIDI Info, and some Cheat dialogs. ( _L_, 2009-08-28 02:22:00 )



Build 1065 - windows
* New Build. -Changes to the DrawTile and DrawCombo format. As a result of this, any older beta scripts using these will have to be updated. I apologize for the inconvenience, and did consider this as the last option, however such is the price of progress.-
* Too many changes in this build to name them all, so here is a basic breakdown:
* Added basic 3D support to ZScript via functions available using the Screen pointer.
* Fixed the ellipse loppiness/wonkyness bug.
* Fixed the clipping issues with some drawing routines when they were being rotated.
* Optimized slightly some drawing routines. Will do some more work on this later.
* Changes to Drawtile: PLEASE READ:
* DrawTile and DrawCombo have been finalized and now take one extra argument: 'Scale' has been replaced with xscale and yscale. These are actual representations of the drawn tile or combo, including w and h arguments, in PIXELS! Yes, you can scale things up or down now. ^_^ So to draw things using default values this now needs to be -1 or another negative number. Unfortunately as previously stated, this leaves old scripts using these features as horribly incompatible with the new format. Also rotation, rx, ry now all work.
* Whats that? You want to know more about the 3D drawing stuff? ...well ok.
* ZScript: Added Quad3D(x1,y1,x2,y2,x3,y3,x4,y4,w,h,cset,flip,texture,rendermode);
* ZScript: Added Triangle3D(x1,y1,x2,y2,x3,y3,w,h,cset,flip,texture,rendermode);
* These will draw a triangle/quad on the screen with the specified vertex coordinates then texture map a tile/combo or block of using w,h onto them! Color interpolation, depth sorting, and color mapping using a z buffer are not implemented.
* Updated zscript and std.zh.....again. ( Gleeok, 2009-08-26 20:10:21 )

* ZScript : Finished adding Screen->DrawCharacter, which will draw one ASCII character from any one of the available internal fonts to the screen (Not before having the option to perform some neato blitting routines of coarse), and as such I've updated std.zh and zscript.txt to match this. Finally there is the beginnings of scripted texts outside the string editor without resorting to using DrawTile!
* Performed some housecleaning of script.txt so it should be readable in any notepad editor now. It looks to be up-to-date, but feel free to let us know if we've missed something. ( Gleeok, 2009-08-22 04:22:24 )

* Fixed all, if not most, of the 30-something items whose default template values were swapped around since about three builds ago. Previous messages indicated fixes of specific instances, but not the majority of problems. My thanks to the testers for their thoroughness.
* Fixed the bug where a newly-created string would be filled with spaces, preventing you from typing into the editor's box.
* Also in the String Editor: fixed the bug where string control code 25 would consume the character immediately after it. (Actually, I think someone else did but forgot to mention it earlier.)
* Fixed some capitalisation for the quest rules.
* Fixed the bug where grabbed tiles, overwritten over blank tiles, would still be considered blank by the Tile Editor's 'hide blank' feature.
* Added default Fire Trail (Enemy), Hover Boots Glow and Cane of Byrna (Beam) weapon sprites to the default template.
* Also added another couple of magic meter tiles by Pokegamer1989.
* Added Screen Flag: Maze Overrides Side Warp, whereby a Side Warp in a Maze Path won't be triggered unless you solve the maze or use its specified exit direction. (And yes, ZScript's Screen->Flags[] can access it. I think.)
* Fixed the bug where the checkmarks in the Cheat menu were on the wrong menu items (and the wrong menu item being disabled sometimes.) ( _L_, 2009-08-21 03:10:10 )

* Fixed some slight errors with the default template.
* Joe123 and myself would like to take this time and announce that phase 1 of operation ZScript: Draw Text is underway. I could tell you what this is, but then I'd have to kill you. ...err, actually it's not fully implemented yet is all. Details will be in zscript.txt. ( Gleeok, 2009-08-20 19:52:26 )

* Updated zscript.txt and std.zh slightly.
* Fixed the bug where Link would be drawn over 'walk down' type combos if he was charging or spinning.
* Fixed another charging bug where you could not trigger 'touch' type combos if Link was not facing them. ( Gleeok, 2009-08-20 05:51:01 )



Build 1057 - windows
* Added ffc->InitD[], which refers to the value of the ffc's D Input values are they are stored in the .qst file
* Made some changes which could've been causing underlying problems with ArcTan
* New build, as we've had quite a few serious bugs fixed recently. ( Joe123, 2009-08-19 08:45:41 )



Build 1056 - linux
* Added a new option to screen data, under the S.Data 1 tab. Now you can set one layer to be either invisible or visible only through the Lens of Truth.
* Some of the Magic and Fire Boomerangs' default data had gotten mixed up. That's fixed now.
* Fixed another ZQuest crash on Linux. The quest header dialog this time.
* That's enough crash fixes to warrant a new build, don't you think? Back up your quests, and all that. ( Saffith, 2009-08-18 17:26:23 )

* Fixed itemdata->Keep
* Fixed the slow-down issue when setting Link->Item
* Added some new Trace-like functions to ZScript for de-bugging. They are:
* TraceB for tracing a boolean state.
* TraceToBase which traces an integer to a number of numerical bases.
* TraceNL which traces a newline.
* ClearTrace which clears allegro.log completely.
* Added Link->Invincible to ZScript, which is reasonably self explanitory.
* Added Screen->EFlags to ZScript, which is the same as Screen->Flags, but for the E.Flags tab of Screen Data. Read-only.
* Added npc->MiscFlags, which allows acces to the 'Misc. Flags' tab of the Enemy Editor, and is read-only.
* Added some new utility routines to std.zh ( Joe123, 2009-08-18 16:36:40 )

* Fixed a screen data dialog crash on Linux.
* Fixed the boomerang's movement after hitting a blocking combo.
* Changed step combo detection.
* Fixed string preview when 25 appears at the end of a line.
* Tweaked the Armageddon Games logo a bit. Those gaps were bugging me. ( Saffith, 2009-08-14 22:40:46 )

* Added left analogue joystick support to ZC. You can now move using the d-pad or left analog.
* Changed the default joystick buttons to reflect the updated button support from way back to build 900 or so. Ex1-4 are now L2, R2, but4, and but3. select=menu, start=start, etc. You can still change these in the controls menu. ...Hey 1990 called, it wants it's button configuration back. ( Gleeok, 2009-08-13 19:38:59 )

* Fixed screen info crashing on some shops.
* Fixed item editor crashing on long item names.
* Repositioned progress boxes in ZQuest's classic interface when scaled up. ( Saffith, 2009-08-13 18:18:20 )

* Fixed the bug where the Old Tile in the Enemy Editor's tile selection dialog was flipped 90 degrees.
* Changed & improved some NPCT_ constant names in std.zh, no doubt ruining hours of work on your part.
* ZQuest: Added an FFC-specific tooltip that is displayed when mousing over an FFC.
* Fixed the bug where instant-appearing strings (by a control code setting the text speed to 0, or pressing B) would be displayed one character too long for their row.
* Renamed the 'Touchy' combos to use the word 'Continuous', which better describes what they do differently.
* Now the Touchy combos do something different. Here it is: normally, if you have a Secret Tile flag on a Bush combo (for instance), and the Secret Combo is a Grass combo (for instance), and you slash it, once, at just the right distance, the Bush combo is slashed (creating the Grass combo) but the Grass combo is not. With the Continuous type, the slash's influence 'continues' from the Bush combo and affects the resultant Grass combo as well. Comprehende? Good. ( _L_, 2009-08-13 06:27:11 )

* Fixed the bug with slashing weapons causing Link to use slash tiles even he doesn't have the slash ability.
* Fixed the bug where ZC crashes if you use a bomb while the arrows are on the other weapon button.
* Fixed bugs regarding slash combos. ( DarkNation, 2009-08-12 20:34:24 )

* Fixed a special case crash in the player along with some assumptions on how zc handles video card errors. To put this another way: Go ahead and try to get zelda-w to crash on startup now. I dare you. ;-D
* Updated qst.dat. Previous proposed fixes in the default template should now be withstanding. ( Gleeok, 2009-08-12 18:55:16 )

* Restored the keyboard shortcuts in the enemies dialog, including the otherwise inaccessible copy and paste functions.
* Fixed a crash when the screen info displays certain tile warps. ( Saffith, 2009-08-12 16:51:05 )



Build 1046 - windows
* The maximum number of hearts displayed on the file select screen is now 48 (very large numbers of hearts had looked a little interesting in previous
* Implicit casts from Float to Bool in ZScript no longer throw up a compiler warning. One day in the distant future when we have discrete Integers and
* Added ffc->Script, which is and only ever will be read-only.
* Link->Equipped is no longer read-only, and I've added a few functions to std.zh for this.
* Added Link->Invisible. No more dummy LTM items!
* Added npc->Type, which is read-only.
* After an horrifically tedious few hours of coding I bring you Screen->Flags, which can only be read-only. I also added a couple of script-specific screen
* I have spent quite a long time testing them, but it is very possible that some might be returning the wrong flag (as I've had to rearrange all of the
* I'm experimenting with making InputMouseX and InputMouseY set-able via allegro's position_mouse(). If it turns out to be causing problems it can be ( Joe123, 2009-08-12 12:48:24 )



Build 1045 - windows
* New build. Added some extra debugging code to the initialization routine.
* Fixed some inconsistencies with the Patra and Gleeok enemies in the default template. Thanks Pokegamer! ( Gleeok, 2009-08-12 04:51:54 )

* Fixed the bug where the mouse cursor would vanish when it was outside the drawing area in combo alias mode.
* Fixed the tile page "goto page" dialog so it no longer prompts to goto the page you're already viewing.
* Recanted the previous offering of the CanWalk functions based on redundancy alone. Now it's just one function 1/4 of the size. Hey, they can't all be winners, right? ( Gleeok, 2009-08-10 23:06:20 )

* Fixed the bug where finishing the first or second quest would break the next one. Unfortunately, this won't fix saves that are already affected. ( Saffith, 2009-08-10 20:32:07 )



Build 1042 - linux
* Fixed a couple of crashes on Linux.
* Accordingly, here's a new Linux build, assuming I've done this right. ( Saffith, 2009-08-09 14:03:31 )

* Fixed the bug where the controls menu was only accepting the first eight of the joystick buttons.
* Added again the InputPress stuff for right analogue, which somehow I managed to leave out the last time. Sorry about that. ( Gleeok, 2009-08-03 03:16:31 )

* Added the feature whose absence was preventing the String Editor from ascending to true greatness (...well, one such feature, anyway). It is a Duplicate button which lets you duplicate an existing string. Now, instead of tediously and intricately setting the tile and attributes for a bunch of new strings, you can just duplicate a previous string and edit that.
* Removed the 'View Darkness' menu item. You'll just have to use the L key again.
* Fixed the bug where continuing in a dark screen wouldn't set the room's darkness correctly.
* New ZQuest hotkey: holding down Control while pressing the arrow keys switches to the destination screen of the Side Warp in that direction, if there is any. This is convenient for quickly switching to warp destinations without having to open the Side Warp dialog. Tell a friend! ( _L_, 2009-08-02 01:30:52 )



Build 1038 - windows
* Testing out a new windows build.
* Please remember to BACKUP your quests! If you like to perform any downloading rituals, now is the time. I prefer the highly scientific fingers crossed please work please work method myself. ( Gleeok, 2009-08-01 04:31:18 )

* Fixed the bug where peahat AI would fail on the left side of the screen if they were placed there by a script or other means.
* Added some general purpose functions to std.zh: RadtoDeg, DegtoRad, and Rand2.
* Added a few more functions to std.zh for the benefit of simplifying solidity collision checking. These are CanWalk() and CanWalkSideview(). Now you can use one line of code where previously it may have taken 20.
* ZScript: Hey, remember how the scale and rotation arguments for DrawTile and DrawCombo didn't work? Well I sure hope you haven't been setting these. Why, you ask? Because they work now that's why! :D That's right, you can scale and/or rotate these now using single or a block of size less than 20. -Note that arguments 9 and 10 (anchor x,y) are still reserved for future use, so leave these at 0. Also currently you cannot scale or rotate a transparent tile or combo...for now. Do me proud. ( Gleeok, 2009-07-31 22:08:50 )

* Fixed a bug such that if Link is moved by a script while shooting the Hookshot, but the Hookshot itself is not, the Hookshot will dismiss itself after it retracts and Link isn't caught in an infinite loop waiting for the head to arrive.
* Now, when pasting a screen, the screen's selected Door Combo Set is pasted as well as the Doors.
* Large Mode: Fixed a bug where some adjacently-listed Commands buttons (such as 'Save' and 'Screen Data') were being incorrectly disabled or enabled.
* Fixed the bug where 'Spinning Tile' combos placed directly onto the screen (that is, without combo cycling etc.) wouldn't generate the Spinning Tile enemy when the screen was loaded.
* Fixed the bugfix relating to NES quest push block CSets. Now it works as previously advertised in b1024. ( _L_, 2009-07-27 09:18:08 )

* ZScript: I bet all you zscripters out there were wondering why it currently wasn't possible to access Right Analogue Joystick Input for those of you who use game pads. Well now you can. Added new Link boolean values to ZScipt: You can set or read these by calling "Link->InputAxisUp", *Down, *Left, and *Right. Also going along with the current trend, there are also InputPress"*" values as well for these. However due to memory constrictions these have been shortened to "InputPAxisUp" etc. Have fun with these!
* Added ComboX() and ComboY() functions to std.zh. These are basically the inverse of of "ComboAt()" in that they return the X,Y coordinate of said Combo. ( Gleeok, 2009-07-27 04:31:28 )

* Fixed several inconsistencies in the 1st, 2nd, and 3rd quest files and their proposed versions.
* Fixed a bug where newly-created quests would cause your hp to drain if you picked up a sword.
* Implemented Gleeok's fix for the Fullscreen to Windowed lock up bug. ( DarkNation, 2009-07-26 21:13:42 )



Build 1032 - windows
* Err let's try this gain.... ( Sean, 2009-07-23 23:22:17 )



Build 1031 - windows
* [ZCL] [BUGFIX] Windows Scale not keeping it's settings ( Sean, 2009-07-23 23:18:11 )



Build 1030 - windows
* Let's try that again then... ( Joe123, 2009-07-23 10:45:54 )



Build 1029 - windows
* Added the Item Drop Set Editor to the favourites list in large mode
* Fixed the Misc[] arrays in zscript.txt
* Added npc->D[], which correlates the npc's Miscellaneous Attribute from the Enemy Editor. They are read-only.
* Added Link->Equipment, which contains the item IDs of what Link currently has equipped. It is read-only
* Added some functions to std.zh (and fixed the ones I added last time). You may find them useful if:
* A) You look at the number '10' and think of how many digits there are on your hands
* B) You loose sleep at night over the symbols '&', '|', '<<' and '>>' ( Joe123, 2009-07-23 09:32:44 )



Build 1028 - linux
* ZCL for linux build ( Sean, 2009-07-22 12:39:51 )



Build 1027 - windows
* [ZCL] [Bug Fix] Sometimes ZCL doesn't read the settings properly. Thus Ignoring them
* [ZCL] [Bug FIx] Fixed the FPS problem
* [ZCL] [GUI] [New Feature] Name Entry Mode in Zelda Classic Tab
* [ZCL] [GUI] [New Feature] Settings are read in Title Screen now
* [ZCL] [GUI] [New Feature] Combo Brush in ZQ Tab
* [ZCL] [GUI] [New Feature] Enable Tooltips in ZQ Tab
* [ZCL] [GUI] [New Feature] Floating Brush in ZQ Tab
* [ZCL] [GUI] [New Feature] Mouse Scroll in ZQ Tab
* [ZCL] [GUI] [New Feature] Overwrite Protection in ZQ Tab
* [ZCL] [GUI] [New Feature] Palette Cycle in ZQ Tab
* [ZCL] [GUI] [New Feature] Show Ruleset Dialog When Creating New Quests in ZQ Tab
* [ZCL] [GUI] [New Feature] Tile Protection in ZQ Tab
* [ZCL] [GUI] [New Feature] Uncompressed Auto Saves in ZQ Tab
* [ZCL] [GUI] [New Feature] Use Static for Invalid Data in ZQ Tab
* [ZCL] [GUI] [New Feature] Auto backup features in ZQ Tab
* [ZCL] [GUI] Got rid of the white space
* [ZCL] [GUI] Major clean up of the GUI
* [ZCL] [GUI] [Removed Feature] A lot of tabs were removed because of the GUI clean up
* [ZCL] [GUI] [Removed Feature] Welcome screen removed
* [ZCL] [GUI] [Removed Feature] Removed secondary tabset icons
* [ZCL] [Core] Edited how ag.cfg is being read :) ( Sean, 2009-07-22 00:08:39 )



Build 1025 - linux
* OMG A LINUX BUILD :D. I still think about you guys. Also later down the road you guys will see a new build of ZCL. Here is a teaser shot of that http://dproj.ath.cx/tmp/newzcl.jpg ( Sean, 2009-07-21 13:22:41 )



Build 1024 - windows
* It's my honour to present build 10000000000 to all those ZC users who can count in binary. Speaking on behalf of Joe123 and myself: though the two most commonly used ZQuest menus have been rearranged, it is our belief that even several years of muscle memory can be overcome after about twenty minutes of use, and the gains from its more efficient menu item placement are not to be idly cast over. (But we are of course receptive to feedback with regards to specific menu arrangement decisions and their worth thereof.) ( _L_, 2009-07-21 06:12:06 )

* Fixed the bugs where fireball-shooting Statue combos and Spinning Tile combos wouldn't generate the appropriate enemies when they were placed using scripts and other methods. This includes occasions when an existing combo's type was changed to 'Spinning Tile' or 'Statue' using Screen->ComboT[].
* ZQuest: Added a right-click menu that appears when you right-click visible FFCs. The options are: Edit FFC, Copy FFC, and Paste FFC (that is, overwrite the clicked FFC with the copied FFC).
* An option has been added to the standard right-click menu allowing you to move the next unused FFC to the mouse's coordinates, and then edit it. This is believed to be a smoother, more natural manner of instantiating FFCs than using the Screen menu item all the time.
* Another option in the same right-click menu: Paste FFC as FFC n, where n is the first unused FFC in the screen. It lets you paste a copied FFC into the screen overwriting an unused FFCs. This function can also be used to duplicate FFCs quickly and smoothly, by copying and pasting them into the same screen. That sounds highly useful, right? ( _L_, 2009-07-21 04:53:15 )

* Fixed the bug where scrolling in the bottom panel in large mode would move the combo list
* Correctly assigned the blank favourites command to 'Default Items'; it no longer crashes ZQuest
* Set the initial focus of the Compile Script and Assign Compiled Script dialog (you can now compile scripts without using the mouse)
* Items can now be edited directly from the 'Screen Item' and 'Special Item' dialogs, and Enemies from the 'Select Enemy' dialog
* Re-arranged the right-click menu, moving select and scroll to combo to the top, and giving 'Draw Block' its own sub-menu, with some more block sizes
* In large mode, the 'Current Combo' and 'Cycle Combo' boxes now show the walkability and inherent flags of the selected and cycle to combo when the respective toggles are activated
* Shift-Click now sets the CSet of a combo on-screen to the current CSet without changing the combo
* Documented the 'InputMouseB' and 'InputMouseZ' variables, which were added to ZScript but not mentioned. They are read-only.
* Removed ffc->WasTriggered() from ZScript as it does nothing. ( Joe123, 2009-07-19 08:18:19 )

* Fixed the bug where scrolling with the mouse wheel in large mode only changed the current map in the top left hand corner of the minimap
* The 'Y' key now opens the 'Compile Script' dialog, and the 'I', 'C', 'E' and 'X' keys can be used to select the buttons in that dialog
* The braces '{' and '}' can now be used to increment and decrement the current flag, for the benefit of laptop users who have no * and / numpad keys
* Reorganised the flags in the Screen Data dialog under various headings, and removed the unused flags from view
* Enemies with Extend set to >= 3 via ZScript now drop items in the middle of their graphics rather than in the top left corner. This does not affect NES Bosses
* Other (Floating) and Other enemy types no longer have their random and halt rates and homing factors truncated to small integer values in the enemy editor as they do not affect the enemy's movements and may be used as an 'input' to a script
* Added e->Homing to ZScript, which should only be read and not set ( Joe123, 2009-07-17 16:59:07 )

* Fixed the bug where the Tile Editor's 'Show Only Unused' option wasn't displayed correctly in Large Mode.
* Added some extra entries to the Tile Editor right-click menu, providing access to a few features formerly restricted to hotkeys. These are the Color Depth option (bound to B and control-B), and the Show Only Unused option (bound to control-U). This later feature now takes the form of three options: Hide Used, Hide Unused, and Hide Blank, with Hide Blank as the default.
* Conversely, these are added to the Combo Editor right-click menu: Insert New (bound to I), and Delete (bound to shift-I).
* Now, tiles hidden with the Hide options are shown as invalid static if you have invalid static turned on. You might want to turn it off before you export a tile page, though.
* Large Mode only: 8-bit colour tiles are now marked with a tiny flashing '8' in the Tile Editor, to distinguish them from 4-bit colour tiles.
* Fixed the bug where the Edit and Done buttons in the Select Combo dialog were incorrect.
* You know, I was going to implement the 'Spinning Tile (Random)' Combo Type from scratch, but then I pondered and thought... nah. So, it's now 'Unused'. If you still want the behaviour, ask someone to write a script that, once every 3 seconds, randomly chooses a specific kind of combo and changes it to a 'Spinning Tile (Immediate)' combo.
* Also, the matching default enemy has been changed - it is now called 'Spinning Tile (Enemy Sprite)' (and the other is 'Spinning Tile (Combo)') and has been given some default tiles, to show that you can make spinning tiles with a standard tile outside of that defined by the combo that summoned them.
* Added some Spinning Tile tiles to the default quest, as well as a Spinning Tile combo, and cycling combos allowing one to make use of them.
* Increased the spinning tile enemies' default step speed from 50 to 200, where it used to be. Don't know how that got that way.
* Enemy Editor: Fixed the 'bug' where it looked like you ought to be able to set the Flip of an enemy's tile, even though in reality you can't.
* Select Combo: fixed the bug where the displayed 'Cycle' combo number was the same as the current combo number.
* Enemy Editor: Implemented the '4-Frame 4-Dir + Tracking' animation type, which previously did nothing. What? Nothing? Seriously?
* Also added '2-Frame 4-Dir + Tracking'. (As you know, 'Tracking' means that the enemy will always face Link, like an Eyeball-type combo.)
* Fixed the bug where the 'Choose Freeform Combo' dialog's combo preview would slide upward every time you opened it.
* Reset some of the default item data (Sword 1, Sword 2, Heart, Heart Container) in the default quest, fixing several dastardly bugs where these items killed Link or else didn't work.
* Fixed the bug where NES quest push blocks sometimes used CSet 9 unwantedly. Now, they only use CSet 9 in NES Dungeons while the related NES Fix quest rule is off. ( _L_, 2009-07-13 06:41:47 )

* Secret Combos can now be accessed by pressing 'F5' in ZQuest, and re-organised the 'Screen' menu.
* Moved the Screen Data dialog around so all of the tabs fit on one screen.
* Moved the 'Is Flashing', 'Is Flickering' and 'Is Transparent' flags in the Enemy Editor to the previous tab, to seperate the spawning flags from the other flags.
* The non-numpad +/- keys now work in RomView.
* Under the level 1 cheat, 'H' can now be used to refill hearts in addition to Numpad *, and 'M' can be used to refill magic in addition to Numpad for the benefit of laptop users. ( Joe123, 2009-07-07 14:29:06 )



Build 1018 - windows
* Fixed the crash that occurs when Link takes a Maze Path route that leads north of the northmost screens.
* Fixed the bug where dismissing the 'Go To' cheat dialog caused the music to resume even when the game was inactive (that is, greyed out) when you entered the dialog.
* Fixed the bug where one could use the 'Go To' cheat while the game was inactive, and then, without resuming the game, quit the quest and open a different quest, causing Link, in the different quest, to be warped where the dialog had specified. Unlimited cheating potential: denied!
* Fixed the small bug where dismissing a 'Quit' or 'Reset' dialog with a press of Return/Enter while in-game would also open the pause subscreen as soon as the dialog was dismissed.
* Finally added a button to the Tile Editor that, when clicked, lets you save the current tile page to a BMP file. It is most desirable for those using Large Mode, and you must be appalled that we waited this long before implementing it. My apologies. ( _L_, 2009-07-07 04:09:25 )

* Fixed the Large Mode bug where the 'Choose Freeform Combo' dialog wrongly positioned the FFC information over the combo preview. Sorry.
* Changed the name of Screen Flags: 'Use As Save Screen(SP)' to 'Save Point -> Continue Here', and 'Use As Save Screen (AUTO)' to 'Save Game On Entry'. This is to reflect that you don't really need the firstmentioned Screen Flag alongside a Save Point combo, but it's what most situations would call for.
* Tweaked the Large Mode screen information: now, screens with Save Point combos and the 'Save Point -> Continue Here' are labeled 'Save-Continue Screen', screens with just Save Point combos are labeled 'Save Screen', and screens with the 'Save Game On Entry' flag are labeled 'Automatic Save/Continue Screen'.
* Fixed the bug where hookshot-deflected weapons would occasionally explode like a bomb. ( _L_, 2009-06-29 04:44:36 )

* Fixed the bug where gaining magic and crossing into a Ring's magic cost threshold wouldn't update Link's colour instantly.
* Fixed the bug where losing magic and crossing out of a Ring's magic cost threshold wouldn't permit Link to use a lower-level Ring with a lesser cost.
* Fixed the bug where losing a large sum of magic through a Ring could cause Link to have negative magic (which, of course, wraps around to positive magic.)
* (To clarify: even if you run out of the magic to use it, a Ring will still appear in the subscreen, and still have an active Link Tile Modifier. This is intended behaviour.) ( _L_, 2009-06-29 00:51:08 )



Build 1015 - windows
* Copied the recent fixes to the original quests to the proposed versions. ( DarkNation, 2009-06-28 20:04:46 )

* Added sensitive (touchy) versions of the slashable combos. Old quests will autoupdate their slashable combos to these versions for compatibility.
* Fixed the bug where beating a default quest would set your continue hp to 0 so you die immediately upon starting the next quest.
* Updated the ZQuest large mode font to include some missing elements (like the up and down arrows on the tile and combo screens and the check mark on the enemy list screen).
* Fixed the slide speed of the Zol enemies.
* "Fire 2 Trail (Enemy)" and "Magic (Ice, Enemy)" are now listed with "Disabled" tags until these are implemented after 2.5 is released.
* Fixed a bug where the screen wouldn't update in ZQuest (and sometimes it would appear to get stuck on a purple screen when you first started).
* Fixed the bomb and super bomb damage ratios to Link.
* Fixed the bug where latching your hookshot onto a hookshot combo while facing downwards on a sideview screen would cause the chain to fall off the screen and Link to freeze.
* Music now stops when you warp via a tile until you arrive on the new screen as it did in Zelda 1.
* The low hp warning beep now pauses when you enter a warp or a cave as it did in Zelda 1.
* Fixed the bug where bombing through a wall would not update the connecting wall in the connecting room even if the room had been visited previously until you entered the next room.
* Unused items at the end of the item list are now preceded with 'zz' instead of just 'z' to help them stay at the bottom of the list correctly.
* The fairy guy now animates properly when the new enemy tiles rule is enabled.
* The -scale command-line switch for ROMView has been disabled for the timebeing due to it always crashing.
* The default quests now properly hide the items in the subscreen while the subscreen is scrolling up or down.
* The default original subscreen type now properly hides the items in the subscreen while the subscreen is scrolling up or down.
* Sound and music now pause while the "Goto" cheat dialog is open.
* Fixed the bug with the translucency rebuild command after opening an image in the tile grabber.
* The 'reduce color' and 'show original palette' commands int the tile grabber now disable each other as they are mutually exclusive.
* The plus and minus (equals) keys on the main keyboard now work in the tile and combo selector windows. ( DarkNation, 2009-06-28 20:01:08 )

* Attention: I've radically altered expanded the scope of my previously mentioned Large Mode error-listing display feature. Now, in addition to just simple errors, it now lists, in small white-on-black text in the corner of the screen area, most every significant mechanical feature of the screen before you. This includes the presence of: Screen State Carryover, Timed Warp, Maze Path, the 'Sideview Gravity', 'Invisible Link', 'Save Screen', 'Continue Here' and 'Treat As..' Screen Flags, the String, every Room Type and Catch All, and all relevant Tile and Side Warps. This is entirely practical because the majority of screens in a quest would have less than 3 of those features. This information display can be toggled by tapping N if it obscures something important.
* Do you know what this means? What this means is that I have made most of the 'Small Mode panels' functionally obsolete in Large Mode! This is tremendous tidings, for those panels have been a bugbear in the Large Mode interface for years. Now, every relevant detail conveyed by those panels (except the increasingly irrelevant Screen Flags panel) is covered by the screen info display, and what remains - the eight warp return and coloured square selectors - has been placed on a single compact panel. (But don't forget that all of the panels still exist in Small Mode.)
* And, having reduced those two panels into one, I have also been permitted to expand the Large Mode minimap selector even further! It is now 3 times the size of the Small Mode selector, and is about as large as it can practically be.

* Of course, you're thinking I forgot something important. But I haven't! A box showing the 'Cycle' of the currently selected combo has been added to the top of the Large Mode combo selectors.
* Large Mode: Enlarged the Secret Combos dialog, the Select Enemy dialog and the Choose Freeform Combo dialog.
* Added a preview pane to the Select Enemy dialog, and fixed some bugs with the pane's choice of 'face' tiles for Gleeok and Aquamentus enemy types. ( _L_, 2009-06-23 04:59:43 )

* ZQuest: Replaced the 'Lost Woods' MIDI with a Zelda piano medley called 'The Travels of Link' that some of you might have already heard at vgmusic.com a few years back - and yes, I received permission from the sequencer, Jeff Glenen. This new MIDI is 32 minutes long, so there's a submenu that lets you choose from 19 individual Zelda songs within the medley. (There are actually more than 19, but the submenu wouldn't fit in Small Mode's screen if I added any more.)
* Large Mode: enlarged the Edit MIDI dialog, the Select/Add Door Combo Set dialog, and the Map Import Bias dialog.
* Added a 'Help' button to the Combo Flag dialog, Room Type dialog and Guy dialog. Press it to get a terse description of the currently selected Combo Flag, Room Type or Guy, so you can learn what exactly 'Block Hole' does, how the '3-Stair Warp' room works or what tile Ama uses.
* Screen Data: Moved the Timed Warp related flags and input boxes to their own tab, so that there is room for an included explanation, and so that nobody confuses them with, say, Room State Carryover. Also moved 'Sideview Gravity' to the first tab, and 'Floating Traps' to the E. Data tab. ( _L_, 2009-06-21 10:35:39 )

* Fixed the ZQuest tooltip crash. It turns out that some combo type names, such as 'Treasure Chest (Locked, Copycat)' were too long for the tooltip bitmap. The bitmap has been expanded.
* Fixed the bug where Gohmas frozen temporarily by a temporary Clock would get their movement routine confused.
* Fixed a few slightly malfunctioning Integrity Checks.
* Amazing ZQuest feature alert: screen integrity errors are now automatically identified and listed in the lower-right of the current screen in Large Mode. These include most of the errors that the Integrity Check quest report diagnoses. Outright mistakes (such as not setting a Guy for a particular Room Type) are printed in red, whereas suspicious behaviour of unknown intent (such as setting the Special Item to item 0) is printed in innoculous grey. ( _L_, 2009-06-19 10:45:58 )



Build 1010 - macosx-Leopard
* Fixed the bug where the continue screen was wrong if Link tile-warped to a 'Do Not Continue' screen soon after starting the game.
* Fixed the bug where if Link, when 'restarting the level' (Wallmaster, Wind Wizzrobe, Farore's Wind), was sent back to a different DMap then the current one, then the DMap palettes wouldn't change during a subsequent inter-DMap scrolling warp.
* Screen Data: Moved the 'Invisible Enemies' checkbox to the E. Flags tab.
* Added a brief descriptive caption to the Maze Path dialog, as well as some confirmative warning dialogs.
* Changed the default Farore's Wind sound effect... again?! (But this time it's more like what I want. I think.) ( _L_, 2009-06-16 18:58:53 )

* Fixed the bug where constant-moving Traps would sporadically use their Special Tile unwantedly.
* Seemingly fixed the bug where using a script to set a Patra core's HP to 0 wouldn't kill the flyers as well.
* Added to the Default submenu: Items (which is now separate from Sprites) and Enemies.
* Removed '<Slide-Proof>' from the names of the Zora, Boulder and Rock enemies.
* Default Template: fixed the bug where one of the combos in the default room 0x80 was wrong.
* Default Template: fixed the bug where the Ladder 1 item's name was 'Ladder' instead of 'Ladder 1'.
* Fixed the bug where a Side Warp Passageway would use the screen's Tile Warp destination instead of the Side Warp destination. ( _L_, 2009-06-08 10:49:07 )



Build 1008 - windows
* Fixed the bug where coloured string text wasn't being coloured correctly in the String Editor preview pane.
* Fixed the bug where Link would re-enter Cave combos and such as soon as he exited or appeared on them, if they were on the top row of the screen.
* Fixed the bug where Link would be able to prematurely exit the fairy circle animation if a string was still visible on-screen. ( _L_, 2009-05-29 03:54:27 )



Build 1007 - macosx-Leopard
* Fixed the bug where the 'Messages Can Be Bypassed With The B Button' rule wasn't working correctly with the most recent string format.
* ZScript: division and modulo has been sanitised against divide-by-zero crashes. Now if a division-by-zero operation is performed, an error will be sent to Allegro.log and the arbitrary value of 0 will be returned. Make sure you don't divide something by zero on purpose, though.
* Fixed the bug where certain item classes had a mislabeled Action Sound.
* Fixed the bug where the Super Quake Scroll's Action Sound wasn't being used. ( _L_, 2009-05-18 02:52:16 )

* The clouds part, an angelic choir sings, and down from the heavens comes the feature we've all been waiting for: the ability to click and drag FFCs in ZQuest. Just click on them with the standard cursor and drag them wherever you want! The only downside is that you have to move an FFC aside if you want to change the underlying combo beneath it.
* Hopefully fixed the bug where non-Darknut walking enemies would use their Special Tile wrongly, and also fixed the bug where enemies with the '3-Frame' animation would actually use four-directional tiles.
* Added the new '3-Frame 4-Dir' animation type. I would like to remind everyone now that the '3-Frame' animation is actually quite similar to the 4-Frame animation. It runs thus: 1->2->3->2->repeat. If any of you have 4-Frame animations where panels 2 and 4 are the same, consider converting to 3-Frame animation for the extra tilespace efficiency.
* Fixed the bug where the 'Learn Slash' and '1/2 Magic Upgrade' screens would endlessly play a sound effect, and the recurring bug with the 'Door Repair' room type.
* ZScript: changed Game->GetMIDI() - now, custom MIDIs are numbered from 1 upward instead of 7 upward, for compatability with Game->PlayMIDI().
* Fixed the bug where default Wizzrobes in pre-Enemy Editor quests had a Misc. Attribute 5 of 0 instead of 74.
* Level 4 Cheats: added the option to show the names of FFC scripts currently being executed. Use it to see if your FFC is carrying over, or the script is exiting at the right time, or somesuch. ( _L_, 2009-05-10 01:58:34 )



Build 1005 - linux
* [ZCL] Small bug in the interface I had to fix :P ( Sean, 2009-05-04 12:52:16 )



Build 1004 - windows
* [ZCL] Fixed a bug with scaling option not working. (Windows only issue) ( Sean, 2009-05-04 12:21:46 )

* The non-numpad +/- now change CSet when editing and grabbing a tile./r/n * Link's charge and jump sprites are now moved when pressing 'M' in the tilepage./r/n * The 'Select Enemies' dialog is now enlarged slightly, and the "copy" indicator positioned correctly in large mode./r/n ( Joe123, 2009-05-04 04:51:14 )



Build 1002 - linux , windows


Build 1001 - macosx-Leopard
* Now that we have reached the COMPLETELY ARBITRARY milestone of 1,000 source code updates since the equally arbitrary time of January 2007, I would just like to take the time to thank testers who've written clear & exact bug reports, testers who've helped find crashes within hours of the new build, testers who've taken the time to make versatile and thorough testing quests, testers who've pointed out my mistakes when I've been wrong in diagnosis, testers who've made certain that even the simplest bug has been genuinely fixed, testers who've been patient but firm when a bug goes unchecked for months, testers-
* What?
* What do you mean, this isn't revision 1000?
* Really?
* By how many minutes?
* Gosh. What're the odds, eh?
* .........
* ...Well, um, nevermind then. Forget it. Don't mind me. Carry on. ( _L_, 2009-05-02 04:31:47 )



Build 1000 - windows
* The normal +/- keys now function on the tilepage, for laptop users.
* The Misc[] values are no longer truncated to integers.
* ffc->Misc[] values are now retained for Carryover ffcs changing screen.
* Added Game->GetMIDI to ZScript.
* Build 1000 is upon us! ( Joe123, 2009-05-02 04:05:23 )

* Fixed the bug where the quest file wasn't marked as unsaved when you pasted a CSet in the Palette Editor.
* Fixed the bug where, with NES movement enabled, using a script to slightly shift Link perpendicular to his facing direction wouldn't work.
* Fixed the bug where, if a Fairy combo flag's heart circle animation was interrupted, it wouldn't be disposed of afterward.
* Renamed the 'Heart Ring' Quest Rules to use the name 'Heart Circle'.
* Game event logging: the 'Screen Secrets triggered' event now signifies if secrets were triggered by Enemies->Secret or the Secrets screen state.
* Fixed the bug where stepping onto a Raft Path combo flag while using the Walk Through Walls cheat would cause unintended rafting.
* Fixed the bug where the Flippers wouldn't be properly disabled by DMap Item Disabling.
* Added several extra debugging level 4 cheats to the Cheat menu. These include the ability to show and hide layers (including ZScript primitives) and sprites, and the ability to turn on and off lighting in the screen. Also, some other menu items have been shifted to the Refill submenu.
* Removed the enemy animation types 'Slow Flip' and 'Slow 2-Frame' because they're redundant and also buggy. Affected enemies will be updated to use 'Flip' or '2-Frame' and have their Frame Rate values doubled. (This fixes the Fairy guy animation bug as well.)
* Also removed '4-Frame 3-Trap', 'Pols Voice', and 'Darknut (New)', relegating their combined functionality into '4-Frame 4-Dir'. As a result, Pols Voices now use their Special Tile for their leaping animation, rather than just their usual tile plus 20, and Traps now use their Special Tile for something rather than just their usual tile plus 20 (but only when they were placed by the 'Middle Traps' Screen Flag).
* Also, the enemy animation dropdown menu in the Enemy Editor is now alphabetically sorted. Good!
* Fixed the bug where Link couldn't walk a Maze Path direction that happened to lead outside of the DMap's bounds. ( _L_, 2009-05-02 03:28:45 )



Build 998 - linux , windows
* ZCL Release only ( Sean, 2009-04-29 10:26:34 )



Build 997 - linux
* This version of ZC was built on svn 990
* This is the last ZCL 2.5 release for linux. Windows Version coming soon
* I made this build so Majora would stop whining :P ( Sean, 2009-04-27 19:35:42 )

* New Quest Rule: 'Things That Remove Sword Jinxes Also Remove Item Jinxes'. It applies to Potions, Triforces, and Fairy combo flags. This is set for all new created quests from now on.
* Moved the 'No Position Offset for Screen Items' rule to the 'NES Fixes' category.
* Fixed the bug where Link's shadow wasn't visible while the screen was scrolling.
* Fixed the bug where a Patra's Misc. Attribute 5 interfered with the creation of the inner eyes.
* Fixed the bug where oval-type Patras' inner rings weren't using the oval pattern.
* Fixed the bug/crash where an enemy that splits into itself wouldn't continue to split into itself. ( _L_, 2009-04-24 02:40:27 )

* The bug where strings were stored backward in ZScript should be fixed by now ( jman2050, 2009-04-21 11:15:10 )

* I noticed that the Quest Rule 'Slow Enemy Animation' only has the effect of internally doubling each enemy's Frame Rate. So, it is done away with, and affected quests will be updated.
* Fixed: the Frame Rate value no longer affects a teleporting Wizzrobe in any way.
* Because someone asked for it: the teleporting Wizzrobe's Misc. Attribute 5 now controls the amount of frames duration between its disappearing from the screen and its reappearing elsewhere in the screen. Default is 74. Minimum is 0. Maximum is 1200, which is 20 seconds - a number I chose myself.
* Fixed the bug where non-Zora enemies with the 'Zora (New)' animation type had incorrect preview tiles in the Enemies dialog. ( _L_, 2009-04-19 07:54:13 )

* Fixed the whistle Warp Ring inconsistency in proposed2nd.qst, and added a missing walk-through wall in level 9.
* Fixed the bug where having a Super Bomb Ratio of 0 would cause division-by-zero crashes.
* Fixed the bug where "Secret Money" Room Types could be used repeatedly if they weren't in a Cave screen. ( _L_, 2009-04-15 10:54:08 )

* Fixed the bug where the Door Repair rooms' fee was being charged repeatedly each frame.
* Fixed the bug where rafting between screens into non-walkable water didn't work with Smart Screen Scrolling.
* Seemingly fixed the bug where the Sword Beam Trigger combo flags couldn't be triggered by higher-leveled sword beams.
* Fixed the bug where the Game Icons dialog had improperly scaled sprites in Small Mode.
* Hopefully fixed the bug where getting items that increased maximum Bomb capacity didn't also affect Super Bomb capacity.
* Also fixed the bug where More Bombs rooms ignored the current Super Bomb Ratio and assumed it was 4. ( _L_, 2009-04-08 10:53:57 )



Build 987 - windows
* Just testing a new upload. ( DarkNation, 2009-04-05 18:23:36 )

* Fixed the bug where the Wand's slash hitbox was vertically wider than the Sword's.
* Fixed the bug where pressing the Sword's button while slashing with the Wand would prolong the Wand's animation.
* Fixed the bug where the DMap flag 'Use Caves Instead of Item Cellars' prevented the use of Passageway warps.
* ZQuest: Fixed the bug where the Link Sprites dialog's tile selectors' clickable areas weren't quite the right size.
* Zscript.txt: Added to the X, Y and Z descriptions a note that float values passed to them are cast to int. ( _L_, 2009-03-28 11:09:41 )



Build 984 - windows
* ZCL Release ( Sean, 2009-03-26 18:05:59 )



Build 982 - windows
* The Misc[] values actually work now, I'd forgotten to initialise them.
* Added the 'VBound' function to std.zh.
* Documented Game->PlayMIDI and w->Behind. ( Joe123, 2009-03-21 07:55:46 )

* Ellipse no longer occasionally fills the exterior instead of interior of the ellipse. ( DarkDragon, 2009-03-18 17:45:42 )



Build 980 - windows
* Fixed the bug where guy fires wouldn't animate with the new enemy tile srule checked
* Fixed a few instances in ZQuest where the screen wouldn't update while manipulating GUI elements.
* Added quest rule which, when checked, removes the slight vertical offset of items placed in rooms, among other places
* Fixed up the init/cheat menu so that map/compass/key values and flags can be manipulated for level numbers up to 511.
* Fixed the bug where Link wouldn't exit water going upwards if the top half of the above tile was solid, regardless of whether the bottom half wasn't. This obviously only refers to standard Link collision.
* Fixed a bug where joypad input wouldn't disable the matrix screensaver.
* Applied two fixes to proposed1st.qst. Thanks AmazingAmpheros!
* Fixed the default Zelda 3 subscreen template. Now the subscreen will look and function properly in a fresh new quest. Obviously, if you're using your own tileset you will have to change the tile references of some subscreen elements.
* Fixed a semi-major memory leak in the script compiler.
* Fixed some bugs involving the hotspot of the fill tool cursor in the tile editor. It should now work properly.
* As always, back up your quests and save files! ( jman2050, 2009-03-18 13:38:59 )



Build 979 - windows
* The selected item tile graphic is no longer distorted in small mode

* The lweapon, eweapon, item, ffc and npc objects in ZScript now each have a miscellaneous array of 8 integers which you can use in your scripts. These are similar to the 'Screen->D[]' variables, but they are not saved with the file.
* New build. ( Joe123, 2009-03-17 16:03:10 )

* Compiling scripts twice no longer crashes ZQ. ( DarkDragon, 2009-03-16 21:20:10 )

* The Vire and Rope animation types no longer show the wrong tile in the enemy selection dialog
* Moved the 'Output ASM Script to Allegro.log' checkbox so it's no longer on top of the 'OK' button in small mode.
* Added the 'Screen->LayerScreen' and 'Screen->LayerMap' commands to ZScript. ( Joe123, 2009-03-15 12:53:33 )



Build 976 - windows
* New build. Back up your quests, all normal caveats apply, yadda yadda. Some important steps have been made in the game's development, and the release of 2.5 looks closer than it ever has. The support of everyone is appreciated by all the developers. ( jman2050, 2009-03-14 20:59:19 )

* Fixed the bug where Moldorms were not using the assigned tiles.
* Fixed the bug where the fill tool cursor would jump during its first use in the tile editor.
* Fixed the bug where the move tool in the tile editor would make the tile slide erratically in large mode.
* Added keyboard shortcuts for the tile and combo editors ('t' and 'k', respectively).
* The '/', '*', '-', and '+' keyboard keys now work like their keypad counterparts (for people without a keypad) in ZQuest.
* The keyboard repeat delay and repeat rate in ZQuest are now customizable. Set them to 0 to turn off key repetition (typewriter mode). ( DarkNation, 2009-03-14 20:36:28 )

* Fixed a pretty bad memory leak in the combo code that caused the memory usage of ZQ to increase while idling on the combo page. This is likely the source of the random crashing.
* Preliminary recoding of the ZQuest rendering code has netted a substantial increase in overall response and speed of the program, especially in dialog boxes and the like. Will do further testing before making a release.
* Fixed bug where pressing space on the combo pages would result in spaces between each combo.
* Fixed a bug where right clicking on a tile in the tile selector would point to a different tile than the one intended.
* Fixed a bug where inserting new combos into the combo page corrupted the combo buffer memory. ( jman2050, 2009-03-14 17:56:49 )

* Doing nothing while viewing the combo table no longer leaks memory and crashes. ( DarkDragon, 2009-03-14 11:59:22 )



Build 971 - windows
* Whoops there was a bug in the setup wizard which would not let ZCL setup correctly. Sorry about that. Must of missed it. ( Sean, 2009-03-12 20:55:00 )



Build 970 - windows
* This new build release is just ZCL only. ( Sean, 2009-03-12 20:36:13 )

* [ZCL] Minor Interface Fixes
* [ZCL] When an error occurs it now fails gracefully. This means it shouldn't give you that corruption message.
* [ZCL] ZCL now supports multiple versions of ZC from 1.92 to current. This is new so expect bugs.
* [NOTE] For all ZCL testers. Please make sure you extensively test this version of ZCL. There was a lot of core rewriting again due to the multi zc support. So please report the bugs! ( Sean, 2009-03-12 20:34:48 )

* ZQ no longer crashes when you create a new quest and click "Zelda 3-esque." ( DarkDragon, 2009-03-11 17:42:53 )



Build 967 - windows
* Shortened the ZQuest key delay. I'll probably make it changable in the config file or something later on
* Hopefully fixed the screen data dialog box. The lesson? If you want to experiment with the code, don't leave your changes in when things don't work! ( jman2050, 2009-03-10 09:46:36 )



Build 966 - windows
* New build to apply _L_'s fixes to the Screen Data dialog since that bug kind of sucks
* Also reverted romview. Sorry about that! ( jman2050, 2009-03-10 07:40:56 )

* Fixed the bug where the Screen Data dialog was invisible! We're all sorry about that.
* Fixed the bug where the 'Layer 2 is Background' and 'Layer 3 is Background' Screen Flags weren't being honoured in ZQuest's screen edge previews. ( _L_, 2009-03-10 00:20:50 )



Build 964 - windows
* Seems like the latest changes broke ZCL. Well I recompiled ZCL and now this would be the correct release to use. Still gots me wondering. Who broke my program :( ( Sean, 2009-03-09 19:52:06 )



Build 963 - windows
* Lots of stuff here. First off, the quest format was changed slightly, so double, triple, and quadruple check that quest integrity isn't compromised. BACK UP YOUR QUESTS as always.
* Added 4 new key/button assignments to the ZC engine. These are defaulted to q, w, a and s on the keyboard and can be changed just like any other button. They don't actually do anything by default, but they can be accessed in scripts just like any other key/button.
* Speaking of input, there are now INPUTPRESSx variables which, for each button, is set ONLY on the frame where a particular button is actually pressed. Should be useful to those planning custom actions.
* Fixed the "memory exhausted" compile-time bug that occurs when making large global arrays.
* Fixed a fatal memory corruption bug relating to tooltips that may be responsible for the rampant crashing in Zquest.
* Fixed the bug where initialized global arrays would bork when starting a quest that has already been saved. Due to the method of this fix, a new global script slot is being introduced: The Continue script. This runs at the same point as the Init script does, but will run EVERY time a quest is started or continued, not just on a new save file as with the Init script. As an extra bonus, just as with the Init script, naming a global script "Continue" will append the user-made code to the generated Continue script.
* A small input delay has been added to ZQuest to allay the phenomenon where ZQuest would lag behind the input buffer. In other words, holding shift+page down to scroll through combos won't continue scrolling long after you've let go of the keys. Of course, the timing is experimental, so if you think it's too sluggish, it can be changed easily. ( jman2050, 2009-03-09 18:13:20 )



Build 962 - windows
* DO NOT USE OR DOWNLOAD BUILDS 961 OR 962! ( DarkNation, 2009-03-09 17:13:33 )



Build 961 - windows
* Fixed a bug where BS Dodongos could randomly spawn inside 1-combo spaces, causing them to be unmoving and drawn incorrectly.
* Fixed a bug where init data wouldn't be kept on tabs other than the current one.
* Fixed a bug where some custom sfx names were reset after going into the tile grabber.
* Fixed a bug where some item names were reset after going into the tile grabber.
* Fixed a bug where some weapon names were reset after going into the tile grabber.
* Fixed a bug where some tile windows in large mode were 1 pixel too small in the x and y directions.
* Fixed a bug where the "First Enemy Carries Screen Item" screen flag wasn't showing up in the editor.
* Fixed a bug where enemy screen flags would be reset if the screen data window was closed on a different tab.
* Fixed the bug where the Next Message dropdown text was partially cut off. ( DarkNation, 2009-03-09 16:14:14 )

* Init Data: Moved the Keys and Rupees boxes from the Misc tab to the Items tab, where they belong.
* ZScript: Fixed the bug where EW_BOMB weapons were being created instead of EW_BOMBBLAST weapons.
* Fixed the bug where projectiles created by Prism combos didn't have valid parent item IDs, potentially causing crashes.
* Fixed the bug where you could walk out of a Candle or Byrna slash before it finished.
* Also fixed the bug where a Candle or Byrna slash didn't display Link's stab sprite. ( _L_, 2009-03-09 03:43:32 )

* Fixed the bug where having the Wavy and Quake effects occur at the same time would result in a crash. ( _L_, 2009-03-02 20:20:31 )

* ZScript: added Screen->Lit, a simple boolean variable pertaining to whether this room is dark or not. Setting it will darken or brighten the room.
* Fixed the bug where the enemy->ID of an NPC_ITEMFAIRY was about 4096 larger than what it ought to be.
* Also, setting enemy->ID will now do nothing, for safety purposes.
* Fixed the bug where setting a Screen->Door[] value to D_OPEN wouldn't do anything.
* Removed the Enemy Flags menu item, now that its purpose is done.
* Now, clicking the 'Flags' button in the Enemy dialog will take you directly to the E. Flags tab in Screen Data.
* The checkbox labels for the 'Zora', 'Corner Traps', 'Middle Traps', 'Falling Rocks' and 'Statues Shoot Fireballs' enemy flags now also display the name of the enemy that has the matching checkbox in its enemy data.
* Large Mode: enlarged the Enemy Pattern dialog, changed the Random pattern's name to Spawn, and added some short explanatory text. ( _L_, 2009-02-23 19:18:41 )

* For personal reasons, Lanmolas now obey gravity, and can fall. Incidentally - if their segments should become vertically separated when one walks off an edge in Sideview, don't necessarily consider it a bug.
* Large Mode: enlarged the Link Sprites dialog, the Misc Colors dialog, the Compile ZScript dialog, and the Doors dialog.
* Also, the buttons in the Doors dialog now display the currently selected door for that direction.
* ZScript: Recanted the recent entirely well-meaning change to Screen->ComboS[], on the basis that it might break backwards-compatability with some prior scripts.
* ZScript: added Screen->IsSolid(int x, int y), which returns true if the coordinate position is treated as solid by ZC (referring, of course, to combos on layers 0, 1 and 2). Since it uses in-engine methods to identify solidity, it should be ideal for the sort of situation where you need to call it 1,024 times per frame. ( _L_, 2009-02-19 20:14:58 )



Build 956 - windows
* Forgot to add in one of the ZScript parser files a few builds ago, so some of the things I added were crashing the compiler. Sorry about that. They're not now. ( Joe123, 2009-02-19 04:12:05 )



Build 955 - windows
* The enemy flags dialog has moved to 'Screen Data'.
* ComboS now checks solidity on layers one and two, as well as layer zero.
* New build
* Hopefully this one won't corrupt everyone's quests... ( Joe123, 2009-02-19 03:39:40 )

* Fixed the bug where custom open door types were being overwritten in the game engine.
* Link's swim speed it now selectable in the quest editor (slow or fast).
* Tooltips in ZQuest can now be turned off in options. ( DarkNation, 2009-02-16 19:34:27 )

* Added the 'Ln' command to ZScript, for the sake of practise/completeness.
* Added the 'InputMap' variable to ZScript ( Joe123, 2009-02-15 06:31:27 )

* Added the Log10 function to ZScript. ( Joe123, 2009-02-14 11:59:50 )

* Moved the 'Message More Y is Offset' check box down in the large mode dialog/r/n
* Fixed my change to the code so that an enemy's down facing sprite actually is shown in the enemy selection dialog. ( Joe123, 2009-02-14 08:40:50 )

* ZScript: Fixed the bug where the pointer returned by Screen->CreateNPC() pointed to the last segment of a boss rather than the boss itself.
* Added to std.zh the function NumNPCsOf(int type), which might be useful.
* Fixed a subsequent, and possibly final, bug with the implementation of Screen->D[] that caused adjacent DMaps' variables to overlap.
* Improved the weapon sound effect disposal routine. Now, boomerangs and such should have their looping sounds disposed at the right occasions.
* Fixed the bug where setting Screen->Door[] to D_SHUTTER before scrolling onto the screen wouldn't result in the proper shutter-closing animation. ( _L_, 2009-02-12 05:48:33 )

* ZScript: Added the variable item->Pickup, which determines what happens when Link picks up the item. It determines whether Link holds up the item when collecting it, whether the item vanishes after awhile and whether melee weapons can collect it, whether an enemy is carrying the item, and what Screen States are set when the item is picked up.
* Fixed the bug where scrolling into a screen onto a warp combo prevented that warp combo from triggering. ( _L_, 2009-02-08 00:42:34 )

* ZScript feature: Screen->Message(0) now makes the currently displayed message disappear, even if your quest doesn't have the 'Messages Disappear' rule checked. This also removes the 'invisible Guy wall' that 'Feed The Goriya' and other such Room Types have.
* Now, when a DMap Intro message is being displayed, the effects of Screen->Message() calls are delayed until after the DMap Intro message has been dismissed. At that point, only the most recent Screen->Message() call will be used. ( _L_, 2009-02-05 02:46:18 )

* ZScript: added the bitwise NOT, which is represented by the tilde '~'. If you have been trying to use the bitwise NOT prior to now, rest assured that it was actually equivalent to the logical NOT. (Also, the ZASM command is BITNOT).
* Fixed the bug where a screen's and DMap's palette selection was being saved as a byte instead of a word.
* ZScript: a warning is now logged to Allegro.log when you try to reference a Screen->D[] value outside of the 0-7 range.
* Now, the 'Visited' Screen State is no longer logged in Allegro.log as '<Unknown>'. ( _L_, 2009-02-04 22:49:29 )



Build 946 - linux , windows
* New ZCL Builds for windows and linux. Also this is a good time to try the updater feature in ZCL. :) ( Sean, 2009-02-02 12:12:43 )

* [ZCL] Minor Interface Fixes
* [ZCL] Updater shows the wget console. This is so you guys know it's actually doing something :P
* [ZCL] Oh look icons on the tabs.
* [ZCL] Interface improvements
* [ZCL-LINUIX] Using the GTK2 Interface again
* [ZCL Updater] Handles errors better
* [ZCL Updater] Checks to make sure you have a connection
* [ZCL Updater] Interface improvements
* [ZCL] Added 800x600 in ZC Resolution Tab ( Sean, 2009-02-02 11:04:44 )



Build 944 - linux , windows
* [ZCL] Removed ZSCRIPT (Source code will be released to public soon)
* [ZCL] Core Optimizations
* [ZCL] ZCL for Linux will be using GTK until Lazarus becomes more stable with GTK2 sorry people =/
* [ZCL] New Logo
* [ZCL] Updater Feature implemented - On the first download of the alphas please click on the updater feature so it can configure itself. This is a very new feature so if you spot any bugs please immediately report them. ( Sean, 2009-02-01 16:38:14 )

* ZScript: Added Game->GetCurLevel(), which tells you the dungeon level of the current DMap. It works great as an index into Game->LItems[]!
* Fixed a bug where if an item is, by being collected, upgraded into a new item with a pickup script, then the pickup script will use the new item's script number but the old item's arguments. (Now, it will use the new item's arguments.)
* Fixed the bugs where certain ZQuest tile preview panels were slightly smaller than they ought.
* Fixed a bug where 'Paste Spec. -> Screen Data' would also paste the Side Warp trigger settings.
* Also, 'Paste Spec. -> Warps' now pastes the status of the 'Combos Carry Over' checkbox as well.
* Fixed a bug where it was possible in Sideview to fall into screen 0x80 from screen 0x70, crashing ZC! ( _L_, 2009-01-29 09:34:34 )

* ZScript: Fixed a bug that made various events, such as setting Link->Item[] or using the level 4 cheat, erase certain values in Game->LItems[].
* ZScript: Fixed a potential bug where Screen->D[] might now have worked correctly when used in Overworld DMaps.
* ZScript: Fixed another bug that made Screen->D[x] pointed to not quite the same variable as Game->GetScreenD(Game->GetCurDMap(), x). Now, they are assured to point to the same variable. This also affects the string control code \3\X\X\X (Goto If Screen Variable).
* ZScript: Fixed the bug where setting positive values to weapon->Jump and item->Jump actually resulted in negative values, and vice versa. If you've been unknowingly compensating for this deficiency, please change your code now!
* ZScript: Added the functions Game->GetDMapScreenD() and Game->SetDMapScreenD(), which are like Game->GetScreenD() and Game->SetScreenD(), but allow you to get and set values in other DMaps with minimum fuss!
* Added several more clarificatory notes to Zscript.txt, such as how Screen->D[] differs by DMap, and the difference between Link->Warp() and Link->PitWarp().
* Fixed some potential bugs where getting a screen item or special item via Boomerang or Hookshot (with the 'Boomerang/Hookshot Grabs All Items' quest rule) wouldn't set the appropriate Screen State.
* ZQuest: As you know, water combos only function on layer 0. So, water combos on layers 1 and 2 no longer show up blue when you press the 'w' key to show walkability.
* Sideview: Now, if Link stands on a solid damage combo as a platform, he will take damage! That's pretty intuitive, isn't it? ( _L_, 2009-01-27 01:56:30 )

* Fixed a bug where 3-Stair Warp Rings didn't work quite right in non-Overworld DMaps.
* Fixed a bug where setting a positive value to Game->DCounter[CR_MAGIC] that wasn't divisible by 8 would cause it to endlessly empty and fill the magic meter. ( _L_, 2009-01-21 03:24:57 )



Build 935 - windows
* Thought I'd try uploading a new build.
* Added the 'Message More Y is offset' flag to the 'Strings' Dialog. Now, your 'Message More' so as always to be in-line with the string.
* Changed the sprite in the Enemy Selection dialog to show the 'down' facing sprite.
* Moved around some of the boxes in the Enemy Editor dialog, mostly so the whole 'W:' attribute now fits in the box in small mode.
* First proper upload, wish me luck! ( Joe123, 2009-01-14 14:27:44 )

* Added a new feature to Zplayer called BIG2 use it like you are using BIG when you enter in your resolution. There will be a feature added to ZCL to show you what I mean. Example what this does http://sjnetwork.net/big2.jpg ( Sean, 2009-01-14 08:51:56 )

* Renamed the combo flag ' 52 Push Block (Vert, Once, Trigger)' to ' 52 Push Block (Vert, Once)'.
* Moved the hitbox for Link's southward-facing sword stab five pixels downward.
* Fixed the bug where the 'Smooth Vertical Scrolling' rule caused a string to display improperly while scrolling.
* ZScript: fixed the bug where setting Link->Dir (Link's direction) every frame didn't prevent him from firing sword beams perpendicular to this direction. ( _L_, 2009-01-13 03:17:24 )

* Fixed a bug in the Enemie Data Editor. When you edit the name and click cancel. It still applies the new name. ( Sean, 2009-01-10 22:44:58 )



Build 928 - windows
* Fixed a bug that made script-created Bait lweapons vanish as soon as they appeared if Link didn't have a Bait item.
* Now, 'No Enemy' combo flags are treated as solid platforms by walking enemies in sideview. This should be convenient!
* Helpful advisory: if you place a combo flag on a layer, but that combo flag only works on layer 0, you'll be notified that the flag doesn't function on layers 1 and above.
* Changed the 2008 copyright to 2009. Kids, remember what to do when you suddenly feel old: SCREAM REAL LOUD! ( _L_, 2009-01-09 07:41:09 )

* Fixed the bug where Remote Super Bombs didn't work quite right.
* Presumably fixed the bug where the Action Script attached to a Farore's Wind, Din's Fire or Nayru's Love item wouldn't ever run.
* Fixed the sideview bug where jumping upward into a screen ignored the 'Smart Screen Scrolling' quest rule.
* Fixed the sideview bug where falling into the bottommost row of combos in the bottommost row of screens wasn't recognised as a platform. ( _L_, 2009-01-06 05:33:25 )



Build 923 - windows
* New version of ZC for windows. ( Sean, 2009-01-04 11:37:00 )



Build 922 - windows
* New ZCL Release Only
* --Much Cleaner Interface
* --ZCL Zscript Editor
* --Notepad
* --Load Quest On Start
* --New Banner
* --Descriptions for some options you check. This tells you what does what :P
* --Go To Color Scheme and Title Screen has been removed
* --Load SFX.dat has been removed
* I am still accepting requests and also BUG TEST THIS! ( Sean, 2009-01-03 17:19:10 )



Build 921 - macosx-Leopard
* Leopard build. Testing build system. ( Takuya, 2009-01-02 19:35:32 )



Build 919 - macosx-Tiger-and-Leopard
* Sorry about that. I need to talk to DD. Again should run on Leopard... probably not Tiger. Sorry folks. Working on it. Happy New Year. ( Takuya, 2009-01-01 00:00:52 )

* Fixed a bug with an OS X lib on my end. ( Takuya, 2008-12-31 23:54:46 )

* Oops. There should be a new build ( Takuya, 2008-12-31 23:48:09 )

* Placed an upper limit on the wavyness of Screen->Wavy, where values greater than 2048 don't increase the screen's distortion any further.
* Added an Integrity Check for screens that contain Save Point combos, but don't have the 'Use As Save Room' screen flag checked. This may be deliberate, but the most likely intended behaviour is to have the flag checked.
* Fixed the bug where the Boomerang's range was ignored if its weapon sprite had more than one frame of animation specified.
* Fixed the Boomerang's 'Corrected Animation' clip tile bug. To reiterate, the clip tile's location is: tile 54 if 'Corrected Animation' is off, starting tile + frames if 'Corrected Animation' is on, and starting tile + (frames x 8) if both 'Corrected Animation' and 'Directional Tiles' are on. ( _L_, 2008-12-31 20:39:10 )

* Fixed some more mistakes in ZScript.txt.
* Tooltips: the main screen tooltip gives the properties of the pointed combo. It lists all of the properties in the Properties dialog.
* Fixed the bug where an Item Override subscreen item wouldn't be non-visible when a DMap explicitly disabled that item. ( _L_, 2008-12-26 08:42:34 )

* Fixed a bug where too many weapons on the screen would cause the hookshot to freeze the game.
* Fixed a bug where the tile editor would sometimes cause the mouse to not work outside of a certain area on the screen.
* Fixed a bug where certain locked doors in the default template would not work properly.
* Tweaked the new larger tile list window.
* The combo list window is now enlarged as well.
* Preliminary work on the new tooptip system (the code has been in there since build 827, but dormant). ( DarkNation, 2008-12-24 15:13:44 )

* Extended the FFC Editor's D value caps from 32767.0000 to 214748.3647, both positive and negative.
* Now, using the Raft will set your 'drowning return point' at wherever you stop rafting.
* ZScript: Fixed the bug where weapon->Flash was a float instead of a bool.
* The Screen Flag 'All Triggers->16-31' now recognises layered triggers.
* Large Mode: enlarged the Select Tile dialog. It took awhile. ( _L_, 2008-12-22 02:34:30 )

* Sorry for the break in updates... I've had a bad week. The bug where setting out-of-bounds values for a string's Y Position was possible and could crash ZC has been fixed.
* The Item Drop Set editor's item tile panes display the tiles at exactly double resolution now.
* The 'What Links Here' Quest Report now also displays a list of screens that use the current screen as a layer. Nifty! ( _L_, 2008-12-16 07:07:43 )



Build 910 - linux , windows
* [ZCL]Fixed a little color issue when ZCL is running with the windows classic theme
* [ZCL]Fixed another issue that Classic Mode will not save the settings ( Sean, 2008-12-14 08:44:43 )



Build 908 - windows
* Windows version of ZCL ( Sean, 2008-12-09 22:11:27 )



Build 907 - linux
* Finally a ZCL build for Linux Again
* Changed Large checkbox to Use Classic Interface since the Large mode is now the default. This will be updated on the windows version soon. ( Sean, 2008-12-09 21:13:03 )



Build 906 - windows
* New build fixing more critical bugs yay! ( jman2050, 2008-12-09 11:18:03 )

* Fixed the critical bug where the Enemy Rules window was broken. Fin fang foom!
* Fixed the critical bug where an Item Drop Set with all chances set to 0 would cause a 'divide by zero' crash when used.
* Fixed the bug where a charging sword had no collision detection.
* Now, the counter-refilling equipment items no longer refill counters while a message has frozen the action. This has the potential for player abuse! ( _L_, 2008-12-07 00:23:31 )



Build 904 - linux
* Added Linux soundfont. Run zelda-l and zquest-l once and sound should be working if it was not before. ( Takuya, 2008-12-06 13:21:30 )



Build 903 - linux
* My bad.. try now? ( Takuya, 2008-12-05 20:58:16 )

* Testing a Linux build ( Takuya, 2008-12-05 20:55:05 )



Build 901 - windows
* New build to fix the item drops. Sorry for taking so long. As usual, BACK UP ALL QUEST FILES!!! ( jman2050, 2008-12-05 14:27:06 )

* Fixed the bug where the Nothing Chance of an Item Drop Set was being read as an item ID. On behalf of all developers, I apologise for this messup.
* Deprecated the 'Allow 10 Rupee Drops' and 'Enemies Don't Drop Clocks' rules. Quests which had those rules set will simply have their item drop lists modified accordingly.
* Also, the hidden condition where Non-gameplay Items could never be dropped has been removed. Quests which have Non-gameplay Items in their lists will have their drop chances reduced to 0 and the 'Nothing' chance extended accordingly.
* After a moment's introspection, a decision: the rule 'Old Style Warp Detection' now does nothing if diagonal movement is enabled. I believe that nobody who uses diagonal movement genuinely wants OSWD as well, but if anyone can convince me otherwise, I may recant.
* Added a new default item drop set, 'Tall Grass Combos', which is used by all Tall Grass, Bush, and other combos to determine what item appears when they are slashed. This directly replaces item drop set 12, which should be blank... unless you edited it during the last two days. If you did so, please recreate it in another empty item set before using the next build, and accept my fond apologies. ( _L_, 2008-12-03 05:16:51 )



Build 899 - windows
* Just uploading the windows build. BACKUP YOUR QUEST FILES BEFORE USING THIS ON THEM! 3 QUEST FILE CHANGES WERE INTRODUCED IN THIS VERSION. ( DarkNation, 2008-12-01 17:59:44 )

* New item drop set editor. It can be accessed from the Quest menu in the Misc Data submenu.
* Fixed a bug regarding a raft leaving a raft path if the path turns immediately after entering a screen.
* There are now 255 shop and info types and they can now be named.
* The shop editor now displays a picture of each item being sold.
* Tweaked the message string lists so that the numbers line up a bit better when numbers are needed and the numbers don't show when they aren't.
* Item lists (for the item editor and the room item and special item properties) now show the item's tile.
* Renamed the Music menu in the Quest menu to Audio and moved the SFX menu inside of it.
* Shop and Info type names now appear in the room information panel.
* Shop and Info types for a room are now selected from a list instead of a manual-entry number box.
* The minimap preview for the dmap list now also shows the minimap background in small mode instead of just in large mode.
* The warp editor destination screen box can be filled in automatically now by clicking on the appropriate screen in the dmap preview box. ( DarkNation, 2008-12-01 17:53:40 )

* Removed the 'If Possible, Use Slash Tiles' checkbox. Instead, the Sword, Wand, Cane of Byrna and Candle itemclasses now use an item flag, 'Can Slash'. This works for all classes, including Swords, and is backwards-compatable with current quests.
* Tile Editor: Fixed the bug where the focus of the Fill cursor was in the upper-right corner, instead of the tip of the spiliing paint.
* Large Mode: Fixed the bug where the Shop Types and Info Types editors' dropdown menus were broken. My apologies! ( _L_, 2008-11-27 02:25:45 )



Build 896 - macosx-Tiger-and-Leopard
* OS X build includes proposed quests 1 2 and 3 ( Takuya, 2008-11-25 18:35:14 )



Build 895 - macosx-Tiger-and-Leopard
* OS X fullscreen does not work, but should run on Leopard (PPC/Intel), MAYBE Tiger ( Takuya, 2008-11-25 17:31:26 )

* OS X fullscreen does not work, but should run on Leopard (PPC/Intel), MAYBE Tiger ( Takuya, 2008-11-25 17:28:54 )

* Fixed the bug where a DMap's disabled item list was cleared when a certain procedure was called.
* Modernised the Under Combo dialog (such that you now click on the current combo to select a new one), and expanded it in Large Mode.
* Added labels to the Game Icons dialog, and expanded it in Large Mode. ( _L_, 2008-11-22 09:29:21 )

* Rulesets: The following quest rules are ZC engine improvements to ZC-exclusive features, and are now present in all rulesets for future quests: 'Damage Combos Work On Layers 1 and 2', 'Warps Ignore Arrival X/Y Position When Setting Continue Screen', 'Use Warp Return Points Only', 'Combo Cycling On Layers', and 'Must Kill All Bosses To Set 'No Return' Screen State'. It is recommended that all future quest files have these rules set.
* NES Fix Quest Rule: 'Invincible Link Isn't Hurt By Own Fire Weapons'.
* Also, added the 'Use Old Style Warp Detection' rule to the 'Authentic NES' ruleset, and moved the 'No NES Sprite Flicker' rule to the NES Fixes category.
* Fixed the bug where the string control code \5\X\X (Goto If Item) wasn't working for certain item IDs.
* Fixed the bug where reflected magic sent from Magic Prism combos had the wrong HitYOffset value.
* Fixed the bug where you couldn't use the Magic Containers cheat menu option to add extra magic containers. ( _L_, 2008-11-17 06:51:40 )

* The 'Block All' combo type no longer blocks Hookshot handles and chains.
* Forcibly fixed a bug that made Link's retracting stab (that is, frame 15 of the stab animation) slice the Tall Grass combo that Link was standing on. Now, that frame no longer has hit detection.
* Misc. Colors: Renamed 'Dungeon Foreground' to 'Minimap Foreground 1' and 'Cave Foreground' to 'Minimap Foreground 2', as well as some others.
* As you know, if a NES Dungeon DMap had a Level of 0, then ALL of its NES Dungeon features were suppressed! This behaviour is removed, and instead, all previous quests' Level 0 NES Dungeon DMaps are converted to Interior type DMaps, which have completely identical functionality.
* ...Except, of course, for the minimap foreground colour. So, the 'Use Minimap Foreground Color 2' DMap flag has been added. All non-Overworld DMaps use Minimap Foreground 1 unless that flag is set. In prior quests, all normal Interior DMaps will have it set, and all converted level 0 NES Dungeons will have it unset.
* Helpful messages: The Secret Combos dialog now indicates which Layer's Secret Combos are currently being edited. Also, the DMap Editor now tells you that one of the Minimap tile options silently disables the classic NES minimap.
* Rejoice! The 'Trigger->Self' and 'Trigger->Self, Secret Tiles' Combo Flags now work on layers!
* Large Mode: expanded the Warp Rings dialog, the Tile and Side Warps dialog, and the Select DMap dialog.
* Large Mode only: The Select DMap preview box now shows the Minimap tile background in addition to (or instead of) the classic NES Minimap. ( _L_, 2008-11-12 02:08:45 )

* ZScript: sanitised the code for the Screen combo arrays so that out-of-bounds array indices (for instance, getting and setting combo number 176 and above) no longer meltdown the system.
* Repositioned the Hammer's vertical collision box four pixels downward. Or, to put it another way, its lweapon->HitYOffset value is now 4 when swung vertically. ( _L_, 2008-11-06 09:14:34 )

* Fixed the bug where screen SFX weren't being hushed when Link left the screen via certain whirlwinds.
* Added some sanity checks to the combo flag secret-triggering code, to prevent chaos from ensuing when a weapon passed through the upper-left corner of the screen.
* Made a fix to the aforementioned Goriya tile flip compatability fix. Now, it won't be applied if the 'Use New Enemy Tiles' rule was in effect. ( _L_, 2008-11-02 08:38:40 )

* ZScript: If a Like Like or Wallmaster is holding Link and is moved by a script, then Link will also be moved.
* Large Mode: expanded the 'Assign Compiled Script' dialog.
* Added a checkbox, 'Output ZASM code to allegro.log', to the Assign Compiled Script dialog. If unchecked, then the resulting ZASM code from the compilation process will not be output to allegro.log when assigned to script slots. If your quest uses startlingly large numbers of scripts, then this should reduce compile times by about 40%.
* Change of plans: setting an LW_HOOKSHOT's DeadState to WDS_BOUNCE multiple times will no longer continually negate the lweapon's Step. Rather, it will remain negative if it is already so.
* Fixed a bug where previously deleted characters in a message string were sometimes being printed in-game.
* Added some more IC_ and I_ constants to std.zh. ( _L_, 2008-10-29 01:54:30 )



Build 887 - windows
* Changed the blinking and transparent Ghini quest rules into enemy flags that can be used by all enemies.
* All enemies now respect the 'is flashing' enemy flag, not just Bubbles and Rope 2's.
* Removed the obsolete "Link Slash" misc weapon sprite.
* Fixed the bug where the descenders of letters in certain text objects in large mode were being clipped.
* Added two new non-keyboard letter grid name entry modes for the save slot screen. These are accessible from the Settings Menu.
* Moved the "Key Buttons", "Key Directions" and "Joystick/Gamepad" menus to a "Controls" submenu.
* The "Corrected Animation" and "Directional Sprites" item flags now work for boomerangs. The sequence for the tiles used by the "Corrected Animation" flag are up, down, left, right, up-left, up-right, down-left, and down-right. If the "Corrected Animation" flag is checked, the edge-of-screen clipping spark is pulled from the tile following the list of tiles used in the animation instead of from tile 54. That way, each boomerang can have its own clip spark.
* Fixed a bug where the sprites would not show up when the test button was pressed in the item editor. ( DarkNation, 2008-10-25 15:45:25 )

* ZScript: the LW_HOOKSHOT lweapon's Dir now remains the same even when it's retracting. To tell if it's retracting, know that, instead, its Step becomes negative. Also note that now, setting DeadState to WDS_BOUNCE multiple times will negate its Step each time.
* Fixed the bug where the Tile Editor's Fill cursor jumps position when used.
* Fixed the bug where the Combo Flag cursor becomes invisible when changing screens with Combo Brush enabled. ( _L_, 2008-10-25 03:07:10 )



Build 885 - windows
* Fixed a crippling save game bug that would most certainly kill any save files you're currently using. But that's not so bad because you all back up your quests and save files before every beta, right? .....right?
* As usual, it's _L_'s fault :P ( jman2050, 2008-10-23 19:10:17 )



Build 884 - windows
* Fixed the bug where using assignment operators on arrays crashed the compiler.
* Fixed a brutal quest corruption bug that occured if you created a zero-length text object in a subscreen.
* Fixed the bug where clicking on the grid in the misc colors menu for "Message Text" crashed the program
* New build for you guys! ( jman2050, 2008-10-23 13:24:12 )

* Fixed the Small Mode Enemy Editor dropdown menus.
* Fixed the bug where the Wealth Medal messed up the displayed pricing of the 'Leave Life or Money' Room Type.
* Added an option checkbox enabling/disabling the aforementioned Rulesets dialog. ( _L_, 2008-10-23 08:05:36 )

* Fixed the bug where Link couldn't warp while a message was being typed out, even if the 'Messages Freeze All Action' rule was not set.
* Fixed the bug where whirlwinds reflected off magic mirror combos weren't properly disposed of, causing sound effects problems.
* ZQuest: Fixed the long-standing bug where the door in a left screen edge preview was incorrect.
* Fixed the bug where Link grabbing an item that must be held up, while being propelled by the hookshot, caused him to freeze. ( _L_, 2008-10-16 01:09:37 )

* Seemingly fixed the bug where Tektites, Vires and Pols Voice enemies couldn't have their Y modified if the 'Enemies Move Through Z-Axis' rule was set.
* Now, the 'Nayru's Love' item family uses left and right rocket sprites, the latter of which already exist in the Default Template. Also, the shield sprites can now be changed for each Nayru's Love item.
* Spell rockets are no longer blocked by 'Block All' combos.
* Slightly tweaked the hitbox for Link's sword slash, to make it more closely overlap the sprite itself.
* Also, the LW_SWORD, LW_WAND and LW_HAMMER lweapons now have correct hit detection and combo detection when they're moved away from Link with a script. Telekinesis! ( _L_, 2008-10-14 19:03:03 )

* Save file bug: Only 64 Screen->D[] variables existed per DMap, even though Overworld DMaps can have 128 screens. This is fixed.
* Fixed the bug where Screen->State[] would sometimes not produce the correct values in non-Overworld DMaps.
* Fixed the bug where Link wasn't properly adhered to the grid when walking down a 'Cave (Walk Down)' combo. ( _L_, 2008-10-10 09:16:19 )

* The 'Screen Enemies' dialog now contains a preview tile showing the Tile or E. Tile of the currently selected enemy in the list.
